{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ GodFather's DIALOGS UNIT Version 1.001 }
{ Copyright (C) 1996 By The GodFather }

UNIT GDialogs;



INTERFACE



USES GUtils, GMemory;



TYPE
  TBtnTypes       = (btDefault,btNormal,btCancel);

  TInputLineKinds = (ilNormal,
                     ilLower,ilUpper,ilProperNorm,ilProperFull,
                     ilFileName,
                     ilPassword,
                     ilNumeric);

  TFieldType      = (ftTxtInputLine,
                     ftNumInputLine,
                     ftStaticText,
                     ftComboBox,
                     ftCheckBoxes,
                     ftRadioButtons,
                     ftButtons);

  TDialogPallettes= (DefaultDialogPAL,WarningDialogPAL,BlueDialogPAL);

  TDialogPALRecs  = (_DialogBack,
                     _DialogTitle,
                     _DialogComments,
                     _DialogCommentsHighlight,

                     _InputLineNormal,
                     _InputLineHighLight,

                     _ComboBoxLine,
                     _ComboBoxArrow,
                     _ComboBoxWinAttr,
                     _ComboBoxListNormal,
                     _ComboBoxListHiLight,
                     _ComboBoxFastFind,
                     _ComboBoxOldChoice,

                     _CheckBoxNormal,
                     _CheckBoxHighlight,
                     _CheckBoxSelectedNormal,
                     _CheckBoxSelectedHighlight,
                     _DisabledCheckBox,

                     _RadioBtnNormal,
                     _RadioBtnHighlight,
                     _RadioBtnSelectedNormal,
                     _RadioBtnSelectedHighlight,
                     _DisabledRadioBtn,

                     _ButtonNormal,
                     _ButtonHighlight,
                     _ButtonSelectedNormal,
                     _ButtonSelectedHighlight,
                     _ButtonDefaultNormal,
                     _ButtonDefaultHighlight,
                     _DisabledButton,
                     _ButtonShadow );


  { ----------------------------------------------------------------------- }
  { --------------------------- PStrARRAY OBJECT -------------------------- }
  { ----------------------------------------------------------------------- }
  PStrARRAY = ^TStrARRAY;
  TStrARRAY = OBJECT
    Count: Byte;
    Data: ARRAY[1..255] OF PString;

    FUNCTION GetStr(Num: Byte): STRING;
    PROCEDURE AddStr(AStr: STRING);
    CONSTRUCTOR Init;
    DESTRUCTOR Done;                                                 VIRTUAL;
  END;

  { ----------------------------------------------------------------------- }
  { ---------------------------- BASE OBJECTS ----------------------------- }
  { ----------------------------------------------------------------------- }
  PBaseItem  = ^TBaseItem;
  TBaseItem  = OBJECT(TObject)
    Name     : PString;
    HotKey   : Word;
    Active   : Boolean;
    XPos,YPos: Byte;
    btnType  : TBtnTypes;
    CONSTRUCTOR Init(ABaseItemName:STRING; AHotKey:Word; AXPos,AYPos:Byte);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PBaseOBJ = ^TBaseOBJ;
  TBaseOBJ = OBJECT(TCollection)
    InVAR     : ^Word;
    CurrentPos: Byte;
    XPos,YPos : Byte;
    Width     : Byte;
    ExitKey   : Word;
    Tmp1      : Byte;
    Tmp2      : Byte;
    ItIsButton: Boolean;
    TabAllowed: Boolean;
    FUNCTION  KeyOK(Key: Word): Boolean;
    FUNCTION  GetActive(BaseItemNUM:Byte): Boolean;
    FUNCTION  CheckKey(Key:Word; AltKey:Boolean): Byte;
    PROCEDURE SetActive(BaseItemNUM:Byte; AActive:Boolean);
    PROCEDURE Add(ABaseItemName:STRING; AHotKey:Word);
    PROCEDURE ProcessKeys(VAR Key: Word);
    PROCEDURE DrawALL(MarkCurrent: Boolean);

    PROCEDURE DrawONE(BaseItemNUM:Byte);                                 VIRTUAL;
    PROCEDURE Process;                                                   VIRTUAL;

    CONSTRUCTOR Init;
  END;

  { ----------------------------------------------------------------------- }
  { ------------------------- TRadioBtns OBJECT --------------------------- }
  { ----------------------------------------------------------------------- }
  PRadioButtons = ^TRadioButtons;
  TRadioButtons = OBJECT(TBaseOBJ)
    PROCEDURE DrawONE(BaseItemNUM:Byte);                                 VIRTUAL;
    PROCEDURE Process;                                                   VIRTUAL;
    CONSTRUCTOR InitRadioButtons(AXPos,AYPos:Byte; VAR AInVAR:Word);
  END;

  { ----------------------------------------------------------------------- }
  { ------------------------- TCheckBoxes OBJECT -------------------------- }
  { ----------------------------------------------------------------------- }
  PCheckBoxes = ^TCheckBoxes;
  TCheckBoxes = OBJECT(TBaseOBJ)
    FUNCTION  Marked(BaseItemNUM:Byte): Boolean;
    PROCEDURE Mark(BaseItemNUM:Byte);
    PROCEDURE DrawONE(BaseItemNUM:Byte);                                 VIRTUAL;
    PROCEDURE Process;                                                   VIRTUAL;
    CONSTRUCTOR InitCheckBoxes(AXPos,AYPos:Byte; VAR AInVAR:Word);
  END;

  { ----------------------------------------------------------------------- }
  { ------------------------- TButtons OBJECT ----------------------------- }
  { ----------------------------------------------------------------------- }
  PButtons = ^TButtons;
  TButtons = OBJECT(TBaseOBJ)
    QuickExit: Boolean;
    PROCEDURE AddBtn(ABaseItemName:STRING; AHotKey:Word;
                     AXPos,AYPos:Byte; AbtnType: TbtnTypes);
    PROCEDURE PushButton;
    PROCEDURE DrawONE(BaseItemNUM:Byte);                                 VIRTUAL;
    PROCEDURE Process;                                                   VIRTUAL;
    CONSTRUCTOR InitButtons;
    PRIVATE
    DefaultPOS: Word;
  END;


  { ----------------------------------------------------------------------- }
  { -------------------------- TComboBox OBJECT --------------------------- }
  { ----------------------------------------------------------------------- }
  PComboBox   = ^TComboBox;
  TComboBox   = OBJECT
    XPos,YPos,
    Width,
    LastITEM,
    CurrentPOS: Byte;

    BoxFrame  : FrameStyle;
    StrDATA   : PStrARRAY;
    InVAR     : ^Byte;

    ExitKey   : Word;
    TabAllowed: Boolean;

    PROCEDURE DrawONE(BaseItemNUM: Integer);
    PROCEDURE DrawALL(Normal: Boolean);
    PROCEDURE Process;
    CONSTRUCTOR Init(AXPos,AYPos,
                     AWidth,ALastITEM  : Byte;
                     VAR AInVAR        : Word;
                     VAR AStrData      : PStrARRAY);
    DESTRUCTOR Done;                                                  VIRTUAL;
  END;


  { ----------------------------------------------------------------------- }
  { ------------------------- TInputLine OBJECT --------------------------- }
  { ----------------------------------------------------------------------- }
  PInputLine = ^TInputLine;
  TInputLine = OBJECT(TObject)
     XPos    : Byte;
     YPos    : Byte;
     ExitKey : Word;
     LineLEN : Byte;
     ILType  : TInputLineKinds;
     Min,Max : LongInt;
     InVAR   : ^STRING;
     TabAllowed: Boolean;
     PROCEDURE Draw(Attr: Byte);
     PROCEDURE Filter;
     PROCEDURE Process;
     CONSTRUCTOR InitText(AXPos,AYPos: Byte;
                          ALineLEN   : Byte;
                          AILType    : TInputLineKinds;
                          VAR AInVAR : STRING);
     CONSTRUCTOR InitNumeric(AXPos,AYPos: Byte;
                             AMin,AMax  : LongInt;
                             VAR AInVAR : STRING);
     PRIVATE
     TMPStr: STRING;
  END;

  { ----------------------------------------------------------------------- }
  { ------------------------- TDialogDATA OBJECT -------------------------- }
  { ----------------------------------------------------------------------- }
  PDialogData = ^TDialogData;
  TDialogData = OBJECT(TObject)
     CommentX : Byte;
     CommentY : Byte;
      Comment : PString;
       HOTKey : Word;
    FieldType : TFieldType;
    InputLine : PInputLine;
     ComboBox : PComboBox;
 RadioButtons : PRadioButtons;
   CheckBoxes : PCheckBoxes;
      Buttons : PButtons;
      CONSTRUCTOR Init(AFieldType: TFieldType;
                       ACommentX : Byte;
                       ACommentY : Byte;
                       AComment  : STRING;
                       AHotKey   : Word);
      DESTRUCTOR Done; VIRTUAL;
  END;

  { ----------------------------------------------------------------------- }
  { ----------------------------- TDialog OBJECT -------------------------- }
  { ----------------------------------------------------------------------- }
  PDialogDataCollection = ^TDialogDataCollection;
  TDialogDataCollection = OBJECT(TCollection)
  END;

  PDialog = ^TDialog;
  TDialog = OBJECT
    XPos     : Byte;
    YPos     : Byte;
    Width    : Byte;
    Heigth   : Byte;
    BoxType  : FrameStyle;
    Title    : STRING;
    Data     : PDialogDataCollection;
 { ------------------------------------------------------------ }
    PROCEDURE AddTxtInputLine(ACommentX  : Byte;
                              ACommentY  : Byte;
                              AComment   : STRING;
                              AHotKey    : Word;
                              AXPos,AYPos: Byte;
                              ALineLEN   : Byte;
                              AILType    : TInputLineKinds;
                              VAR AInVAR : STRING);
    PROCEDURE AddNumInputLine(ACommentX  : Byte;
                              ACommentY  : Byte;
                              AComment   : STRING;
                              AHotKey    : Word;
                              AXPos,AYPos: Byte;
                              AMin,AMax  : LongInt;
                              VAR AInVAR : STRING);
    PROCEDURE AddStaticText  (ATextX     : Byte;
                              ATextY     : Byte;
                              ANormAttr  : Byte;
                              AHiAttr    : Byte;
                              AText      : STRING);
    PROCEDURE AddComboBox    (ACommentX  : Byte;
                              ACommentY  : Byte;
                              AComment   : STRING;
                              AHotKey    : Word;
                              AXPos,AYPos: Byte;
                              AWidth     : Byte;
                              ALastITEM  : Byte;
                              ABoxFrame  : FrameStyle;
                              VAR AInVAR : Word;
                             VAR AStrDATA: PStrARRAY);
    PROCEDURE AddRadioButtons(ACommentX : Byte;
                              ACommentY : Byte;
                              AComment  : STRING;
                              AHotKey   : Word;
                              AXPos,
                              AYPos     : Byte;
                              VAR AInVAR:Word);
    PROCEDURE AddRadioButton(ARadioButtonName:STRING; AHotKey:Word);
    PROCEDURE AddCheckBoxes(ACommentX : Byte;
                            ACommentY : Byte;
                            AComment  : STRING;
                            AHotKey   : Word;
                            AXPos,
                            AYPos     : Byte;
                            VAR AInVAR:Word);
    PROCEDURE AddCheckBox(ACheckBoxName:STRING; AHotKey:Word);
    PROCEDURE AddButtons;
    PROCEDURE AddButton(AButtonName:STRING; AHotKey:Word; AXPos,AYPos:Byte; AbtnType: TBtnTypes);
 { ------------------------------------------------------------ }
    PROCEDURE DrawALLFields;
    PROCEDURE DrawALLComments;
    PROCEDURE DrawALL;

    FUNCTION Process(StartFrom: Byte): Integer;

    CONSTRUCTOR Init(AXPos,AYPos,
                     AWidth,AHeigth : Byte;
                     ADialogPAL     : TDialogPallettes;
                     ABoxType       : FrameStyle;
                     ATitle         : STRING);
    DESTRUCTOR Done; VIRTUAL;
    PRIVATE
    FirstTime: Boolean;
  END;


VAR
  DialogPallette: ARRAY[TDialogPALRecs] OF Byte;


PROCEDURE InitPallette (PAL: TDialogPallettes);



IMPLEMENTATION



VAR
  ShortCuts   : ARRAY[0..255] OF Word;
  ShortCutsCnt: Byte;
  LastShortCut: Word;
  ShortCutOK  : Boolean;


 FUNCTION IsInShortCuts(Key: Word): Boolean;
 VAR I: Byte;
 BEGIN
   IsInShortCuts := False;
   i := 0;
   WHILE i <> ShortCutsCnt DO
   BEGIN
     IF ShortCuts[i] = Key
       THEN BEGIN
              IsInShortCuts := True;
              LastShortCut  := Key;
              Break;
            END
       ELSE LastShortCut := 0;
     Inc(i);
   END;
 END;


 PROCEDURE InitPallette(PAL: TDialogPallettes);
 VAR DialogBack: Byte;
 BEGIN
   CASE PAL OF
     DefaultDialogPAL: DialogBack := $5; {Purple}
     WarningDialogPAL: DialogBack := $4; {Red}
     BlueDialogPAL   : DialogBack := $1; {Blue}
   END;

   DialogPallette[ _DialogBack                ] := Attr(DialogBack+8,DialogBack);
   DialogPallette[ _DialogTitle               ] := Attr($F,DialogBack);
   DialogPallette[ _DialogComments            ] := Attr($7,DialogBack);
   DialogPallette[ _DialogCommentsHighlight   ] := Attr($E,DialogBack);

   DialogPallette[ _InputLineNormal           ] := $07;
   DialogPallette[ _InputLineHighLight        ] := $0F;

   DialogPallette[ _ComboBoxLine              ] := $07;
   DialogPallette[ _ComboBoxArrow             ] := Attr($7,DialogBack);
   DialogPallette[ _ComboBoxWinAttr           ] := $3B;
   DialogPallette[ _ComboBoxListNormal        ] := $30;
   DialogPallette[ _ComboBoxListHiLight       ] := $17;
   DialogPallette[ _ComboBoxFastFind          ] := $3B;
   DialogPallette[ _ComboBoxOldChoice         ] := $38;

   DialogPallette[ _CheckBoxNormal            ] := $07;
   DialogPallette[ _CheckBoxHighlight         ] := $0E;
   DialogPallette[ _CheckBoxSelectedNormal    ] := $0F;
   DialogPallette[ _CheckBoxSelectedHighlight ] := $0E;
   DialogPallette[ _DisabledCheckBox          ] := $08;

   DialogPallette[ _RadioBtnNormal            ] := $07;
   DialogPallette[ _RadioBtnHighlight         ] := $0E;
   DialogPallette[ _RadioBtnSelectedNormal    ] := $0F;
   DialogPallette[ _RadioBtnSelectedHighlight ] := $0E;
   DialogPallette[ _DisabledRadioBtn          ] := $08;

   DialogPallette[ _ButtonNormal              ] := $70;
   DialogPallette[ _ButtonHighlight           ] := $74;
   DialogPallette[ _ButtonSelectedNormal      ] := $F0;
   DialogPallette[ _ButtonSelectedHighlight   ] := $F4;
   DialogPallette[ _DisabledButton            ] := $78;
   DialogPallette[ _ButtonDefaultNormal       ] := $71;
   DialogPallette[ _ButtonDefaultHighlight    ] := $74;

   DialogPallette[ _ButtonShadow              ] := Attr(0,DialogBack);
 END;


{ ------------------------------------------------------------------------- }
{ --------------------------- PStrARRAY METHODS --------------------------- }
{ ------------------------------------------------------------------------- }
FUNCTION TStrARRAY.GetStr(Num: Byte): STRING;
BEGIN
  IF Num > Count
    THEN GetStr := ''
    ELSE IF Data[Num] = NIL
           THEN GetStr := ''
           ELSE GetStr := Data[Num]^;
END;

PROCEDURE TStrARRAY.AddStr(AStr: STRING);
BEGIN
  IF Count = 255 THEN Exit;
  IF AStr  <>  ''
    THEN Data[Count+1] := NewStr(AStr)
    ELSE Data[Count+1] := NIL;
  Inc(Count);
END;

CONSTRUCTOR TStrARRAY.Init;
VAR I: Byte;
BEGIN
  Count := 0;
  FOR I := 1 TO 255 DO Data[I] := NIL;
END;

DESTRUCTOR TStrARRAY.Done;
VAR I: Byte;
BEGIN
  FOR I := 1 TO 255 DO
    IF Data[I] <> NIL THEN DisposeStr(Data[I]);
END;



{ ------------------------------------------------------------------------- }
{ ----------------------------- TBaseItem METHODS ------------------------- }
{ ------------------------------------------------------------------------- }
CONSTRUCTOR TBaseItem.Init(ABaseItemName:STRING; AHotKey:Word; AXPos,AYPos: Byte);
BEGIN
  Name   := NewStr(ABaseItemName);
  HotKey := AHotKey;
  Active := True;
  XPos   := AXPos;
  YPos   := AYPos;
  ShortCuts[ShortCutsCnt] := HotKey; Inc(ShortCutsCnt);
END;

DESTRUCTOR TBaseItem.Done;
BEGIN
  DisposeStr(Name);
END;

{ ------------------------------------------------------------------------- }
{ ------------------------------ TBaseOBJ METHODS ------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TBaseOBJ.DrawONE(BaseItemNUM:Byte);                   BEGIN END;
PROCEDURE TBaseOBJ.Process;                                     BEGIN END;

FUNCTION TBaseOBJ.KeyOK(Key: Word): Boolean;
VAR OK: Boolean;
BEGIN
  OK := False;
  IF (Key=kbEnter) OR
     (Key=kbEsc)   OR
     (Key=kbTab)   OR
     (Key=kbSTab)  THEN OK := True;
  IF OK THEN DrawAll(False);
  ExitKey := Key;
  KeyOK := OK;
END;

FUNCTION TBaseOBJ.GetActive(BaseItemNUM:Byte): Boolean;
VAR BaseItem: PBaseItem;
BEGIN
  IF BaseItemNum > Count
    THEN GetActive := False
    ELSE BEGIN
           BaseItem  := At(BaseItemNUM-1);
           GetActive := BaseItem^.Active;
         END;
END;

FUNCTION TBaseOBJ.CheckKey(Key:Word; AltKey:Boolean): Byte;
VAR Index: Byte; BaseItem: PBaseItem;
BEGIN
  CheckKey := 0;
  FOR Index := 1 TO Count DO
  BEGIN
    BaseItem := At(Index-1);
    IF AltKey
      THEN IF BaseItem^.HotKey = Key
             THEN BEGIN
                    CheckKey := Index;
                    Break;
                  END
      ELSE IF (NormalChar(BaseItem^.HotKey) = UpCase(Chr(Key))) AND
              (Key < 255)
             THEN BEGIN
                    CheckKey := Index;
                    Break;
                  END;
  END;
  IF BaseItem^.Active = False THEN CheckKey := 0;
END;

PROCEDURE TBaseOBJ.DrawALL(MarkCurrent: Boolean);
VAR Index: Byte; OLDCPos: Byte;
BEGIN
  IF NOT MarkCurrent THEN
  BEGIN
    OLDCPos    := CurrentPOS;
    CurrentPOS := Count + 1;
  END;
  FOR Index := 1 TO Count DO DrawONE(Index);
  IF NOT MarkCurrent THEN CurrentPOS := OLDCPos;
END;

PROCEDURE TBaseOBJ.SetActive(BaseItemNUM:Byte; AActive:Boolean);
VAR BaseItem: PBaseItem;
BEGIN
  IF BaseItemNUM > Count
    THEN
    ELSE BEGIN
           BaseItem := At(BaseItemNUM-1);
           BaseItem^.Active := AActive;
         END;
END;

PROCEDURE TBaseOBJ.Add(ABaseItemName:STRING; AHotKey:Word);
BEGIN
  Insert(New(PBaseItem, Init(ABaseItemName,AHotKey,0,0)));
  IF Length(ABaseItemName) > Width THEN Width := Length(ABaseItemName)+1;
END;

PROCEDURE TBaseOBJ.ProcessKeys(VAR Key: Word);
VAR BaseItem: PBaseItem;
BEGIN
  IF ((Key=kbTab) OR (Key=kbSTab)) AND NOT TabAllowed THEN Key := 0;
  Tmp1 := CheckKey(Key,True);
  Tmp2 := CheckKey(Key,False);
  IF (Tmp1 = 0) AND (Tmp2 = 0) THEN ShortCutOK := IsInShortCuts(Key);
  IF ShortCutOK THEN Key := kbEnter;
  IF ItIsButton THEN
  BEGIN
    IF (Key=kbTab ) AND (CurrentPOS <> Count) THEN Key := kbDown;
    IF (Key=kbSTab) AND (CurrentPOS <> 1)     THEN Key := kbUp;
  END;
  CASE Key OF
     kbUp,
   kbLeft: BEGIN
             IF CurrentPOS = 1 THEN CurrentPOS := Count ELSE Dec(CurrentPos);
             BaseItem := At(CurrentPos-1);
             IF BaseItem^.Active = False THEN
             REPEAT
               IF CurrentPOS = 1 THEN CurrentPOS := Count ELSE Dec(CurrentPos);
               BaseItem := At(CurrentPos-1);
             UNTIL BaseItem^.Active;
           END;
   kbDown,
  kbRight : BEGIN
             IF CurrentPOS = Count THEN CurrentPOS := 1 ELSE Inc(CurrentPos);
             BaseItem := At(CurrentPos-1);
             IF BaseItem^.Active = False THEN
             REPEAT
             IF CurrentPOS = Count THEN CurrentPOS := 1 ELSE Inc(CurrentPos);
               BaseItem := At(CurrentPos-1);
             UNTIL BaseItem^.Active;
           END;
  kbHome,
  kbPgUp : CurrentPOS := 1;
   kbEnd,
  kbPgDn : CurrentPOS := Count;
 END;
END;

CONSTRUCTOR TBaseOBJ.Init;
BEGIN
  INHERITED Init(1,1);
  ItIsButton := False;
  TabAllowed := False;
END;


{ ------------------------------------------------------------------------- }
{ ------------------------------ TRadioButtons ---------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TRadioButtons.DrawONE(BaseItemNUM:Byte);
VAR RadioBtn: PBaseItem; StrOut: STRING; A: Byte; OK: Boolean;
BEGIN
  RadioBtn := At(BaseItemNUM-1);
  StrOut := ' ( ) '+PadLeft(GetStr(RadioBtn^.Name),Width,' ');
  IF (InVAR^ = BaseItemNUM)
    THEN A := DialogPallette[_RadioBtnSelectedNormal]
    ELSE A := DialogPallette[_RadioBtnNormal];
  IF (InVAR^ <> CurrentPOS) THEN A := DialogPallette[_RadioBtnNormal];
  IF (InVAR^ = BaseItemNUM) THEN StrOut[3] := #7;
  IF RadioBtn^.Active
    THEN WriteHi(XPos,YPos+Pred(BaseItemNUM),A,DialogPallette[_RadioBtnHighlight],StrOut)
    ELSE WriteHi(XPos,YPos+Pred(BaseItemNUM),DialogPallette[_DisabledRadioBtn],DialogPallette[_DisabledRadioBtn],StrOut);
END;

PROCEDURE TRadioButtons.Process;
VAR RadioBtn: PBaseItem; Key: Word;
BEGIN
  Cursor(On);
  DrawALL(True);
  REPEAT
    PosCursor(XPos+2,YPos+Pred(CurrentPOS));
    Key := GetKey;
    ProcessKeys(Key);
    IF Tmp1 <> 0 THEN CurrentPos := Tmp1;
    IF Tmp2 <> 0 THEN CurrentPos := Tmp2;
    IF (Key=kbEnter) THEN
      IF GetActive(CurrentPOS) = False THEN Key := 0;
    PosCursor(XPos+2,YPos+Pred(CurrentPOS));
    InVAR^ := CurrentPOS;
    DrawALL(True);
  UNTIL KeyOK(Key);
END;

CONSTRUCTOR TRadioButtons.InitRadioButtons(AXPos,AYPos:Byte; VAR AInVAR:Word);
BEGIN
  INHERITED Init;
  XPos       := AXPos;
  YPos       := AYPos;
  Width      := 0;
  CurrentPos := AInVAR;
  InVar      := @AInVAR;
END;



{ ------------------------------------------------------------------------- }
{ --------------------------------- TCheckBoxes --------------------------- }
{ ------------------------------------------------------------------------- }
FUNCTION TCheckBoxes.Marked(BaseItemNUM:Byte): Boolean;
VAR Flag: Word;
BEGIN
  IF BaseItemNUM = 1 THEN Flag := 1 ELSE Flag := 1 SHL Pred(BaseItemNUM);
  IF (InVAR^ AND Flag) <> 0
    THEN Marked := True
    ELSE Marked := False;
END;

PROCEDURE TCheckBoxes.Mark(BaseItemNUM:Byte);
VAR Flag: Word;
BEGIN
  IF BaseItemNUM = 1 THEN Flag := 1 ELSE Flag := 1 SHL Pred(BaseItemNUM);
  IF Marked(BaseItemNUM)
    THEN InVAR^ := InVar^ AND NOT Flag
    ELSE InVAR^ := InVar^ OR Flag;
END;

PROCEDURE TCheckBoxes.DrawONE(BaseItemNUM:Byte);
VAR CheckBox: PBaseItem; StrOut: STRING; A: Byte;
BEGIN
  CheckBox := At(BaseItemNUM-1);
  StrOut := ' [ ] '+PadLeft(GetStr(CheckBox^.Name),Width,' ');
  IF CurrentPOS = BaseItemNUM
    THEN A := DialogPallette[_CheckBoxSelectedNormal]
    ELSE A := DialogPallette[_CheckBoxNormal];
  IF Marked(BaseItemNUM) THEN StrOut[3] := 'x';
  IF CheckBox^.Active
    THEN WriteHi(XPos,YPos+Pred(BaseItemNUM),A,DialogPallette[_CheckBoxHighlight],StrOut)
    ELSE WriteHi(XPos,YPos+Pred(BaseItemNUM),DialogPallette[_DisabledCheckBox],DialogPallette[_DisabledCheckBox],StrOut);
END;

PROCEDURE TCheckBoxes.Process;
VAR CheckBox: PBaseItem; Key: Word;
BEGIN
  Cursor(On);
  DrawALL(True);
  REPEAT
    PosCursor(XPos+2,YPos+Pred(CurrentPOS));
    Key := GetKey;
    ProcessKeys(Key);
    IF Tmp1 <> 0 THEN BEGIN CurrentPos := Tmp1; Key := kbSpace; END;
    IF Tmp2 <> 0 THEN BEGIN CurrentPos := Tmp2; Key := kbSpace; END;
    IF (Key=kbSpace) THEN
      IF GetActive(CurrentPOS) THEN Mark(CurrentPOS);
    PosCursor(XPos+2,YPos+Pred(CurrentPOS));
    DrawALL(True);
  UNTIL KeyOK(Key);
END;

CONSTRUCTOR TCheckBoxes.InitCheckBoxes(AXPos,AYPos: Byte; VAR AInVAR: Word);
BEGIN
  INHERITED Init;
  XPos       := AXPos;
  YPos       := AYPos;
  Width      := 0;
  CurrentPos := 1;
  InVar      := @AInVAR;
END;


{ ------------------------------------------------------------------------- }
{ ---------------------------------- TButtons ----------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TButtons.DrawONE(BaseItemNUM:Byte);
VAR Button: PBaseItem; StrOut: STRING; A,B: Byte;
BEGIN
  Button := At(BaseItemNUM-1);
  WITH Button^ DO
  BEGIN
    A      := DialogPallette[_ButtonNormal];
    B      := DialogPallette[_ButtonHighlight];
    StrOut := GetStr(Name);
    IF CurrentPos = BaseItemNUM
      THEN BEGIN
             StrOut[1] := #16;
             StrOut[Length(StrOut)] := #17;
             A := DialogPallette[_ButtonSelectedNormal];
             B := DialogPallette[_ButtonSelectedHighlight];
           END;
    IF (btnType = btDefault) AND (CurrentPOS = Count+1)
      THEN BEGIN
             StrOut[1]              := #16;
             StrOut[Length(StrOut)] := #17;
             A := DialogPallette[ _ButtonDefaultNormal];
             B := DialogPallette[_ButtonDefaultHighlight];
           END;
    IF Active
      THEN WriteHi(XPos,YPos,  A,  B,StrOut)
      ELSE WriteHi(XPos,YPos,DialogPallette[_DisabledButton],DialogPallette[_DisabledButton],StrOut);
    FastWrite(XPos+Length(Name^)-2,YPos,DialogPallette[_ButtonShadow],'');
    FastWrite(XPos+1,YPos+1,DialogPallette[_ButtonShadow],Replicate(Length(Name^)-2,''));
  END;
END;

PROCEDURE TButtons.PushButton;
VAR Button: PBaseItem; StrOut: STRING; A,B: Byte;
BEGIN
  Button := At(CurrentPOS-1);
  WITH Button^ DO
  BEGIN
    StrOut := Name^;
    StrOut[1] := #16;
    StrOut[Length(StrOut)] := #17;
    A := DialogPallette[_ButtonSelectedNormal];
    B := DialogPallette[_ButtonSelectedHighlight];
    FastWrite(XPos,YPos,DialogPallette[_ButtonShadow],' ');
    WriteHi(XPos+1,YPos,A,B,StrOut);
    FastWrite(XPos+1,YPos+1,DialogPallette[_ButtonShadow],Replicate(Length(Name^)-2,' '));
    Delay(100);
    WriteHi(XPos,YPos,A,B,StrOut);
    FastWrite(XPos+Length(Name^)-2,YPos,DialogPallette[_ButtonShadow],'');
    FastWrite(XPos+1,YPos+1,DialogPallette[_ButtonShadow],Replicate(Length(Name^)-2,''));
    Delay(100);
  END;
END;

PROCEDURE TButtons.Process;
VAR Button: PBaseItem; Key,I: Word;
BEGIN
  Cursor(Off);
  DrawALL(True);
  REPEAT
    IF NOT QuickExit
      THEN Key := GetKey
      ELSE Key := kbEnter;
    ProcessKeys(Key);
    IF Tmp1 <> 0 THEN BEGIN CurrentPos := Tmp1; Key := kbEnter; END;
    IF Tmp2 <> 0 THEN BEGIN CurrentPos := Tmp2; Key := kbEnter; END;
    DrawALL(True);
    IF (Key=kbEnter) AND NOT (ShortCutOK) THEN
      IF GetActive(CurrentPOS) THEN PushButton ELSE Key := 0;
    DrawALL(True);
    IF (Key=kbTab) OR (Key=kbSTab) OR (ShortCutOK) THEN CurrentPOS := DefaultPOS;
    IF (Key=kbEsc) THEN BEGIN
                          FOR I:=0 TO Count-1 DO
                          BEGIN
                            Button := At(I);
                            IF Button^.btnType=btCancel THEN Break;
                          END;
                          CurrentPOS := I+1;
                        END;
  UNTIL KeyOK(Key);
  QuickExit := False;
END;

PROCEDURE TButtons.AddBtn(ABaseItemName:STRING; AHotKey:Word;
                          AXPos,AYPos:Byte; AbtnType: TBtnTypes);
VAR NewBtn: PBaseItem;
BEGIN
  New(NewBtn, Init(ABaseItemName,AHotKey,AXPos,AYPos));
  NewBtn^.btnType := AbtnType;
  Insert(NewBtn);
  IF AbtnType = btDefault THEN CurrentPOS := Count;
  DefaultPOS := CurrentPOS;
END;

CONSTRUCTOR TButtons.InitButtons;
BEGIN
  INHERITED Init;
  ItIsButton := True;
  XPos       := 0;
  YPos       := 0;
  CurrentPos := 1;
  InVAR      := NIL;
  QuickExit  := False;
END;

{ ------------------------------------------------------------------------- }
{ ----------------------------- TComboBox METHODS ------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TComboBox.DrawOne(BaseItemNUM: Integer);
VAR StrOut: STRING;
BEGIN
  StrOut := ' '+PadLeft(StrData^.GetStr(BaseItemNUM),Width,' ')+' ';
  IF CurrentPOS = BaseItemNUM
    THEN FastWrite(XPos+1,YPos+BaseItemNUM,DialogPallette[_ComboBoxListHiLight],StrOut)
    ELSE FastWrite(XPos+1,YPos+BaseItemNUM,DialogPallette[_ComboBoxListNormal],StrOut);
END;

PROCEDURE TComboBox.DrawAll(Normal: Boolean);
VAR I: Integer; ArrAttr: Byte;
BEGIN
  IF Normal
    THEN FOR I := 1 TO LastItem DO DrawONE(I)
    ELSE WriteHi(XPos,YPos,DialogPallette[_ComboBoxLine],DialogPallette[_ComboBoxArrow],
                 '[ '+PadLeft(StrData^.GetStr(CurrentPOS),Width,' ')+' ]~'#31'~');
END;


PROCEDURE TComboBox.Process;
VAR Key: Word; FastFindBUF: STRING; OldWinShadow: Boolean;

  PROCEDURE FastFind(Key:Word);
  VAR Name: STRING; Index: Byte;
      FFLength: Byte;
      FoundIT : Boolean;
  BEGIN
    IF Length(FastFindBUF) = Width THEN Exit;

    FoundIT    := False;
    FFLength   := Length(FastFindBUF)+1;
    FastFindBUF:= FastFindBUF + UpCase(Chr(Key));

    FOR Index := 1 TO LastITEM DO
    BEGIN
      Name := AdjCase(Upper, StripBoth(StrData^.GetStr(Index),' '));
      Name := System.Copy(Name,1,FFLength);
      IF FastFindBUF = Name THEN FoundIT := True;
      IF FoundIT THEN Break;
    END;
    IF NOT FoundIT THEN
    BEGIN
      FastFindBUF[0] := Chr(FFLength-1);
      Exit;
    END;
    IF FoundIT THEN CurrentPOS := Index;
  END;

  FUNCTION KeyOK(Key: Word): Boolean;
  VAR OK: Boolean;
  BEGIN
    OK := False;
    KeyOK := OK;
    IF NOT TabAllowed AND ((Key=kbTab) OR (Key=kbSTab)) THEN Exit;

    IF (Key=kbEnter) OR
       (Key=kbEsc)   OR
       (Key=kbTab)   OR
       (Key=kbSTab)  THEN OK := True;
    IF OK THEN BEGIN
                 RmWin;
                 IF Key = kbEsc THEN CurrentPOS := InVAR^ ELSE InVAR^ := CurrentPOS;
                 DrawALL(False);
               END;
    ExitKey := Key;
    KeyOK := OK;
  END;

BEGIN
  Cursor(Off);
  DrawAll(False);
  FastFindBUF := '';
  OldWinShadow := WinShadow;
  WinShadow := False;
  MkWin(XPos,YPos,Width+3,LastITEM+1,DialogPallette[_ComboBoxWinAttr],BoxFrame,'');
  WinShadow := OldWinShadow;
  FastWrite(XPos+1,YPos,DialogPallette[_ComboBoxOldChoice],' '+StrData^.GetStr(CurrentPOS)+' ');
  DrawALL(True);
  REPEAT
    Key := GetKey;
    ShortCutOK := IsInShortCuts(Key);
    IF ShortCutOK THEN Key := kbEnter;
    IF (Key < 33 ) OR (Key > 126) THEN FastFindBUF := '';
    CASE Key OF
   33..126: FastFind(Key);
      kbUp: IF CurrentPOS <> 1 THEN Dec(CurrentPOS);
    kbDown: IF CurrentPOS <> LastItem THEN Inc(CurrentPOS);
    kbHome: CurrentPOS := 1;
     kbEnd: CurrentPOS := LastITEM;
    kbPgUp: IF CurrentPOS > 2 THEN Dec(CurrentPOS,2) ELSE CurrentPOS := 1;
    kbPgDn: IF CurrentPOS < LastItem-1 THEN Inc(CurrentPOS,2) ELSE CurrentPOS := LastITEM;
    END;
    DrawALL(True);
    FastWrite(XPos+2,YPos+LastITEM+1,DialogPallette[_ComboBoxFastFind],PadLeft(FastFindBUF,Width,#205));
  UNTIL KeyOK(Key);
END;

CONSTRUCTOR TComboBox.Init(AXPos,AYPos,
                           AWidth,ALastITEM  : Byte;
                           VAR AInVAR        : Word;
                           VAR AStrData      : PStrARRAY);
BEGIN
  IF AInVAR > ALastITEM THEN AInVAR := ALastITEM;
  XPos       := AXPos;
  YPos       := AYPos;
  Width      := AWidth;
  LastItem   := ALastItem;
  InVAR      := @AInVAR;
  CurrentPOS := AInVAR;
  StrData    := AStrData;
  TabAllowed := False;
END;

DESTRUCTOR TComboBox.Done;
BEGIN
END;


{ ------------------------------------------------------------------------- }
{ ----------------------------- TInputLine METHODS ------------------------ }
{ ------------------------------------------------------------------------- }
PROCEDURE TInputLine.Filter;
BEGIN
  CASE ilType OF
    ilLower     : TMPStr := AdjCase(Lower, AdjCaseCyr(Lower, TMPStr) );
    ilUpper,
    ilFileName  : TMPStr := AdjCase(Upper, AdjCaseCyr(Upper, TMPStr) );
    ilProperNorm: TMPStr := AdjCase(ProperNorm, AdjCaseCyr(ProperNorm, TMPStr) );
    ilProperFull: TMPStr := AdjCase(ProperFull, AdjCaseCyr(ProperFull, TMPStr) );
    ilNumeric   : BEGIN
                   TMPStr := IntToStr(StrToInt(TMPStr));
                   IF TMPStr = '0' THEN TMPStr := '';
                 END;
  END;
END;

PROCEDURE TInputLine.Draw(Attr: Byte);
VAR StrOut: STRING; StrOutLen: Byte;
BEGIN
  Filter;
  StrOut    := TMPStr;
  StrOutLen := Length(StrOut);
  IF ilType = ilPassword THEN StrOut := Replicate(StrOutLen,'*');
  FastWrite(XPos-2,YPos,DialogPallette[_InputLineNormal],'[ ');
  FastWrite(XPos  ,YPos,Attr,StrOut);
  FastWrite(XPos+StrOutLEN,YPos,DialogPallette[_InputLineNormal],Replicate(LineLEN-StrOutLEN+1,' ')+']');
END;

PROCEDURE TInputLine.Process;
LABEL Exit;
CONST
  IllegalChars : SET OF Char = [' ','*','?','/','|',';','+','=','<','>','[',']',','{\:.}];
  Numbers      : SET OF Char = ['0'..'9'];

VAR
  Key        : Word;
  TMPPos     : Byte;
  InsertMode : Boolean;

  FUNCTION KeyOK(Key: Word): Boolean;
  VAR OK: Boolean;
  BEGIN
    OK := False;
    IF ((Key=kbTab) OR (Key=kbSTab)) AND NOT TabAllowed THEN System.Exit;
    IF (Key=kbEnter) OR (Key=kbEsc) OR (Key=kbTab) OR (Key=kbSTab) THEN OK := True;

    IF OK AND (ilType=ilNumeric) AND (Key<>kbEsc)
                                {^^^ Modified ^^^}
      THEN OK := (StrToInt(TMPStr)>=Min) AND (StrToInt(TMPStr)<=Max);

    IF OK THEN
    BEGIN
      IF (ilType=ilNumeric) AND (TMPStr='') THEN TMPStr := '0';
      ExitKey := Key;
      IF Key = kbEsc THEN TMPStr := InVAR^ ELSE InVAR^ := TMPStr;
      Draw(DialogPallette[_InputLineNormal]);
    END;
    KeyOK := OK;
  END;

  PROCEDURE SetCursor(_InsertMode: Boolean);
  BEGIN
    InsertMode := _InsertMode;
    IF InsertMode THEN Cursor(On) ELSE Cursor(Full);
  END;

  PROCEDURE InsertCharacter;
  BEGIN
    IF Length(TMPStr) < LineLEN
      THEN BEGIN
             Insert(Chr(Key),TMPStr,TMPPos+1);
             Inc(TMPPos);
           END;
  END;

BEGIN
  TMPStr     := InVAR^;

  Filter;

  TMPPos     := Length(TMPStr);
  InsertMode := True;

  SetCursor(InsertMode);
  PosCursor(XPos+TMPPos,YPos);

  Draw(DialogPallette[_InputLineHighLight]);
  REPEAT
    Key := GetKey;
    ShortCutOK := IsInShortCuts(Key);
    IF ShortCutOK THEN Key := kbEnter;
    CASE Key OF
       kbLeft: IF TMPPos <> 0 THEN Dec(TMPPos);
      kbRight: IF TMPPos <> Length(TMPStr) THEN Inc(TMPPos);
       kbHome: TMPPos  := 0;
        kbEnd: TMPPos  := Length(TMPStr);
     kbBSpace: IF TMPPos <> 0 THEN
               BEGIN
                 Delete(TMPStr,TMPPos,1);
                 Dec(TMPPos);
               END;
 kbCtrlBSpace: BEGIN
                 TMPStr := '';
                 TMPPos := 0;
               END;
        kbDel: Delete(TMPStr,TMPPos+1,1);
        kbIns: SetCursor(NOT InsertMode);
      kbCtrlZ: BEGIN
                 TMPStr := InVAR^;
                 TMPPos := Length(TMPStr);
               END;
     32..255: BEGIN
                IF (ilType = ilFileName) AND (Chr(Key) IN IllegalChars) THEN GOTO Exit;
                IF (ilType = ilNumeric) AND NOT (Chr(Key) IN Numbers) THEN GOTO Exit;
                IF (ilType = ilNumeric) AND (Chr(Key) ='0') AND (TMPPos=0) THEN GOTO Exit;
                IF InsertMode
                  THEN InsertCharacter
                  ELSE IF TMPPos+1 > Length(TMPStr)
                         THEN InsertCharacter
                         ELSE BEGIN
                                TMPStr[TMPPos+1] := Chr(Key);
                                Inc(TMPPos);
                              END;
               END;
     END;
 Exit:
     Filter;
     PosCursor(XPos+TMPPos,YPos);
     Draw(DialogPallette[_InputLineHighLight]);
  UNTIL KeyOK(Key);
  TmpSTR := InVAR^;
END;

CONSTRUCTOR TInputLine.InitText(AXPos,AYPos: Byte;
                                ALineLEN   : Byte;
                                AILType    : TInputLineKinds;
                                VAR AInVAR : STRING);
BEGIN
  XPos       := AXPos; Inc(XPos,2);
  YPos       := AYPos;
  LineLen    := ALineLEN;
  ILType     := AILType;
  IF (ilType=ilNumeric) THEN ilType := ilNormal;
  IF (ilType=ilFileName) THEN AInVAR  := StripAll(AInVAR,' ');
  InVAR      := @AInVAR;
  TMPStr     := InVAR^;
  TabAllowed := False;
END;

CONSTRUCTOR TInputLine.InitNumeric(AXPos,AYPos: Byte;
                                   AMin,AMax  : LongInt;
                                   VAR AInVAR : STRING);
BEGIN
  XPos    := AXPos; Inc(XPos,2);
  YPos    := AYPos;
  Min     := AMin;
  Max     := AMax;
  LineLen := Length(IntToStr(Max));
  ILType  := ilNumeric;
  AInVAR  := IntToStr(StrToInt(AInVAR));
  IF AInVAR = '0' THEN AInVAR := '';
  InVAR   := @AInVAR;
  TMPStr  := InVAR^;
  TabAllowed := False;
END;









{ ------------------------------------------------------------------------- }
{ --------------------------- TDialogDATA METHODS ------------------------- }
{ ------------------------------------------------------------------------- }
CONSTRUCTOR TDialogData.Init(AFieldType: TFieldType;
                             ACommentX : Byte;
                             ACommentY : Byte;
                             AComment  : STRING;
                             AHotKey   : Word);
BEGIN
  FieldType := AFieldType;
  CommentX  := ACommentX;
  CommentY  := ACommentY;
  HotKey    := AHotKey;
  IF AComment <> ''
    THEN Comment := NewStr(AComment)
    ELSE Comment := NIL;
  ShortCuts[ShortCutsCnt] := HotKey; Inc(ShortCutsCnt);
END;

DESTRUCTOR TDialogData.Done;
BEGIN
  CASE FieldType OF
    ftTxtInputLine,
    ftNumInputLine : Dispose(InputLine,    Done);
    ftComboBox     : Dispose(ComboBox,     Done);
    ftCheckBoxes   : Dispose(CheckBoxes,   Done);
    ftRadioButtons : Dispose(RadioButtons, Done);
    ftButtons      : Dispose(Buttons,      Done);
  END;
  IF Comment <> NIL THEN DisposeStr(Comment);
END;

{ ------------------------------------------------------------------------- }
{ ------------------------------- TDialog METHODS ------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TDialog.DrawALLFields;
VAR I: Integer; DData: PDialogData;
BEGIN
  WITH Data^ DO
  FOR I := 0 TO Count-1 DO
  BEGIN
    DData := At(I);
    WITH DData^ DO
    CASE FieldType OF
      ftTxtInputLine,
      ftNumInputLine : InputLine^.Draw($07);
      ftStaticText   : WriteHi(CommentX,CommentY,Lo(HOTKey),Hi(HOTKey),Comment^);
      ftComboBox     : ComboBox^.DrawALL(False);
      ftCheckBoxes   : CheckBoxes^.DrawALL(False);
      ftRadioButtons : RadioButtons^.DrawALL(False);
      ftButtons      : Buttons^.DrawALL(False);
    END;
  END;
END;

PROCEDURE TDialog.DrawALLComments;
VAR I: Integer; DData: PDialogData;
BEGIN
  WITH Data^ DO
  FOR I := 0 TO Count-1 DO
  BEGIN
    DData := At(I);
    WITH DData^ DO
    BEGIN
      IF (Comment <> NIL) AND (FieldType<>ftStaticText)
        THEN WriteHi(CommentX,CommentY,
                     DialogPallette[_DialogComments],
                     DialogPallette[_DialogCommentsHighLight],
                     Comment^);
    END;
  END;
END;

PROCEDURE TDialog.DrawALL;
BEGIN
  DrawALLComments;
  DrawALLFields;
END;


PROCEDURE TDialog.AddTxtInputLine(ACommentX  : Byte;
                                  ACommentY  : Byte;
                                  AComment   : STRING;
                                  AHotKey    : Word;
                                  AXPos,AYPos: Byte;
                                  ALineLEN   : Byte;
                                  AILType    : TInputLineKinds;
                                  VAR AInVAR : STRING);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftTxtInputLine,ACommentX+XPos,ACommentY+YPos,AComment,AHotKey));
  DataPTR^.InputLine := New(PInputLine, InitText(AXPos+XPos,AYPos+YPos,ALineLEN,AILType,AInVAR));
  DataPTR^.InputLine^.TabAllowed := True;
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddNumInputLine(ACommentX  : Byte;
                                  ACommentY  : Byte;
                                  AComment   : STRING;
                                  AHotKey    : Word;
                                  AXPos,AYPos: Byte;
                                  AMin,AMax  : LongInt;
                                  VAR AInVAR : STRING);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftNumInputLine,ACommentX+XPos,ACommentY+YPos,AComment,AHotKey));
  DataPTR^.InputLine := New(PInputLine, InitNumeric(AXPos+XPos,AYPos+YPos,AMin,AMax,AInVAR));
  DataPTR^.InputLine^.TabAllowed := True;
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddStaticText(ATextX     : Byte;
                                ATextY     : Byte;
                                ANormAttr  : Byte;
                                AHiAttr    : Byte;
                                AText      : STRING);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftStaticText,ATextX+XPos,ATextY+YPos,AText,(ANormAttr + (AHiAttr SHL 8))));
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddComboBox(ACommentX  : Byte;
                              ACommentY  : Byte;
                              AComment   : STRING;
                              AHotKey    : Word;
                              AXPos,AYPos: Byte;
                              AWidth     : Byte;
                              ALastITEM  : Byte;
                              ABoxFrame  : FrameStyle;
                              VAR AInVAR : Word;
                             VAR AStrDATA: PStrARRAY);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftComboBox,ACommentX+XPos,ACommentY+YPos,AComment,AHotKey));
  DataPTR^.ComboBox := New(PComboBox, Init(AXPos+XPos,AYPos+YPos,AWidth,ALastITEM,AInVAR,AStrDATA));
  DataPTR^.ComboBox^.TabAllowed := True;
  DataPTR^.ComboBox^.BoxFrame := ABoxFrame;
  Data^.Insert(DataPTR);
END;


PROCEDURE TDialog.AddRadioButtons(ACommentX : Byte;
                                  ACommentY : Byte;
                                  AComment  : STRING;
                                  AHotKey   : Word;
                                  AXPos,
                                  AYPos     : Byte;
                                  VAR AInVAR:Word);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftRadioButtons,ACommentX+XPos,ACommentY+YPos,AComment,AHotKey));
  DataPTR^.RadioButtons := New(PRadioButtons,InitRadioButtons(AXPos+XPos,AYPos+YPos,AInVAR));
  DataPTR^.RadioButtons^.TabAllowed := True;
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddCheckBoxes(ACommentX : Byte;
                                ACommentY : Byte;
                                AComment  : STRING;
                                AHotKey   : Word;
                                AXPos,
                                AYPos     : Byte;
                                VAR AInVAR:Word);
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftCheckBoxes,ACommentX+XPos,ACommentY+YPos,AComment,AHotKey));
  DataPTR^.CheckBoxes := New(PCheckBoxes,InitCheckBoxes(AXPos+XPos,AYPos+YPos,AInVAR));
  DataPTR^.CheckBoxes^.TabAllowed := True;
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddButtons;
VAR DataPTR: PDialogData;
BEGIN
  New(DataPTR, Init(ftButtons,0,0,'',0));
  DataPTR^.Buttons := New(PButtons,InitButtons);
  DataPTR^.Buttons^.TabAllowed := True;
  Data^.Insert(DataPTR);
END;

PROCEDURE TDialog.AddRadioButton(ARadioButtonName:STRING; AHotKey:Word);
VAR DataPTR: PDialogData;
BEGIN
  DataPTR := Data^.At(Data^.Count-1);
  WITH DataPTR^ DO
  BEGIN
    IF FieldType <> ftRadioButtons THEN Exit;
    RadioButtons^.Add(ARadioButtonName, AHotKey);
  END;
END;

PROCEDURE TDialog.AddCheckBox(ACheckBoxName:STRING; AHotKey:Word);
VAR DataPTR: PDialogData;
BEGIN
  DataPTR := Data^.At(Data^.Count-1);
  WITH DataPTR^ DO
  BEGIN
    IF FieldType <> ftCheckBoxes THEN Exit;
    CheckBoxes^.Add(ACheckBoxName, AHotKey);
  END;
END;

PROCEDURE TDialog.AddButton(AButtonName:STRING; AHotKey:Word; AXPos,AYPos:Byte; AbtnType: TBtnTypes);
VAR DataPTR: PDialogData;
BEGIN
  DataPTR := Data^.At(Data^.Count-1);
  WITH DataPTR^ DO
  BEGIN
    IF FieldType <> ftButtons THEN Exit;
    Buttons^.AddBtn(AButtonName, AHotKey, AXPos+XPos, AYPos+YPos, ABtnType);
  END;
END;



FUNCTION TDialog.Process(StartFrom: Byte): Integer;
VAR DData  : PDialogData;
    Button : PBaseItem;
    ExitKey: Word;
    I,R    : Word;
    Current: Integer;
    _DPal  : ARRAY[TDialogPALRecs] OF Byte;

 PROCEDURE GetEXITKey;
 BEGIN
   WITH DData^ DO
   CASE FieldType OF
     ftTxtInputLine,
     ftNumInputLine: ExitKey := InputLine^.ExitKey;
     ftComboBox    : ExitKey := ComboBox^.ExitKey;
     ftCheckBoxes  : ExitKey := CheckBoxes^.ExitKey;
     ftRadioButtons: ExitKey := RadioButtons^.ExitKey;
     ftButtons     : ExitKey := Buttons^.ExitKey;
   END;
 END;

 PROCEDURE CheckHOTKeys;
 VAR I: Word; Found: Boolean;
 BEGIN
   Found := False;
   IF ShortCutOK THEN
   BEGIN
     FOR I := 0 TO Data^.Count-1 DO
     BEGIN
       DData := Data^.At(I);
       IF DData^.HOTKey = LastShortCut THEN BEGIN Found := True; Break; END;
     END;
     ExitKey := 0;
     IF Found
       THEN Current := I
       ELSE
          BEGIN
            FOR I := 0 TO Data^.Count-1 DO
            BEGIN
              DData := Data^.At(I);
              WITH DData^ DO
              BEGIN
                CASE FieldType OF
                 ftCheckBoxes  : BEGIN
                                   WITH CheckBoxes^ DO
                                   BEGIN
                                     R := CheckKey(LastShortCut,True);
                                     IF R <> 0 THEN
                                     BEGIN
                                       CurrentPOS := R;
                                       Mark(CurrentPOS);

                                       Current    := I;
                                       Break;
                                     END; {IF}
                                   END {WITH}
                                 END; {ftCheckBoxes}
                 ftRadioButtons: BEGIN
                                   WITH RadioButtons^ DO
                                   BEGIN
                                     R := CheckKey(LastShortCut,True);
                                     IF R <> 0 THEN
                                     BEGIN
                                       CurrentPOS := R;
                                       InVAR^     := R;

                                       Current    := I;
                                       Break;
                                     END; {IF}
                                   END; {WITH}
                                 END; {ftRadioButtons}
                      ftButtons: BEGIN
                                   WITH Buttons^ DO
                                   BEGIN
                                     R := CheckKey(LastShortCut,True);
                                     IF R <> 0 THEN
                                     BEGIN
                                       CurrentPOS := R;
                                       QuickExit  := True;
                                       Current    := I;
                                       Break;
                                     END; {IF}
                                   END; {WITH}
                                 END; {ftButtons}
                END; {CASE}
              END; {WITH}
            END; {FOR}
          END; {ELSE}
     ShortCutOK := False;
   END; {IF}
 END;

BEGIN
  IF FirstTime
    THEN BEGIN
           OpenWin(XPos,YPos,Width,Heigth,DialogPallette[_DialogBack],DialogPallette[_DialogTitle],BoxType,Title);
           FirstTime := False;
         END;
  DrawALL;
  IF StartFrom > Data^.Count-1 THEN Current := Data^.Count-1 ELSE Current := Pred(StartFrom);

  REPEAT
    DData := Data^.At(Current);
    WITH DData^ DO
    BEGIN
      CASE FieldType OF
        ftTxtInputLine,
        ftNumInputLine : InputLine^.Process;
        ftComboBox     : ComboBox^.Process;
        ftCheckBoxes   : CheckBoxes^.Process;
        ftRadioButtons : RadioButtons^.Process;
        ftButtons      : BEGIN Buttons^.Process; Process := Buttons^.CurrentPOS; END;
      END;
    END;
    GetExitKey;
    CheckHOTKeys;
    CASE ExitKey OF
      kbTab : IF Current = Data^.Count-1 THEN Current := 0 ELSE Inc(Current);
     kbSTab : IF Current = 0 THEN Current := Data^.Count-1 ELSE Dec(Current);
    END;
  UNTIL (ExitKey=kbEnter) OR (ExitKey=kbEsc);
  IF Current = Data^.Count-1 THEN Exit;

  DData := Data^.At(Data^.Count-1);
  WITH DDAta^ DO
  BEGIN
    IF ExitKey=kbEsc
        THEN BEGIN
               FOR R := 0 TO Buttons^.Count-1 DO
               BEGIN
                 Button := Buttons^.At(R);
                 IF Button^.btnType=btCancel THEN Break;
               END;
               Process := R+1;
             END
          ELSE BEGIN
                 Process := Buttons^.CurrentPOS;
                 DData^.Buttons^.QuickExit := True;
                 DData^.Buttons^.Process;
               END;
  END;
END;


CONSTRUCTOR TDialog.Init(AXPos,AYPos,
                         AWidth,AHeigth : Byte;
                         ADialogPAL     : TDialogPallettes;
                         ABoxType       : FrameStyle;
                         ATitle         : STRING);
BEGIN
  XPos       := AXPos;
  YPos       := AYPos;
  Width      := AWidth;
  Heigth     := AHeigth;
  BoxType    := ABoxType;
  Title      := ATitle;
  Data       := New(PDialogDataCollection, Init(1,1));
  ShortCutOK := False;
  FirstTime  := True;
  FillChar(ShortCuts,SizeOf(ShortCuts)+1,0);
  InitPallette(ADialogPAL);
  SaveCursor;
END;

DESTRUCTOR TDialog.Done;
BEGIN
  RmWin;
  Dispose(Data,Done);
  RestoreCursor;
END;


{ INITIALIZATION PART OF THE UNIT }
BEGIN
  InitPallette(DefaultDialogPAL);
END.
