{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ Copyright (C) 1995-96 By The GodFather }

UNIT GList;



INTERFACE



USES GUtils;



TYPE
  Pals       = (lDefaultPal,lPurplePal);
  PalRecords = (lBack,
                lTopic,lSelectedTopic,
                lBar,  lSelectedBar,
                lScroller,
                lFastFind);

  PList         = ^TList;
  TList         = OBJECT
     ListX      : Byte;
     ListY      : Byte;
     Lines      : Byte;
     MaxLines   : Byte;
     BarSize    : Byte;
     CurrentY   : Byte;
     MaxTopics  : Integer;
     SelectionON: Boolean;

     ScrollerON : Boolean;
     ScrollerX  : Byte;
     ScrollerY1 : Byte;
     ScrollerY2 : Byte;

     FastFindON : Boolean;
     FastFindX  : Byte;
     FastFindY  : Byte;

     LSTPosition: Integer;
     EndOfList  : Boolean;

     Pallette   : ARRAY[lBack..lFastFind] OF Byte;

     FUNCTION  __GetLine      (ListPos:Integer): STRING;              VIRTUAL;
     FUNCTION  __GetSelected  (ListPos:Integer): Boolean;             VIRTUAL;
     PROCEDURE __SetSelected  (ListPos:Integer; Selected:Boolean);    VIRTUAL;
     PROCEDURE __HookListKeys (ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
     PROCEDURE __IdleListCall (ListPos:Integer);                      VIRTUAL;
     PROCEDURE __EmptyList;                                           VIRTUAL;

     PROCEDURE WriteScroller;                                         VIRTUAL;
     PROCEDURE ChangeMaxTopics(aLines: Byte; aMaxTopics: Integer);
     PROCEDURE FastFind       (Key: Word);

     PROCEDURE ReDraw;
     PROCEDURE Process;

     CONSTRUCTOR Init(aListX       : Byte;
                      aListY       : Byte;
                      aBarSize     : Byte;
                      aLines       : Byte;
                      aMaxTopics   : Integer;
                      aSelectionON : Boolean;
                      aFastFindON  : Boolean;
                      aFastFindX   : Byte;
                      aFastFindY   : Byte;
                      aFastFindCHR : Char;
                      aScrollerON  : Boolean;
                      aScrollerX   : Byte;
                      aScrollerY1  : Byte;
                      aScrollerY2  : Byte;
                      aPallette    : Pals);
     DESTRUCTOR  Done;                                              VIRTUAL;

     PRIVATE
     FastFindCHR: Char;
     FastFindBUF: STRING[20];
     PROCEDURE PrintLine(ThisPosition:Integer; tmpY:Byte; IsBar:Boolean);
     PROCEDURE PrintTopics(FromPosition:Integer);
     PROCEDURE ClearUnused(CallEmptyList: Boolean);
     PROCEDURE KeyHook(VAR KeyPressed: Word);                       VIRTUAL;
  END;

  PBrowseList = ^TBrowseList;
  TBrowseList = OBJECT(TList)
     PROCEDURE WriteScroller;                                       VIRTUAL;
     PROCEDURE KeyHook(VAR KeyPressed: Word);                       VIRTUAL;
     CONSTRUCTOR Init(aBrowseX      : Byte;
                      aBrowseY      : Byte;
                      aBarSize      : Byte;
                      aLines        : Byte;
                      aMaxTopics    : Integer;
                      aScrollerON   : Boolean;
                      aScrollerX    : Byte;
                      aScrollerY1   : Byte;
                      aScrollerY2   : Byte );
     DESTRUCTOR Done;                                               VIRTUAL;
  END;


IMPLEMENTATION


FUNCTION TList.__GetLine(ListPos: Integer): STRING;
BEGIN
  __GetLine := 'Line '+IntToStr(ListPos);
END;

FUNCTION TList.__GetSelected(ListPos: Integer): Boolean;
BEGIN
  __GetSelected := False;
END;

PROCEDURE TList.__SetSelected(ListPos: Integer; Selected:Boolean);
BEGIN
END;

PROCEDURE TList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
BEGIN
END;

PROCEDURE TList.__IdleListCall(ListPos: Integer);
BEGIN
END;

PROCEDURE TList.__EmptyList;
BEGIN
END;

PROCEDURE TList.ChangeMaxTopics(aLines: Byte; aMaxTopics: Integer);
BEGIN
  MaxTopics := aMaxTopics;
  Lines     := aLines;
  MaxLines  := Lines;
  ReDraw;
END;

PROCEDURE TList.FastFind(Key:Word);
VAR
  Name    : STRING;
  Index   : Integer;
  FFLength: Byte;
  FoundIT : Boolean;
  tmpKey  : STRING[1];

BEGIN
  IF NOT FastFindON THEN Exit;
  IF Length(FastFindBUF) = 20 THEN Exit;
  IF ((Key < 33 ) OR (Key > 191)) THEN Exit;

  FoundIT    := False;
  FFLength   := Length(FastFindBUF)+1;

  tmpKey     := AdjCaseCyr(Upper, AdjCase(Upper,Chr(Key)));
  FastFindBUF:= Concat(FastFindBUF,tmpKey);

  FOR Index := 1 TO MaxTopics DO
  BEGIN
    Name := AdjCaseCyr(Upper, AdjCase(Upper, StripBoth(__GetLine(Index),' ')));
    Name := System.Copy(Name,1,FFLength);
    IF FastFindBUF = Name THEN FoundIT := True;
    IF FoundIT THEN Break;
  END;
  IF NOT FoundIT THEN
  BEGIN
    FastFindBUF[0] := Chr(FFLength-1);
    Exit;
  END;
  IF FoundIT THEN FastWrite(FastFindX,FastFindY,
                            Pallette[lFastFind],
                            PadLeft(FastFindBUF,20,FastFindCHR));
  IF (Index <> LSTPosition) AND FoundIT THEN
  BEGIN
    LSTPosition := Index;
    ReDraw;
  END;
END;

PROCEDURE TList.WriteScroller;
BEGIN
  WriteVScrollBar(ScrollerX,
                  ScrollerY1,ScrollerY2,
                  Pallette[lScroller],
                  LSTPosition,
                  MaxTopics);
END;

PROCEDURE TList.PrintLine(ThisPosition:Integer; tmpY:Byte; IsBar:Boolean);
VAR St: STRING; Attr: PalRecords; Index: Byte;
BEGIN
  IF IsBar THEN Attr := lBar ELSE Attr := lTopic;
  IF __GetSelected(ThisPosition) THEN Inc(Attr);

  St := __GetLine(ThisPosition);

  IF Length(St) > BarSize THEN St[0] := Chr(BarSize);
  IF Length(St) < BarSize THEN St    := St + Replicate(BarSize-Length(St),' ');

  FastWrite(ListX,Pred(ListY)+tmpY,Pallette[Attr],St);
END;

PROCEDURE TList.PrintTopics(FromPosition:Integer);
VAR Index,TempY: Integer; Dummy: Boolean;
BEGIN
  TempY := 1;
  FOR Index := FromPosition TO FromPosition+Pred(Lines) DO
  BEGIN
    IF TempY = CurrentY THEN Dummy := True ELSE Dummy := False;
    PrintLine(Index,tempY,Dummy);
    Inc(TempY);
    IF Index = MaxTopics THEN Break;
  END;
END;

PROCEDURE TList.ClearUnused(CallEmptyList: Boolean);
BEGIN
  ClearText(ListX,ListY,ListX+Pred(BarSize),ListY+Pred(MaxLines),Pallette[lBack]);
  IF CallEmptyList THEN __EmptyList;
END;

PROCEDURE TList.ReDraw;
VAR FromPosition: Integer;
BEGIN
{}IF (MaxLines < CurrentY)                                THEN CurrentY       := MaxLines;

  IF (MaxTopics = 0)                                      THEN BEGIN ClearUnused(True); Exit; END;
  IF (LSTPosition < MaxLines)                             THEN FromPosition   := 1
                                                            ELSE FromPosition := LSTPosition-Pred(CurrentY);
  IF (MaxTopics<=MaxLines)                                THEN Lines          := MaxTopics;
  IF ((MaxTopics<=MaxLines) AND (Lines<=CurrentY))        THEN CurrentY       := Lines;
  IF (FromPosition < 1)                                   THEN FromPosition   := 1;
  IF (FromPosition+Pred(Lines) > MaxTopics)               THEN FromPosition   := MaxTopics-Pred(Lines);
  IF (LSTPosition < 1)                                    THEN LSTPosition       := 1;
  IF (LSTPosition > MaxTopics)                            THEN LSTPosition       := MaxTopics;
  IF (LSTPosition-Pred(CurrentY)+Pred(Lines) > MaxTopics) THEN CurrentY       := Lines-(MaxTopics-LSTPosition);
  IF (LSTPosition < Lines)                                THEN CurrentY       := LSTPosition;
  IF Lines <> MaxLines                                    THEN ClearUnused(False);

  PrintTopics(FromPosition);
END;

PROCEDURE TList.KeyHook(VAR KeyPressed: Word);
BEGIN
END;

PROCEDURE TList.Process;
VAR
  Key: Word;

  PROCEDURE DisplayTopics(FromPosition: Integer);
  BEGIN
    IF (MaxTopics = 0)                        THEN BEGIN ClearUnused(True); Exit; END;
    IF (FromPosition < 1)                     THEN FromPosition := 1;
    IF (FromPosition+Pred(Lines) > MaxTopics) THEN FromPosition := MaxTopics-Pred(Lines);
    PrintTopics(FromPosition);
  END;

BEGIN
  ReDraw;
  REPEAT
    IF (ScrollerON AND (MaxTopics <> 0) ) THEN WriteScroller;
    __IdleListCall(LSTPosition);
    Key := GetKey;
    KeyHOOK(Key);
    __HookListKeys(LSTPosition,Key);

    IF ( (MaxTopics = 0) AND (Key <> kbEsc) ) THEN Key := 0;
    IF (Key = KbSpace) AND (SelectionON)
       THEN BEGIN
              Key := kbDown;
              __SetSelected(LSTPosition,NOT __GetSelected(LSTPosition));
              IF LSTPosition = MaxTopics THEN PrintLine(LSTPosition,CurrentY,True);
            END;
    IF (LSTPosition=1) AND ((Key=kbUp) OR (Key=kbPgUp) OR (Key=kbHome)) THEN Key := 0;
    IF (LSTPosition=MaxTopics) AND ((Key=kbDown) OR (Key=kbPgDn) OR (Key=kbEnd)) THEN Key := 0;
    IF ((Key < 33 ) OR (Key > 191)) AND (FastFindON) THEN
    BEGIN
      FastFindBUF := '';
      FastWrite(FastFindX,FastFindY,Pallette[lFastFind],Replicate(20,FastFindCHR));
    END;
    CASE Key OF
     33..191: FastFind(Key);
        kbUp: BEGIN
                IF CurrentY <> 1 THEN PrintLine(LSTPosition,CurrentY,False);
                Dec(LSTPosition);
                IF CurrentY <> 1
                  THEN Dec(CurrentY)
                  ELSE DisplayTopics(LSTPosition);
                PrintLine(LSTPosition,CurrentY,True);
              END;
      kbDown: BEGIN
                IF CurrentY <> Lines THEN PrintLine(LSTPosition,CurrentY,False);
                Inc(LSTPosition);
                IF CurrentY <> Lines
                  THEN BEGIN
                         Inc(CurrentY);
                         PrintLine(LSTPosition,CurrentY,True);
                       END
                  ELSE DisplayTopics(LSTPosition-Pred(Lines));
              END;
      kbPgUp: BEGIN
                CurrentY := 1;
                Dec(LSTPosition,Pred(Lines));
                IF (LSTPosition < 1) THEN LSTPosition := 1;
                DisplayTopics(LSTPosition);
              END;
      kbPgDn: BEGIN
                CurrentY := Lines;
                Inc(LSTPosition,Pred(Lines));
                IF (LSTPosition > MaxTopics) THEN LSTPosition := MaxTopics;
                DisplayTopics(LSTPosition-Pred(Lines));
              END;
      kbHome,
  kbCtrlPgUp: BEGIN
                CurrentY := 1;
                LSTPosition := 1;
                DisplayTopics(LSTPosition);
              END;
       kbEnd,
  kbCtrlPgDn: BEGIN
                CurrentY := Lines;
                LSTPosition := MaxTopics;
                DisplayTopics(LSTPosition);
              END;
      kbEsc: EndOfList:= True;
    END;
    IF (ScrollerON AND (MaxTopics <> 0) ) THEN WriteScroller;
  UNTIL EndOfList;
END;

CONSTRUCTOR TList.Init
                    ( aListX       : Byte;
                      aListY       : Byte;
                      aBarSize     : Byte;
                      aLines       : Byte;
                      aMaxTopics   : Integer;
                      aSelectionON : Boolean;
                      aFastFindON  : Boolean;
                      aFastFindX   : Byte;
                      aFastFindY   : Byte;
                      aFastFindCHR : Char;
                      aScrollerON  : Boolean;
                      aScrollerX   : Byte;
                      aScrollerY1  : Byte;
                      aScrollerY2  : Byte;
                      aPallette    : Pals );
BEGIN
  ListX       := aListX;
  ListY       := aListY;
  Lines       := aLines;
  MaxLines    := Lines;
  BarSize     := aBarSize;
  LSTPosition := 1;
  MaxTopics   := aMaxTopics;

  IF (LSTPosition <= Lines)       THEN CurrentY   := LSTPosition
                                    ELSE CurrentY := 1;
  IF (Pred(ListY)+Lines > MaxY)   THEN Lines      := MaxY-Pred(ListY);
  IF (Pred(ListX)+BarSize > MaxX) THEN BarSize    := MaxX-Pred(ListX);
  IF (Lines >= MaxTopics)         THEN Lines      := MaxTopics;

  SelectionON := aSelectionON;

  ScrollerON  := aScrollerON;
  ScrollerX   := aScrollerX;
  ScrollerY1  := aScrollerY1;
  ScrollerY2  := aScrollerY2;

  FastFindON  := aFastFindON;
  FastFindX   := aFastFindX;
  FastFindY   := aFastFindY;

  FastFindCHR := aFastFindCHR;
  FastFindBUF := '';

  EndOfList   := False;

  IF aPallette = lDefaultPal
    THEN BEGIN
           Pallette[lBack]          := $17;
           Pallette[lTopic]         := $17;
           Pallette[lSelectedTopic] := $1F;
           Pallette[lBar]           := $30;
           Pallette[lSelectedBar]   := $2F;
           Pallette[lScroller]      := $19;
           Pallette[lFastFind]      := $19;
         END
    ELSE BEGIN
           Pallette[lBack]          := $57;
           Pallette[lTopic]         := $57;
           Pallette[lSelectedTopic] := $5F;
           Pallette[lBar]           := $20;
           Pallette[lSelectedBar]   := $2F;
           Pallette[lScroller]      := $5D;
           Pallette[lFastFind]      := $5D;
         END;
END;

DESTRUCTOR TList.Done;
BEGIN
END;


{ ------------------------------------------------------------------------- }
{ ------------------------ TBrowse OBJECT PROCEDURES ---------------------- }
{ ------------------------------------------------------------------------- }

PROCEDURE TBrowseList.WriteScroller;
VAR Current: Integer;
BEGIN
  Current := LSTPosition;
  IF CurrentY > 1 THEN Dec(Current,Pred(Lines));
  WriteVScrollBar(ScrollerX,
                  ScrollerY1,ScrollerY2,
                  Pallette[lScroller],
                  Current,
                  MaxTopics-Pred(Lines));
END;

PROCEDURE TBrowseList.KeyHook(VAR KeyPressed: Word);
BEGIN
  IF (MaxLines <> Lines) AND
     ((KeyPressed=kbPgUp) OR
      (KeyPressed=kbPgDn)) THEN KeyPressed := 0;
  CASE KeyPressed OF
    kbPgUp: Dec(LSTPosition, Pred(Lines));
    kbPgDn: Inc(LSTPosition, Pred(Lines));
    kbUp  : BEGIN
              IF (Lines <= ListY) THEN BEGIN KeyPressed := 0; Exit; END;
              IF CurrentY <> 1
                THEN BEGIN
                       CurrentY := 1;
                       Dec(LSTPosition, Pred(Lines));
                     END;
            END;
    kbDown: BEGIN
              IF (Lines <= ListY) THEN BEGIN KeyPressed := 0; Exit; END;
              IF CurrentY <> Lines
                THEN BEGIN
                       CurrentY := Lines;
                       Inc(LSTPosition, Pred(Lines));
                     END;
            END;
  END;
END;

CONSTRUCTOR TBrowseList.Init(aBrowseX   : Byte;
                             aBrowseY   : Byte;
                             aBarSize   : Byte;
                             aLines     : Byte;
                             aMaxTopics : Integer;
                             aScrollerON: Boolean;
                             aScrollerX : Byte;
                             aScrollerY1: Byte;
                             aScrollerY2: Byte );
BEGIN
  INHERITED Init( aBrowseX,
                  aBrowseY,
                  aBarSize,
                  aLines,
                  aMaxTopics,
                  False,False,0,0,#0,
                  aScrollerON,
                  aScrollerX,
                  aScrollerY1,
                  aScrollerY2,
                  lDefaultPal );
  FillChar(Pallette,SizeOf(Pallette),$20);
  Pallette[lScroller] := $2A;
END;

DESTRUCTOR TBrowseList.Done;
BEGIN
END;

END.
