{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

UNIT GMenus2;

INTERFACE


USES GUtils, GMemory;


TYPE
  TDispacher = PROCEDURE(Position:Byte);
  TOnQuit    = PROCEDURE;

  PMenu = ^TMenu;
  TMenu = RECORD
    Name     : PString;
    XPos     : Byte;
    YPos     : Byte;

    Width    : Byte;

    BoxAttr  : Byte;

    MenuAttr : Byte;
    MenuAttr2: Byte;
    BarAttr  : Byte;
    BarAttr2 : Byte;

    NameAttr : Byte;
    CurPos   : Byte;
    Topics   : ARRAY[1..25] OF PString;
    Count    : Byte;
    QuitTime : Boolean;
    Dispacher: TDispacher;
    OnQuit   : TOnQuit;
  END;



PROCEDURE NewMenu(VAR Menu:PMenu);
PROCEDURE DisposeMenu(VAR Menu:PMenu);
PROCEDURE RunMenu(VAR Menu:PMenu);



IMPLEMENTATION


PROCEDURE StdDispacher(Position:Byte);
BEGIN
END;


PROCEDURE StdOnQuit;
BEGIN
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE NewMenu(VAR Menu:PMenu);
BEGIN
  New(Menu);
  FillMem(Menu^,SizeOf(TMenu),0);
  WITH Menu^ DO
  BEGIN
    CurPos   := 1;
    QuitTime := False;
    Dispacher:= StdDispacher;
    OnQuit   := StdOnQuit;
  END;
END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE DisposeMenu(VAR Menu:PMenu);
VAR Index:Byte;
BEGIN
  WITH Menu^ DO
  BEGIN
    DisposeStr(Name);
    FOR Index := 1 TO Count DO DisposeStr(Topics[Index]);
    Dispose(Menu);
  END
END;



{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE RunMenu(VAR Menu:PMenu);
VAR Key:Word;

  PROCEDURE WriteTopic(TPos,Attr,Attr2:Byte);
  VAR MinWidth:Byte;
  BEGIN
    WITH Menu^ DO
    BEGIN
      MinWidth := 4;
      IF TPos > 9 THEN MinWidth := 5;
      WriteHi(XPos+1,YPos+TPos,Attr,Attr2,' ~'+IntToStr(TPos)+'~ '+PadLeft(Topics[TPos]^,Width-MinWidth,' '));
    END;
  END;

  PROCEDURE SetCurPos(CPos:Byte);
  BEGIN
    WITH Menu^ DO
    BEGIN
      CurPos := CPos;
      WriteTopic(CPos,BarAttr,BarAttr2);
    END;
  END;

BEGIN
  WITH Menu^ DO
  BEGIN
    QuitTime := False;
    MkWin(XPos,YPos-2,Width,Count+3,BoxAttr,cyrSingle,'');
    HLine(XPos+1,XPos+Pred(Width),YPos,BoxAttr,SingleLine);
    WriteBetween(XPos+1,XPos+Pred(Width),YPos-1,NameAttr,Name^);

    FOR Key := 1 TO Count DO WriteTopic(Key,MenuAttr,MenuAttr2);

    WriteTopic(CurPos,BarAttr,BarAttr2);
    REPEAT
      Key := GetKey;

      IF Key=Ord('+') THEN Key := kbEnter;
      IF Key=Ord('-') THEN Key := kbEsc;

      WriteTopic(CurPos,MenuAttr,MenuAttr2);
      CASE Key OF
        kbUp: BEGIN
                Dec(CurPos);
                IF CurPos < 1 THEN CurPos := Count;
              END;
      kbDown: BEGIN
               Inc(CurPos);
               IF CurPos > Count THEN CurPos := 1;
              END;
      kbHome: CurPos := 1;
       kbEnd: CurPos := Count;
     kbEnter: BEGIN
                WriteTopic(CurPos,BarAttr,BarAttr2);
                Dispacher(CurPos);
              END;
       kbEsc: QuitTime := True;
      49..57: IF Key-48 <= Count THEN
              BEGIN
                SetCurPos(Key - 48);
                WriteTopic(CurPos,BarAttr,BarAttr2);
                Dispacher(CurPos);
              END;
      END;
      SetCurPos(CurPos);
      IF QuitTime THEN
        IF @OnQuit <> NIL THEN OnQuit;
    UNTIL QuitTime = True;
    RmWin;
  END;
END;



END.
