{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ GF's TURBO UTILITY KIT Version 4.4 }
{ DPMI Compatible / Date 15-03-1997 }
{ SHARE Compatible / Date 27-05-1997 }
{ Copyright (C) 1994-97 By The GodFather }

UNIT GUtils;


INTERFACE


USES Dos;


{ͻ}
{ TYPES }
{ͼ}
TYPE
  {PALLETTE}
  PalARRAY = ARRAY[0..$F+1] OF Byte;
  {FONT}
  Char8x16 = ARRAY[0..15] OF Byte;
  Font8x16 = ARRAY[0..255] OF Char8x16;
  {MISC}
  CharWidth   = (EGAWidth, VGAWidth);
  TCase       = (Upper,Lower,ProperNorm,ProperFull,Flip);
  LineStyle   = (SingleLine, DoubleLine, cyrSingleLine, cyrDoubleLine);
  TCursorType = (On, Off, Half, Full);
  FrameStyle  = (NoFrame  , Thick,
                 Bold1    , Bold2,
                 Single1  , Double1,
                 Special1 , Special2,
                 cyrSingle, cyrDouble);
{ Direction   = (Up, Down, Left, Right);}
  {KEYBOARD}
  KBChars     = ARRAY[1..60] OF Char;
  {FILES}
  TShareMethod  = (Compatible, DenyBoth, DenyRead, DenyWrite, DenyNone);
  TAccessMethod = (AccessRead, AccessWrite, AccessReadWrite);
  {PRINTER}
  PrnStatus   = (prnOK,prnNoPaper,prnOffLine,prnBusy,prnUnknown);
  {MOUSE}
  MouseCursorARRAY = ARRAY[1..32] OF Word;
  TMouseButtons  = (btnLeft,btnRight,btnMiddle);
  TButtonState   = (Pressed,Released);
  TMouseDirection= (MoveLEFT,MoveRIGHT,MoveUP,MoveDOWN,NoMove);
  TMouseStatus   = RECORD
    LeftButton,
    RightButton,
    MiddleButton : TButtonState;
    MouseX,MouseY: Integer;
  END;
  {USED BY EncodeStr AND DecodeStr}
  eString    = STRING[127];
  {USED BY WriteHVScrollBar}
  TScrollBar = RECORD
    LeftChar    : Char;
    RightChar   : Char;
    UpChar      : Char;
    DownChar    : Char;
    BackChar    : Char;
    ElevatorChar: Char;
  END;

  TaskerRec = RECORD
    OS      : Word;
    Version : Word;
  END;




{ͻ}
{ CONSTANTS }
{ͼ}
CONST {COLOR CONSTANTS}
  Black       = $00;   DarkGray    = $08;
  Blue        = $01;   LightBlue   = $09;
  Green       = $02;   LightGreen  = $0A;
  Cyan        = $03;   LightCyan   = $0B;
  Red         = $04;   LightRed    = $0C;
  Magenta     = $05;   LightMagenta= $0D;
  Brown       = $06;   Yellow      = $0E;
  LightGray   = $07;   White       = $0F;

  Mono        = $07;   Blink       = $80;

CONST {BoxDrawingChars}
  LineChars   : ARRAY[LineStyle,1..2] OF Char = ('ĳ', 'ͺ', '', '');
  BoxChars    : ARRAY[FrameStyle,1..7] OF Char =
    ('       ',     { NO FRAME }
     '++++--|',     {-------------------------------------------}
     '',     {  +- THICK -+  SINGLE Ŀ  SPECIAL 1 ķ }
     '',     {  |         |                          }
                    {  +---------+  Ľ }
     'ڿĳ',     {               DOUBLE ͻ  SPECIAL 2 ͸ }
     'ɻȼͺ',     {                                       }
                    {              ͼ ; }
     'ַӽĺ',     {               BOLD1    BOLD2   }
     'ոԾͳ',     {                                       }
                    {                  }
     '',     {===========================================}
     '');


CONST {KEYBOARD CODES}
  kbEnter       = 13;
  kbSpace       = 32;
  kbEsc         = 27;

  kbIns         = 20992;
  kbDel         = 21248;
  kbsTab        = 3840;
  kbCtrlPS      = 29184;

  kbTab         = 60000;
  kbAltSpace    = 60001;
  kbBSpace      = 60002;
  kbCtrlBSpace  = 60003;
  kbCtrlM       = 60004;

  kbCtrlA       = 1;    kbAltA  = 7680;         kbAlt1          = 30720;
  kbCtrlB       = 2;    kbAltB  = 12288;        kbAlt2          = 30976;
  kbCtrlC       = 3;    kbAltC  = 11776;        kbAlt3          = 31232;
  kbCtrlD       = 4;    kbAltD  = 8192;         kbAlt4          = 31488;
  kbCtrlE       = 5;    kbAltE  = 4608;         kbAlt5          = 31744;
  kbCtrlF       = 6;    kbAltF  = 8448;         kbAlt6          = 32000;
  kbCtrlG       = 7;    kbAltG  = 8704;         kbAlt7          = 32256;
  kbCtrlH       = 8;    kbAltH  = 8960;         kbAlt8          = 32512;
  kbCtrlI       = 9;    kbAltI  = 5888;         kbAlt9          = 32768;
  kbCtrlJ       = 10;   kbAltJ  = 9216;         kbAlt0          = 33024;
  kbCtrlK       = 11;   kbAltK  = 9472;         kbAltMinus      = 33280;
  kbCtrlL       = 12;   kbAltL  = 9728;         kbAltEqual      = 33536;
                        kbAltM  = 12800;
  kbCtrlN       = 14;   kbAltN  = 12544;
  kbCtrlO       = 15;   kbAltO  = 6144;
  kbCtrlP       = 16;   kbAltP  = 6400;
  kbCtrlQ       = 17;   kbAltQ  = 4096;
  kbCtrlR       = 18;   kbAltR  = 4864;
  kbCtrlS       = 19;   kbAltS  = 7936;
  kbCtrlT       = 20;   kbAltT  = 5120;
  kbCtrlU       = 21;   kbAltU  = 5632;
  kbCtrlV       = 22;   kbAltV  = 12032;
  kbCtrlW       = 23;   kbAltW  = 4352;
  kbCtrlX       = 24;   kbAltX  = 11520;
  kbCtrlY       = 25;   kbAltY  = 5376;
  kbCtrlZ       = 26;   kbAltZ  = 11264;

  kbF1          = 15104; kbsF1  = 21504; kbCtrlF1       = 24064; kbAltF1        = 26624;
  kbF2          = 15360; kbsF2  = 21760; kbCtrlF2       = 24320; kbAltF2        = 26880;
  kbF3          = 15616; kbsF3  = 22016; kbCtrlF3       = 24576; kbAltF3        = 27136;
  kbF4          = 15872; kbsF4  = 22272; kbCtrlF4       = 24832; kbAltF4        = 27392;
  kbF5          = 16128; kbsF5  = 22528; kbCtrlF5       = 25088; kbAltF5        = 27648;
  kbF6          = 16384; kbsF6  = 22784; kbCtrlF6       = 25344; kbAltF6        = 27904;
  kbF7          = 16640; kbsF7  = 23040; kbCtrlF7       = 25600; kbAltF7        = 28160;
  kbF8          = 16896; kbsF8  = 23296; kbCtrlF8       = 25856; kbAltF8        = 28416;
  kbF9          = 17152; kbsF9  = 23552; kbCtrlF9       = 26112; kbAltF9        = 28672;
  kbF10         = 17408; kbsF10 = 23808; kbCtrlF10      = 26368; kbAltF10       = 28928;

  kbLeft        = 19200; kbCtrlLeft     = 29440;
  kbRight       = 19712; kbCtrlRight    = 29696;
  kbUp          = 18432;
  kbDown        = 20480;
  kbPgUp        = 18688; kbCtrlPgUp     = 33792;
  kbPgDn        = 20736; kbCtrlPgDn     = 30208;
  kbEnd         = 20224; kbCtrlEnd      = 29952;
  kbHome        = 18176; kbCtrlHome     = 30464;



{ͻ}
{ TYPED CONSTANTS }
{ͼ}
CONST {KEYBOARD}
  DOS_BG_CHARS:KBChars = '';
  WIN_BG_CHARS:KBChars = '';
  DOS_US_CHARS:KBChars = 'ABWGDEVZIJKLMNOPRSTUFHC~{}YX|Qabwgdevzijklmnoprstufhc`[]yx\q';

CONST {PALLETTE}
  OrgPAL:PalARRAY = ($00,$01,$02,$03,$04,$05,$14,$07,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$00);
  AltPAL:PalARRAY = ($00,$08,$4A,$4F,$04,$28,$30,$07,$38,$91,$3A,$3B,$3C,$85,$3E,$3F,$00);

CONST {WINDOWS}
  WinShadow    : Boolean = True;  {Does the windows have shadow}
  WindowCount  : Word    = 0;     {The number of opened windows}
  ShadColor    : Byte    = $08;   {Color attribute for the window shadow}
  GrowWindow   : Boolean = False; {Use GrowFBox instead of FBox routine}
  DelayRatio   : Word    = 10;    {Delay factor for GrowBox routine}

CONST {MISC}
  WaitVRetrace : Boolean = True; {Used by GetFontAccess & ReleaseFontAccess}
  ScrollBar    : TScrollBar =    {DEFAULT definitions for WriteHVScrollBar}
  (LeftChar:#27;  RightChar:#26;
   UpChar:#24;    DownChar:#25;
   BackChar:#176;
   ElevatorChar:#219);
  MouseInstalled: Boolean = False;{Indicates whether mouse driver is installed}

CONST {KEYBOARD}
  IdleHook     : Pointer = NIL;   {This is called by GetKey until key is pressed}
  PressedHook  : Pointer = NIL;   {When key is pressed then GetKey call this}


CONST {MULTITASKING}
  NoTasker  = 0;
  Windows   = 1;
  OS2       = 2;
  DesQView  = 3;
  TopView   = 4;
  DoubleDOS = 5;

  Tasker    : TaskerRec =
   (OS      : NoTasker; { Call first - InitMultitasking to get correct value}
    Version : 0);       { Writeln('Version ',Hi(Version),'.',Lo(Version)); }



{ͻ}
{ VARIABLES }
{ͼ}
VAR {SCREEN}
  BaseOfScreen  : Word;          {Base address of video memory}
  VSeg,VOfs     : Word;          {Base address of active screen}
  CheckSnow     : Boolean;       {Check for snow on color cards?}
  StartMode     : Byte;          {Startup video mode}

{ !!! DO NOT USE THESE IN Protected MODE !!!}
VAR {BIOS}
  Timer         : LongInt ABSOLUTE $0040:$006C; {BIOS Timer counter}
  CurrentMode   : Byte    ABSOLUTE $0040:$0049; {Containts current video mode}
  CharHeight    : Byte    ABSOLUTE $0040:$0085; {Current char height}

VAR {MOUSE}
  MouseStatus   : TMouseStatus;  {CONSTANTLY UPDATED !!! READ THIS VAR !!!}



{ͻ}
{ PROCEDURE & FUNCTIONS }
{ͼ}
    {MISC}
{a} FUNCTION  Attr              (Fore,Back:Byte): Byte;
{a} FUNCTION  FAttr             (Attr:Byte): Byte;
{a} FUNCTION  BAttr             (Attr:Byte): Byte;
{ } FUNCTION  RetPercent        (Num,Max,Current:LongInt): Integer;
{a} PROCEDURE ReBoot            (ColdBoot:Boolean);

{a} PROCEDURE Wait              (Num:Word);
{a} PROCEDURE Delay             (Ms:Word);
{a} PROCEDURE Sound             (Hz:Word);
{a} PROCEDURE NoSound;

{ } PROCEDURE InitClock         (X,Y,Color:Byte);
{ } PROCEDURE DoneClock;

    {INSTALLED?}
{a} FUNCTION  ShareInstalled    : Boolean; INLINE ($B8/$00/$10/$CD/$2F);

    {MULTITASKING}
{a} PROCEDURE GiveUpTimeSlice;
{a} PROCEDURE InitMultiTasking;

    {VIDEO}
{a} FUNCTION  ColorScreen       : Boolean;
{a} FUNCTION  VGASystem         : Boolean;
{a} FUNCTION  EGASystem         : Boolean;
{a} FUNCTION  EGAVGASystem      : Boolean;

{$IFNDEF DPMI}
{a} FUNCTION  MaxX              : Byte; INLINE($31/$C0/$8E/$C0/$26/$A0/$044A);
{a} FUNCTION  MaxY              : Byte; INLINE($31/$C0/$8E/$C0/$26/$A0/$0484/$FE/$C0);
{$ELSE}
{a} FUNCTION  MaxX              : Byte;
{a} FUNCTION  MaxY              : Byte;
{$ENDIF}

{a} FUNCTION  GetVideoMode      : Byte; INLINE($B8/$00/$0F/$CD/$10);
{a} PROCEDURE SetVideoMode      (Mode:Byte);
{a} PROCEDURE SetBlink          (On:Boolean);
{a} PROCEDURE GrayScale         (On:Boolean);
{ } PROCEDURE SetCharWidth      (CWidth:CharWidth);
{a} PROCEDURE VGAScreenOff;
{a} PROCEDURE VGAScreenOn;

    {PALLETTE}
{a} PROCEDURE SetBorderColor    (Color:Byte);
{a} FUNCTION  GetPALReg         (Color:Byte): Byte;
{a} PROCEDURE SetPALReg         (Color,Value:Byte);
{a} PROCEDURE GetPAL            (VAR PAL:PalARRAY);
{a} PROCEDURE SetPAL            (CONST PAL:PalARRAY);
{a} PROCEDURE SetVgaDac         (Color,Red,Green,Blue:Byte);
{a} PROCEDURE GetVgaDac         (Color:Byte; VAR Red,Green,Blue:Byte);

    {DIRECT SCREEN WRITING}
{a} PROCEDURE FastWrite         (X,Y,Attr:Byte; StrOut:STRING);
{a} PROCEDURE PlainWrite        (X,Y:Byte; StrOut:STRING);
{a} PROCEDURE Attribute         (X,Y,Attr:Byte; Number:Word);
{ } PROCEDURE WriteHi           (X,Y,NormAttr,HiAttr:Byte; St:STRING);
{ } PROCEDURE WriteVert         (X,Y,Attr:Byte; St:STRING);
{ } PROCEDURE WriteFill         (X,Y,Attr,ToLength:Byte; Fill:Char; St:STRING);
{ } PROCEDURE WriteBack         (XEnd,Y,Attr:Byte; St:STRING);
{ } PROCEDURE WriteCenter       (LineNO,Attr:Byte; St:STRING);
{ } PROCEDURE WriteBetween      (X1,X2,Y,Attr:Byte; St:STRING);
{ } PROCEDURE WriteVScrollBar   (X,Y1,Y2,Attr:Byte; Current,Max:Longint);
{ } PROCEDURE WriteHScrollBar   (X1,X2,Y,Attr:Byte; Current,Max:Longint);

    {CLEAR SCREEN}
{ } PROCEDURE ClrScr            (Attr:Byte);
{ } PROCEDURE ClearAttr         (X1,Y1,X2,Y2,Attr:Byte);
{ } PROCEDURE ClearText         (X1,Y1,X2,Y2,Attr:Byte);
{ } PROCEDURE ClearLine         (Y,Attr:Byte);
{ } PROCEDURE FillScreen        (X1,Y1,X2,Y2,Attr:Byte; C:Char);
{a} PROCEDURE ScrollUP          (X1,Y1,X2,Y2,NumLines,Attr:Byte);
{a} PROCEDURE ScrollDOWN        (X1,Y1,X2,Y2,NumLines,Attr:Byte);
{ }{PROCEDURE Scroll            (Way:Direction;X1,Y1,X2,Y2:byte; ReplaceChar:Char);}

    {LINE DRAWING}
{ } PROCEDURE HLine             (X1,X2,Y,Attr:Byte; LType:LineStyle);
{ } PROCEDURE VLine             (X,Y1,Y2,Attr:Byte; LType:LineStyle);
{ } PROCEDURE SmartHLine        (X1,X2,Y,Attr:Byte; LType:LineStyle);
{ } PROCEDURE SmartVLine        (X,Y1,Y2,Attr:Byte; LType:LineStyle);

    {BOX DRAWING}
{ } PROCEDURE Box               (X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);
{ } PROCEDURE FBox              (X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);
{ } PROCEDURE GrowFBox          (X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);

    {FAST MEMORY ROUTINES}
{a} FUNCTION  CompMem           (VAR Source,Dest; Count:Word):Boolean;
{a} FUNCTION  ScanMem           (VAR Dest; Count:Word; Num:Byte):Word;
{a} PROCEDURE MoveMem           (VAR Source,Dest; Count:Word);
{a} PROCEDURE FillMem           (VAR Dest; Count:Word; Num:Byte);

    {DIRECT BLOCK SCREEN READ&WRITE}
{a} PROCEDURE MoveFromScreen    (VAR Source,Dest; Count:Word);
{a} PROCEDURE MoveToScreen      (VAR Source,Dest; Count:Word);
{ } PROCEDURE PartSave          (X1,Y1,X2,Y2:Byte; VAR Dest);
{ } PROCEDURE PartRestore       (X1,Y1,X2,Y2:Byte; VAR Source);
{ } PROCEDURE CopyScreenBlock   (X1,Y1,X2,Y2,X,Y:Byte);
{ } PROCEDURE MoveScreenBlock   (X1,Y1,X2,Y2,X,Y:Byte; ReplaceChar:Char);
{ } PROCEDURE GetScreenWord     (X,Y:Byte;VAR Attr:Byte; VAR Ch:Char);
{ } FUNCTION  GetScreenChar     (X,Y:Byte): Char;
{ } FUNCTION  GetScreenAttr     (X,Y:Byte): Byte;
{ } FUNCTION  GetScreenStr      (X1,X2,Y:Byte): STRING;

    {CURSOR}
{a} PROCEDURE SaveCursor;
{a} PROCEDURE RestoreCursor;

{a} FUNCTION  GetCursorTop      : Byte;
{a} FUNCTION  GetCursorBottom   : Byte;
{a} PROCEDURE GetCursorSize     (VAR Top,Bottom:Byte);
{a} PROCEDURE SetCursorSize     (Top,Bottom:Byte);

{a} FUNCTION  WhereX            : Byte;
{a} FUNCTION  WhereY            : Byte;
{a} PROCEDURE GetCursorPos      (VAR X,Y:Byte);
{a} PROCEDURE PosCursor         (X,Y:Byte);

{ } PROCEDURE Cursor            (CursorType:TCursorType);

    {TEXT FONTS}
{a} PROCEDURE Load8x8;
{a} PROCEDURE Load8x14;
{a} PROCEDURE Load8x16;

{a} PROCEDURE GetFontAccess;
{a} PROCEDURE ReleaseFontAccess;
{a} PROCEDURE OneFontOnScreen;
{a} PROCEDURE TwoFontsOnScreen;

{a} PROCEDURE SetFont8x16       (Table:Byte; VAR Font:Font8x16);
{a} PROCEDURE GetFont8x16       (Table:Byte; VAR Font:Font8x16);
{a} PROCEDURE ResetFont8x16     (Table:Byte);

{a} PROCEDURE SetChar8x16       (Table,CharNum:Byte; VAR BitMap:Char8x16);
{a} PROCEDURE GetChar8x16       (Table,CharNum:Byte; VAR BitMap:Char8x16);

{a} PROCEDURE BIOSLoadFont      (CONST Font:Font8x16);

{ } PROCEDURE Set25Lines;
{ } PROCEDURE SetNormalLines;
{ } PROCEDURE SetCondensedLines;


    {WINDOWS}
{ } PROCEDURE MkWin             (AXPos,AYPos         : Byte;
                                 AWidth,AHeigth      : Byte;
                                 AFrameAttr          : Byte;
                                 ABoxType            : FrameStyle;
                                 ATitle              : STRING);

{ } PROCEDURE OpenWin           (AXPos,AYPos         : Byte;
                                 AWidth,AHeigth      : Byte;
                                 ANormAttr,ATitleAttr: Byte;
                                 ABoxType            : FrameStyle;
                                 ATitle              : STRING);
{ } PROCEDURE RmWin;

    {KEYBOARD}
{a} FUNCTION  AltPressed        : Boolean;
{a} FUNCTION  CtrlPressed       : Boolean;
{a} FUNCTION  ShiftPressed      : Boolean;
{a} FUNCTION  LeftShiftPressed  : Boolean;
{a} FUNCTION  RightShiftPressed : Boolean;

{a} FUNCTION  CapsOn            : Boolean;
{a} FUNCTION  NumOn             : Boolean;
{a} FUNCTION  ScrollOn          : Boolean;

{a} PROCEDURE SetCaps           (On:Boolean);
{a} PROCEDURE SetNum            (On:Boolean);
{a} PROCEDURE SetScroll         (On:Boolean);

{a} FUNCTION  ReadKey           : Word;
{a} FUNCTION  KeyPressed        : Boolean;
{a} PROCEDURE PressKey          (Key:Word);

{ } FUNCTION  GetKey            : Word;
{ } FUNCTION  Translate         (CONST Source,Dest:KBChars; Symbol:Char): Char;
{ } PROCEDURE TranslateStr      (CONST Source,Dest:KBChars; VAR S:STRING);
{ } FUNCTION  NormalChar        (AltKey:Word): Char;

{ } PROCEDURE Pause;
{ } PROCEDURE ClearKBuffer;
{a} PROCEDURE MaxKeyboardSpeed;
{ } PROCEDURE DelayKey          (Time:Byte);

    {MOUSE}
{ } PROCEDURE InitMouse;

{a} PROCEDURE ResetMouse;                  INLINE($B8/$00/$00/$CD/$33);
{a} PROCEDURE ShowMouse;                   INLINE($B8/$01/$00/$CD/$33);
{a} PROCEDURE HideMouse;                   INLINE($B8/$02/$00/$CD/$33);
{a} PROCEDURE EmulateLightPenON;           INLINE($B8/$0D/$00/$CD/$33);
{a} PROCEDURE EmulateLightPenOFF;          INLINE($B8/$0E/$00/$CD/$33);
{a} FUNCTION  MouseVersion                 : Word;

{a} FUNCTION  GetMouseX                    : Integer;
{a} FUNCTION  GetMouseY                    : Integer;
{a} PROCEDURE GetMouseXY                   (VAR X,Y:Integer);
{a} PROCEDURE SetMouseXY                   (X,Y:Integer);
{a} FUNCTION  MouseButtonPressed           : Boolean;
{ } FUNCTION  GetMouseButton               (Button:TMouseButtons): TButtonState;
{ } PROCEDURE GetMouseStatus               (VAR InVAR:TMouseStatus);

{a} FUNCTION  LastXPress                   (Button:TMouseButtons): Word;
{a} FUNCTION  LastXRelease                 (Button:TMouseButtons): Word;
{a} FUNCTION  LastYPress                   (Button:TMouseButtons): Word;
{a} FUNCTION  LastYRelease                 (Button:TMouseButtons): Word;
{a} FUNCTION  MouseButtonPresses           (Button:TMouseButtons): Word;
{a} FUNCTION  MouseButtonReleases          (Button:TMouseButtons): Word;
{a} FUNCTION  LastXMovement                : TMouseDirection;
{a} FUNCTION  LastYMovement                : TMouseDirection;

{a} PROCEDURE SetMinMaxX                   (Min,Max:Integer);
{a} PROCEDURE SetMinMaxY                   (Min,Max:Integer);
{a} PROCEDURE SetMouseBox                  (X1,Y1,X2,Y2:Integer);

{a} PROCEDURE HardwareMouseCursor          (FromLine,ToLine:Word);
{a} PROCEDURE SoftwareMouseCursor          (ScreenMasc,CursorMasc:Word);
{a} PROCEDURE SetMouseSensetivity          (X,Y:Word);
{a} PROCEDURE SetEventHandler              (Masc:Word; NewHandler:Pointer);

{a} PROCEDURE SetGraphicMouseCursor        (HotSpotX,HotSpotY:Integer;
                                            VAR CursorBitMAP:MouseCursorARRAY);
{ } PROCEDURE SetWatchMouseCursor;
{ } PROCEDURE SetHourglassMouseCursor;
{ } PROCEDURE SetUpArrowCursor;
{ } PROCEDURE SetCheckMarkCursor;
{ } PROCEDURE SetDiagonalCrossCursor;
{ } PROCEDURE SetRectangularCrossCursor;
{ } PROCEDURE SetPointingHandCursor;

    {STRINGS}
{a} FUNCTION  Replicate         (Number:Byte; Character:Char): STRING;
{ } FUNCTION  Frequency         (Match:STRING; Source:STRING): Byte;
{a} FUNCTION  CompareStr        (NameStr,SearchStr:STRING): Boolean;
{a} FUNCTION  EmptyStr          (Str:STRING): Boolean;
{ } FUNCTION  CurrentTime       : STRING;
{ } FUNCTION  CurrentDate       : STRING;

{ } FUNCTION  EncodeStr         (StrIn:eString): STRING;
{ } FUNCTION  DecodeStr         (StrIn:STRING): eString;

{a} FUNCTION  IsLower           (C:Char): Boolean;
{a} FUNCTION  IsUpper           (C:Char): Boolean;
{a} FUNCTION  IsDigit           (C:Char): Boolean;
{a} FUNCTION  IsAlpha           (C:Char): Boolean;
{a} FUNCTION  IsAlNum           (C:Char): Boolean;

{a} FUNCTION  LastPos           (AChar:Char; Str:STRING): Byte;
{a} FUNCTION  FirstUpperPos     (Str:STRING): Byte;
{a} FUNCTION  FirstLowerPos     (Str:STRING): Byte;
{a} FUNCTION  FirstUpperChar    (Str:STRING): Char;
{a} FUNCTION  FirstLowerChar    (Str:STRING): Char;

{a} FUNCTION  PadLeft           (Str:STRING; Size:Byte; Pad:Char): STRING;
{a} FUNCTION  PadRight          (Str:STRING; Size:Byte; Pad:Char): STRING;
{ } FUNCTION  PadCenter         (Str:STRING; Size:Byte; Pad:Char): STRING;

{ } FUNCTION  Last              (N:Byte; Str:STRING): STRING;
{ } FUNCTION  First             (N:Byte; Str:STRING): STRING;

{a} FUNCTION  AdjCase           (AdjTo:TCase; Str:STRING): STRING;
{ } FUNCTION  AdjCaseCyr        (AdjTo:TCase; Str:STRING): STRING;

{ } FUNCTION  StripLeft         (Str:STRING; C:Char): STRING;
{ } FUNCTION  StripRight        (Str:STRING; C:Char): STRING;
{ } FUNCTION  StripBoth         (Str:STRING; C:Char): STRING;
{ } FUNCTION  StripAll          (Str:STRING; C:Char): STRING;
{a} FUNCTION  ReplaceChar       (Str:STRING; Old,New:Char): STRING;

{ } FUNCTION  PosWord           (WordNO:Byte; Str:STRING): Byte;
{ } FUNCTION  WordCnt           (Str:STRING): Byte;
{ } FUNCTION  ExtractWords      (StartWord,NoWords:Byte; Str:STRING): STRING;
{ } PROCEDURE OverWrite         (OverPos:Byte; VAR Source:STRING; OverStr:STRING);

{ } FUNCTION  AddComas          (This: LongInt): STRING;
{ } FUNCTION  HexToDec          (HexString: STRING): LongInt;
{ } FUNCTION  DecToHex          (Number: Longint): STRING;
{ } FUNCTION  PtrToHex          (P:Pointer): STRING;
{ } FUNCTION  StrToInt          (Str:STRING): LongInt;
{ } FUNCTION  StrToReal         (Str:STRING): Real;
{ } FUNCTION  RealToStr         (Number:Real; Decimals:Byte): STRING;
{ } FUNCTION  IntToStr          (Number:Longint): STRING;
{ } FUNCTION  RealToSciStr      (Number:Real; D:Byte): STRING;

    {FILES}
{a} PROCEDURE SaveFilemode;
    PROCEDURE SetFileMode       (ShareMethod:TShareMethod;
                                 AccessMethod:TAccessMethod);
{a} PROCEDURE RestoreFilemode;

{ } FUNCTION  PathOnly          (FileName:STRING): STRING;
{ } FUNCTION  NameOnly          (FileName:STRING): STRING;
{ } FUNCTION  BaseNameOnly      (FileName:STRING): STRING;
{ } FUNCTION  ExtOnly           (FileName:STRING): STRING;
{a} FUNCTION  AddSlash          (Str:STRING): STRING;
{a} FUNCTION  StripSlash        (Str:STRING): STRING;

{a} FUNCTION  TextFilePos       (VAR F:Text): LongInt;
{a} FUNCTION  TextFileSize      (VAR F:Text): LongInt;
{a} PROCEDURE TextSeek          (VAR F:Text; Pos:LongInt);

{ } FUNCTION  Exist             (FileName:STRING): Boolean; { Wildcards allowed }
{ } FUNCTION  DirExist          (Dir:STRING): Boolean;
{ } FUNCTION  MakeDir           (Dir:STRING; ChangeDir:Boolean):Boolean;

{ } FUNCTION  FindFile          (VAR FileName:STRING): Boolean;
{ } FUNCTION  CopyFile          (SourceFile,TargetFile:STRING): ShortInt;
                                 {Return codes:  0 successful
                                                 1 source and target the same
                                                 2 cannot open source
                                                 3 unable to create target
                                                 4 error during copy
                                                 5 not enough memory}

{ } FUNCTION  RenameFile        (OldName,NewName:STRING): ShortInt;
                                 {Return codes: 0 file renamed
                                                1 file not found
                                                2 rename failed}

{ } FUNCTION  DeleteFile        (Filename:STRING): ShortInt;
                                 {Return codes: -1 File not found
                                                 0 File deleted
                                                 1 Error - file not deleted}

{ } FUNCTION  FSize             (FileName:STRING): LongInt;

    {PRINTER}
{ } FUNCTION  PrinterStatus     : PrnStatus;
{ } FUNCTION  PrinterReady      : Boolean;
{ } PROCEDURE ResetPrinter      (TimeToWait:Word);

    {TIMING}
{a} PROCEDURE StartTimer;
{a} FUNCTION  StopTimer         : Real;
{a} FUNCTION  GetTimerStr       (TimerCount:Real): STRING;

    {PROGRAM EXECUTION}
{ } PROCEDURE ShrinkHeap;
{ } PROCEDURE ExpandHeap;
{ } FUNCTION  RunEXECOM         (ProgName,Params:STRING): Integer;
{ } FUNCTION  RunAnything       (Command:STRING): Integer;
{ } FUNCTION  ShellToDOS        : Integer;




IMPLEMENTATION



{----------------------------------------------------------------------------}
{                                                                            }
{                             MISC ROUTINES                                  }
{                                                                            }
{----------------------------------------------------------------------------}
 FUNCTION Attr(Fore,Back:Byte): Byte; ASSEMBLER;
 ASM
        XOR     AX,AX
        MOV     CL,4
        MOV     AL,Back
        SHL     AL,CL
        OR      AL,Fore
 END;

 FUNCTION FAttr(Attr:Byte): Byte; ASSEMBLER;
 ASM
        XOR     AX,AX
        MOV     AL,Attr
        AND     AL,15
 END;

 FUNCTION BAttr(Attr:Byte): Byte; ASSEMBLER;
 ASM
        XOR     AX,AX
        MOV     AL,Attr
        MOV     CL,4
        AND     AL,112
        SHR     AL,CL
 END;

 FUNCTION RetPercent(Num,Max,Current:LongInt): Integer;
 BEGIN
   IF Max = 0
     THEN RetPercent := 100
     ELSE RetPercent := Num - Trunc(Num * ((Max-Current)/Max));
 END;

 PROCEDURE ReBoot(ColdBoot:Boolean); ASSEMBLER;
 ASM
        MOV     AX, 40h
        MOV     ES, AX
        CMP     ColdBoot, True
        JE      @Boot
        MOV     AX, 1234h
        MOV     [WORD PTR ES:72h],AX    { $40:$72 = 1234h Indicates WARM BOOT }
 @Boot:
        DB      $EA                     { JMP FAR }
        DD      $F000FFF0               { $F000:$FFF0 - POST Address }
 END;


 PROCEDURE Wait(Num:Word); ASSEMBLER;
 VAR Timer:Word;
 ASM
        PUSH    DS
        MOV     DS, Seg0040
        MOV     AX, WORD PTR DS:[$6C]   { $0000:$046C - Address of TIMER }
        ADD     AX, Num
        MOV     Timer, AX
        XOR     AX, AX
 @@1:
        MOV     AX, WORD PTR DS:[$6C]
        CMP     Timer, AX
        JNE     @@1
        POP     DS
 END;

 PROCEDURE Delay(Ms:Word); ASSEMBLER;
 ASM
        MOV     AX, 1000
        MUL     Ms
        MOV     CX, DX
        MOV     DX, AX
        MOV     AH, $86
        INT     15h
 END;

 PROCEDURE Sound(Hz:Word); ASSEMBLER;
 ASM
        MOV     BX, Hz
        MOV     AX, $34DD
        MOV     DX, $0012
        CMP     DX, BX
        JNC     @End
        DIV     BX
        MOV     BX, AX
        IN      AL, 61h
        TEST    AL, 3
        JNZ     @@1
        OR      AL, 3
        OUT     61H, AL
        MOV     AL, $B6
        OUT     43h, AL
 @@1:   MOV     AL, BL
        OUT     42h, AL
        MOV     AL, BH
        OUT     42h, AL
 @End:
 END;

 PROCEDURE NoSound; ASSEMBLER;
 ASM
        IN      AL, $61
        AND     AL, $FC
        OUT     61h, AL
 END;



 { ------------------------- SHOW CLOCK --------------------------- }
TYPE
  TClock = RECORD
      XPos: Byte;
      YPos: Byte;
      Attr: Byte;
    OldPTR: Pointer;
  END;

VAR
  ClockREC   : TClock;


 PROCEDURE ShowClock; FAR;
 VAR OldIdlePTR: Pointer;
 BEGIN
   WITH ClockREC DO
   BEGIN
     FastWrite(XPos,YPos,Attr,CurrentTime);
     OldIdlePTR := OldPTR;
   END;
   IF OldIdlePTR <> NIL THEN INLINE($FF/$1E/OldIdlePTR); { CALL OldPtr }
 END;

 PROCEDURE InitClock(X,Y,Color:Byte);
 BEGIN
   WITH ClockREC DO
   BEGIN
     XPos   := X;
     YPos   := Y;
     Attr   := Color;
     OldPTR := IdleHook;
   END;
   IdleHook := @ShowClock;
 END;

 PROCEDURE DoneClock;
 BEGIN
   IdleHook := ClockREC.OldPTR;
 END;
 { ---------------------------------------------------------------- }




{----------------------------------------------------------------------------}
{                                                                            }
{                               VIDEO ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
{$IFDEF DPMI}
FUNCTION MaxX: Byte; ASSEMBLER;
ASM
  MOV  ES, Seg0040
  MOV  AL, BYTE PTR ES:[$4A]
END;

FUNCTION MaxY: Byte; ASSEMBLER;
ASM
  MOV  ES, Seg0040
  MOV  AL, BYTE PTR ES:[$84]
  INC  AL
END;
{$ENDIF}

 FUNCTION ColorScreen: Boolean; ASSEMBLER;
 ASM
        MOV     AX, True
        MOV     BX, SegB800
        CMP     BaseOfScreen, BX
        JE      @End
        MOV     AX, False
 @End:
 END;

 FUNCTION VGASystem: Boolean; ASSEMBLER;
 ASM
        MOV     AX, 1A00h
        INT     10h
        CMP     AL, 1Ah
        JE      @OK
        MOV     AX, False
        JMP     @End
 @OK:
        MOV     AX, True
        CMP     BL, 7
        JNL     @End
        MOV     AX, False
 @End:
 END;

 FUNCTION EGASystem: Boolean; ASSEMBLER;
 ASM
        MOV     AX, $1200
        MOV     BL, $10
        MOV     CX, $FFFF
        INT     $10
        CMP     CX, $FFFF
        JNE     @OK             { EGA Test }
        JMP     @END_ER
 @OK:   MOV     AX, True
        JMP     @END_OK
 @END_ER:
        MOV     AX, False
 @END_OK:
 END;

 FUNCTION EGAVGASystem: Boolean; ASSEMBLER;
 ASM
        MOV     AX, $1C00
        MOV     CX, $07
        INT     $10
        CMP     AL, 1Ch
        JE      @OK             { VGA Test }

        MOV     AX, $1200
        MOV     BL, $32;
        INT     $10
        CMP     AL, $12
        JE      @OK             { MCGA Test }

        MOV     AX, $1200
        MOV     BL, $10
        MOV     CX, $FFFF
        INT     $10
        CMP     CX, $FFFF
        JNE     @OK             { EGA Test }
        JMP     @END_ER

 @OK:   MOV     AX, True
        JMP     @END_OK

 @END_ER:
        MOV     AX, False
 @END_OK:
 END;

 PROCEDURE SetVideoMode(Mode:Byte); ASSEMBLER;
 ASM
        MOV     AH, 0
        MOV     AL, Mode
        INT     10h
 END;

 PROCEDURE SetBlink(On:Boolean); ASSEMBLER;
 ASM
        MOV     BX, $FF10
        MOV     CL, $0F
        MOV     AX, $1200
        INT     10h
        CMP     CL, $0C
        JNB     @NotEV
        CMP     BH, $01
        JA      @NotEV
        MOV     BL, On
        MOV     AX, $1003
        INT     10h
        JMP     @End
 @NotEV:
        XOR     AX,AX
        MOV     ES,AX
        MOV     DX, WORD PTR ES:$463
        ADD     DX, $04
        MOV     AL, BYTE PTR ES:$465
        MOV     BL, On
        CMP     BL, True
        JNE     @@2
        OR      AL, $20
        JMP     @@3
 @@2:
        AND     AL, $DF
 @@3:
        OUT     DX, AL
        MOV     BYTE PTR ES:$465, AL
 @End:
 END;

 PROCEDURE GrayScale(On:Boolean); ASSEMBLER;
 ASM
        MOV     AL, On
        XOR     AL, 1
        MOV     CL, AL
        MOV     BL, $33
        MOV     AH, $12
        INT     10h
        MOV     AH, $F
        INT     10h
        MOV     AH, 00
        INT     10h
 END;

 PROCEDURE SetCharWidth(CWidth:CharWidth);
 VAR X,HWidth:Byte; Regs:Registers;
 BEGIN
   IF CWidth = EGAWidth
     THEN HWidth := 8
     ELSE HWidth := 9;
   WITH Regs DO
   BEGIN
     IF (HWidth = 8) THEN BX := $0001 ELSE BX := $0800;
     X := Port[$3CC] AND NOT (4 + 8);
     IF (HWidth = 9) THEN X := X OR 4;
     Port[$3C2] := X;
     INLINE($FA);
     Portw[$3C4] := $0100;
     Portw[$3C4] := $01 + BL SHL 8;
     Portw[$3C4] := $0300;
     INLINE($FB);
     AX := $1000;
     BL := $13;
     Intr($10, Regs);
   END;
 END;

 PROCEDURE VGAScreenOn; ASSEMBLER;
 ASM
        CLI
        MOV     DX, 3DAH
        IN      AX, DX
        MOV     DX, 3BAH
        IN      AX, DX
        MOV     AX, 20H
        MOV     DX, 3C0H
        OUT     DX, AX
        STI
 END;

 PROCEDURE VGAScreenOff; ASSEMBLER;
 ASM
        CLI
        MOV     DX, 3DAh
        IN      AX, DX
        MOV     DX, 3BAh
        IN      AX, DX
        XOR     AX, AX
        MOV     DX, 3C0h
        OUT     DX, AX
        STI
 END;

{----------------------------------------------------------------------------}
{                                                                            }
{                            PALLETTE ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE SetBorderColor(Color:Byte); ASSEMBLER;
 ASM
        MOV     AH, $0B
        MOV     BH, 0
        MOV     BL, Color
        INT     10h
 END;

 FUNCTION GetPALReg(Color:Byte): Byte; ASSEMBLER;
 ASM
        MOV     AX, $1007
        MOV     BL, Color
        INT     $10
        XOR     AX, AX
        MOV     AL, BH
 END;

 PROCEDURE SetPALReg(Color,Value:Byte); ASSEMBLER;
 ASM
        MOV     AX, $1000
        MOV     BL, Color
        MOV     BH, Value
        INT     10h
 END;

 PROCEDURE GetPAL(VAR PAL:PalARRAY); ASSEMBLER;
 ASM
        MOV     CX, $F+1
        LES     DI, Pal
 @Fill: MOV     ES:BYTE PTR[DI], $FF
        INC     DI                      { Fill ARRAY with $FF because }
        LOOP    @Fill                   { of some crappy VGA adapters }
        MOV     AX, $1009
        LES     DX, Pal
        INT     10h
 END;

 PROCEDURE SetPAL(CONST PAL:PalARRAY); ASSEMBLER;
 ASM
        MOV     AX, $1002
        LES     DX, Pal
        INT     10h
 END;

 PROCEDURE SetVGADAC(Color,Red,Green,Blue:Byte); ASSEMBLER;
 ASM
        CLI
        MOV     AL, Color
        MOV     DX, $3C8                { PEL WRITE ADDRESS port }
        OUT     DX, AL
        MOV     DX, $3C9                { PEL DATA port }
        MOV     AL, Red
        OUT     DX, AL
        MOV     AL, Green
        OUT     DX, AL
        MOV     AL, Blue
        OUT     DX, AL
        STI
 END;

 PROCEDURE GetVGADAC(Color:Byte; VAR Red,Green,Blue:Byte); ASSEMBLER;
 ASM
        CLI
        LES     DI, Red
        MOV     AL, Color
        MOV     DX, $3C7                { PEL READ ADDRESS port }
        OUT     DX, AL
        MOV     DX, $3C9                { PEL DATA port }
        IN      AL, DX
        MOV     ES:BYTE PTR [DI+00], AL { Red }
        IN      AL, DX
        MOV     ES:BYTE PTR [DI+01], AL { Green }
        IN      AL, DX
        MOV     ES:BYTE PTR [DI+02], AL { Blue }
        STI
 END;



{----------------------------------------------------------------------------}
{                                                                            }
{                                 DIRECT WRITE                               }
{                                                                            }
{----------------------------------------------------------------------------}

 PROCEDURE CalcMemPointer; NEAR; ASSEMBLER;
 ASM
        XOR     AX, AX          { AX = 0 }
        MOV     CL, AL          { CL = 0 }
        MOV     BH, AL          { BH = 0 }
        MOV     ES, Seg0040     { ES = $0000 }
        DEC     CH              { convert to DOS 0..MaxY-1 coords }
        MOV     AL, BYTE PTR ES:[$4A]   { AL = MaxX }
        SHL     AX, 1           { AL = AL * 2 }
        MUL     CX              { DX,AX = Y * (MaxX * 2) }
        XCHG    AH, AL          { Exchange AH with AL }
        MOV     AH, DL          { Set corect value in AX }
        MOV     DI, AX          { Store in DI }
        DEC     BX              { convert to DOS 0..79 coords }
        SHL     BX, 1           { Account for attribute Bytes }
        ADD     DI, BX          { DI = (Row * 160) + (Col * 2) }
        ADD     DI, VOfs        { Add base address }
        MOV     ES, VSeg        { ES:DI points to first Row,Col attribute }
        XOR     AX, AX          { AX = 0 }
 END;

 PROCEDURE FastWrite(X,Y,Attr:Byte; StrOut:STRING); ASSEMBLER;
 ASM
        PUSH    DS              { Save DS }
        MOV     BL, X           { BL = X }
        MOV     CH, Y           { CH = Y }
        CALL    Calcmempointer  { Set up ES:DI for LDS }
        MOV     CL, CheckSnow   { Need to wait? }
        LDS     SI, StrOut      { DS:SI points to St[0] }
        CLD                     { Set direction to forward }
        LODSB                   { AX = Length(St); DS:SI -> St[0] }
        XCHG    AX, CX          { CX = Length; AL = WaitForRetrace }
        JCXZ    @FWExit         { exit if string empty }
        MOV     AH, Attr        { AH = display attribute }
        RCR     AL, 1           { If WaitForRetrace is False... }
        JNC     @FWMono         { use "FWMono" routine }
        MOV     DX, 03DAh       { Point DX to CGA status port }
 @FWGetNext:
        LODSB                   { Load next character into AL }
        MOV     BX, AX          { Store video Word in BX }
        CLI                     { hold interrupts }
 @FWWaitNoH:
        IN      AL, DX          { get retrace situation }
        TEST    AL, 8           { retracing? }
        JNZ     @FWStore        { If so, go }
        RCR     AL, 1           { ELSE, wait for END of }
        JC      @FWWaitNoH      { horizontal retrace }
 @FWWaitH:
        IN      AL, DX          { get retrace situation }
        RCR     AL, 1           { Wait for horizontal }
        JNC     @FWWaitH        { retrace }
 @FWStore:
        MOV     AX, BX          { Move Word back to AX... }
        STOSW                   { and THEN to screen }
        STI                     { OK to interrupt now }
        LOOP    @FWGetNext      { Get next character }
        JMP     @FWExit         { wind up }
 @FWMono:
        LODSB                   { Load next character into AL }
        STOSW                   { Move video Word into place }
        LOOP    @FWMono         { Get next character }
 @FWExit:
        POP     DS              { clean up and go home }
 END; {FastWrite}


 PROCEDURE PlainWrite(X,Y:Byte; StrOut:STRING); ASSEMBLER;
 ASM
        PUSH    DS              { SaveDS }
        MOV     BL, X           { BL=X }
        MOV     CH, Y           { CH=Y }
        CALL    Calcmempointer  { Setup ES:DI for LDS }
        MOV     CL, CheckSnow   { Need to wait? }
        LDS     SI, StrOut      { DS:SI points to St[0] }
        CLD                     { Set direction to forward }
        LODSB                   { AX=Length(St); DS:SI->St[1] }
        XCHG    AX, CX          { CX=Length; AL=Wait }
        JCXZ    @PWExit         { exit if string empty }
        RCR     AL, 1           { If Wait For Retrace is False... }
        JNC     @PWNoWait       { use PWNoWait routine }
        MOV     DX, 03DAh       { Point DX to CGA status port }
 @PWGetNext:
        LODSB                   { Load next character into AL }
        MOV     AH, AL          { Store char in AH }
        CLI                     { hold interrupts }
 @PWWaitNoH:
        IN      AL, DX          { get retrace situation }
        TEST    AL, 8           { Check for vertical retrace }
        JNZ     @PWStore        { Inprogress?go }
        RCR     AL, 1           { ELSE, wait for END of }
        JC      @PWWaitNoH      { horizontal retrace }
 @PWWaitH:
        IN      AL, DX          { Get 6845 status again }
        RCR     AL, 1           { Wait for horizontal }
        JNC     @PWWaitH        { retrace }
 @PWStore:
        MOV     AL, AH          { Move char back to AL... }
        STOSB                   { and THEN to screen }
        STI                     { OK to interrupt now }
        INC     DI              { Skip attribute Bytes }
        LOOP    @PWGetNext      { Get next character }
        JMP     @PWExit         { Done }
 @PWNoWait:
        MOVSB                   { Move character to screen }
        INC     DI              { Skip attribute Bytes }
        LOOP    @PWNoWait       { Get next character }
 @PWExit:
        POP     DS              {Cleanup and go home}
 END; {PlainWrite}

 PROCEDURE Attribute(X,Y,Attr:Byte; Number:Word); ASSEMBLER;
 ASM
        MOV     BL, X           { BL=X }
        MOV     CH, Y           { CH=Y }
        CALL    CalcMemPointer  { Call routine to calculate offset }
        INC     DI              { Skip character }
        CLD                     { Set direction to forward }
        MOV     CX, Number      { CX=Number to change }
        JCXZ    @AExit          { If zero, exit }
        MOV     AL, Attr        { AL=Attribute }
        CMP     CheckSnow,1     { Get wait state }
        JNE     @ANoWait        { If Wait For Retrace is False }
                                { use ANoWait routine }
        MOV     AH, AL          { Store attribute in AH }
        MOV     DX, 03DAh       { Point DX to CGA status port }
 @AGetNext:
        CLI                     { No interrupts now }
 @AWaitNoH:
        IN      AL, DX          { get retrace situation }
        TEST    AL, 8           { check for vertical retrace }
        JNZ     @AGo            { Inprogress? Go }
        RCR     AL, 1           { Wait for END of horizontal }
        JC      @AWaitNoH       { retrace }
 @AWaitH:
        IN      AL, DX          { get retrace situation }
        RCR     AL, 1           { Wait for horizontal }
        JNC     @AWaitH         { retrace }
 @AGo:
        MOV     AL, AH          { Move Attr back to AL... }
        STOSB                   { and THEN to screen }
        STI                     { Allow interrupts }
        INC     DI              { Skip characters }
        LOOP    @AGetNext       { Look for next opportunity }
        JMP     @AExit          { Done }
 @ANoWait:
        STOSB                   { Change the attribute }
        INC     DI              { Skip characters }
        LOOP    @ANoWait        { Get next character }
 @AExit:                        { Exit }
 END; {Attribute}

 PROCEDURE WriteHi(X,Y,NormAttr,HiAttr:Byte; St:STRING);
 VAR I,R,StrEnd:Byte; OK:Boolean;
 BEGIN
   I  := 1;
   R  := 1;
   OK := False;
   IF St[Length(St)] = '~'
     THEN StrEnd := Length(St)
     ELSE StrEnd := Succ(Length(St));
   REPEAT
     IF St[I] = '~' THEN BEGIN OK := NOT OK; Inc(I); END;
     IF OK
       THEN BEGIN
              IF St[I] = '~'
                THEN Inc(I)
                ELSE FastWrite(X+Pred(R),Y,HiAttr,St[I]);
            END
       ELSE FastWrite(X+Pred(R),Y,NormAttr,St[I]);
     Inc(I); Inc(R);
   UNTIL I >= StrEnd;
 END;

 PROCEDURE WriteVert(X,Y,Attr:Byte; St:STRING);
 VAR I:Integer; TempStr:STRING;
 BEGIN
   IF Length(St) > MaxY THEN Delete(St,MaxY,255);
   FOR I := 1 TO Length(St) DO
   BEGIN
     TempStr := St[I];
     FastWrite(X,Pred(Y)+I,Attr,St[I]);
   END;
 END;

 PROCEDURE WriteFill(X,Y,Attr,ToLength:Byte; Fill:Char; St:STRING);
 BEGIN
   FastWrite(X,Y,Attr,PadLeft(St,ToLength,Fill));
 END;

 PROCEDURE WriteBack(XEnd,Y,Attr:Byte; St:STRING);
 BEGIN
   FastWrite(Succ(XEnd)-Length(St),Y,Attr,St);
 END;

 PROCEDURE WriteCenter(LineNO,Attr:Byte; St:STRING);
 BEGIN
   FastWrite((MaxX DIV 2)-Length(St) DIV 2,LineNo,Attr,St);
 END;

 PROCEDURE WriteBetween(X1,X2,Y,Attr:Byte; St:STRING);
 VAR X: Integer;
 BEGIN
   IF Length(St) >= X2-X1+1
     THEN FastWrite(X1,Y,Attr,St)
     ELSE BEGIN
            X := X1+(X2-X1+1-Length(St)) DIV 2;
            FastWrite(X,Y,Attr,St);
          END;
 END;


 PROCEDURE WriteVScrollBar(X,Y1,Y2,Attr:Byte; Current,Max:Longint);
 VAR I,Y,LineLength: Integer;
 BEGIN
   WITH ScrollBar DO
   BEGIN
     FastWrite(X,Y1,Attr,UpChar);
     FastWrite(X,Y2,Attr,DownChar);
     FOR I := Succ(Y1) TO Pred(Y2) DO FastWrite(X,I,Attr,BackChar);
     IF (Current > 0) AND (Max >= Current) THEN
     BEGIN
       LineLength := Y2 - succ(Y1);
       IF LineLength > 0 THEN
       BEGIN
          Y := (Current * LineLength) DIV Max;
          IF Current >= Max THEN Y := Pred(LineLength);
          IF (Y < 0) OR (Current = 1) THEN Y := 0;
          FastWrite(X,Succ(Y1)+Y,Attr,ElevatorChar);
       END;
     END;
   END;
 END;

 PROCEDURE WriteHScrollBar(X1,X2,Y,Attr:Byte; Current,Max:Longint);
 VAR X,LineLength: Integer;
 BEGIN
   WITH ScrollBar DO
   BEGIN
     FastWrite(X1,Y,Attr,LeftChar);
     FastWrite(X2,Y,Attr,RightChar);
     FastWrite(Succ(X1),Y,Attr,Replicate(Pred(X2-X1),BackChar));
     IF (Current > 0) AND (Max >= Current) THEN
     BEGIN
       LineLength := X2 - Succ(X1);
       IF LineLength > 0 THEN
       BEGIN
          X := (Current * LineLength) DIV Max;
          IF Current >= Max THEN X := Pred(LineLength);
          IF (X < 0) OR (Current = 1) THEN X := 0;
          FastWrite(Succ(X1)+X,Y,Attr,ElevatorChar);
       END;
     END;
   END;
 END;


{----------------------------------------------------------------------------}
{                                                                            }
{                                  CLEARING                                  }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE ClrScr(Attr:Byte);
 BEGIN
   PosCursor(1,1);
   ClearText(1,1,MaxX,MaxY,Attr);
 END;

 PROCEDURE ClearAttr(X1,Y1,X2,Y2,Attr:Byte);
 VAR I,X: Byte;
 BEGIN
   X := Succ(X2-X1);
   FOR I := Y1 TO Y2 DO Attribute(X1,I,Attr,X);
 END;

 PROCEDURE ClearText(X1,Y1,X2,Y2,Attr:Byte);
 VAR Y: Integer;
 BEGIN
   IF X2 > MaxX THEN X2 := MaxX;
   FOR Y := Y1 TO Y2 DO FastWrite(X1,Y,Attr,Replicate(Succ(X2-X1),' '));
 END;

 PROCEDURE ClearLine(Y,Attr:Byte);
 BEGIN
   FastWrite(1,Y,Attr,Replicate(MaxX,' '));
 END;

 PROCEDURE FillScreen(X1,Y1,X2,Y2,Attr:Byte; C:Char);
 VAR I:Integer; St:STRING;
 BEGIN
   ClearAttr(X1,Y1,X2,Y2,Attr);
   St := Replicate(Succ(X2-X1),C);
   FOR I := Y1 TO Y2 DO PlainWrite(X1,I,St);
 END;

 PROCEDURE ScrollUP(X1,Y1,X2,Y2,NumLines,Attr:Byte); ASSEMBLER;
 ASM
        MOV     CL, X1; MOV     CH, Y1; DEC     CL;     DEC     CH;
        MOV     DL, X2; MOV     DH, Y2; DEC     DL;     DEC     DH;
        MOV     AH, 6
        MOV     AL, NumLines
        MOV     BH, Attr
        INT     10h
 END;

 PROCEDURE ScrollDOWN(X1,Y1,X2,Y2,NumLines,Attr:Byte); ASSEMBLER;
 ASM
        MOV     CL, X1; MOV     CH, Y1; DEC     CL;     DEC     CH;
        MOV     DL, X2; MOV     DH, Y2; DEC     DL;     DEC     DH;
        MOV     AH, 7
        MOV     AL, NumLines
        MOV     BH, Attr
        INT     10h
 END;

{PROCEDURE Scroll(Way:Direction;X1,Y1,X2,Y2:Byte; ReplaceChar:Char);
 VAR I: Integer;
 BEGIN
   CASE Way OF
   Up   : BEGIN
            CopyScreenBlock(X1,Succ(Y1),X2,Y2,X1,Y1);
            PlainWrite(X1,Y2,Replicate(succ(X2-X1),ReplaceChar));
          END;
   Down : BEGIN
            CopyScreenBlock(X1,Y1,X2,pred(Y2),X1,Succ(Y1));
            PlainWrite(X1,Y1,Replicate(Succ(X2-X1),ReplaceChar));
          END;
   Left : BEGIN
            CopyScreenBlock(Succ(X1),Y1,X2,Y2,X1,Y1);
            FOR I := Y1 TO Y2 DO
                PlainWrite(X2,1,ReplaceChar);
          END;
   Right: BEGIN
            CopyScreenBlock(X1,Y1,Pred(X2),Y2,Succ(X1),Y1);
            FOR I := Y1 TO Y2 DO
                PlainWrite(X1,1,ReplaceChar);
          END;
   END;
 END;}

{----------------------------------------------------------------------------}
{                                                                            }
{                               LINE DRAWING                                 }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE HLine(X1,X2,Y,Attr:Byte; LType:LineStyle);
 VAR I: Integer;
 BEGIN
   IF X2 > X1
     THEN FastWrite(X1,Y, Attr,Replicate(X2-X1+1,LineChars[LType,1]))
     ELSE FastWrite(X1,Y, Attr,Replicate(X1-X2+1,LineChars[LType,1]));
 END;

 PROCEDURE VLine(X,Y1,Y2,Attr:Byte; LType:LineStyle);
 VAR I: Integer;
 BEGIN
   IF Y2 > Y1
     THEN FOR I := Y1 TO Y2 DO FastWrite(X,I,Attr,LineChars[LType, 2])
     ELSE FOR I := Y2 TO Y1 DO FastWrite(X,I,Attr,LineChars[LType, 2]);
 END;

 PROCEDURE SmartHLine(X1,X2,Y,Attr:Byte; LType:LineStyle);
 VAR
    I: Integer;
    Ch,
    TestCh: Char;
    LineStr: STRING[19];
    StringOffset: Byte;

    FUNCTION AdjacentChar(X,Y:Byte): Char;
    BEGIN
       IF (Y < 1) OR (Y > MaxY)
         THEN AdjacentChar := ' '
         ELSE AdjacentChar := GetScreenChar(X,Y);
    END;

    FUNCTION LineCh(X,Y:byte): Char;
    CONST DownSingle: STRING[13] = '¿ŴѸص';
          DownDouble: STRING[13] = '˻ιҷ׶';
          UpSingle:   STRING[13] = 'ŴصϾ';
          UpDouble:   STRING[13] = 'ιʼ׶к';
    VAR LStyle : char;
    BEGIN
       LStyle := AdjacentChar(X,Pred(Y));
       IF Pos(LStyle,DownSingle) > 0
         THEN LStyle := ''
         ELSE IF Pos(LStyle,DownDouble) > 0
             THEN LStyle := ''
             ELSE LStyle := ' ';
       CASE LStyle OF
       '': IF Pos(AdjacentChar(X,Succ(Y)),UpSingle) > 0
              THEN Ch := LineStr[2+StringOffset]
              ELSE Ch := LineStr[3+StringOffset];

       '': IF Pos(AdjacentChar(X,succ(Y)),UpDouble) > 0
              THEN Ch := LineStr[4+StringOffset]
              ELSE Ch := LineStr[5+StringOffset];
       ELSE TestCh := AdjacentChar(X,succ(Y));
            IF pos(TestCh,UpSingle) > 0
              THEN Ch := LineStr[6+StringOffset]
              ELSE IF pos(TestCh,UpDouble) > 0
                  THEN Ch := LineStr[7+StringOffset]
                  ELSE Ch := LineStr[1];
       END;
       LineCh := Ch;
    END;

 BEGIN
   IF LType IN [DoubleLine,cyrDoubleLine]
     THEN LineStr := '˵ '
     ELSE LineStr := 'Ҵٶ';
   StringOffSet := 0;
   FastWrite(X1,Y,Attr,LineCh(X1,Y));
   StringOffSet := 6;
   FOR I := Succ(X1) TO Pred(X2) DO FastWrite(I,Y,Attr,LineCh(I,Y));
   StringOffSet := 12;
   FastWrite(X2,Y,Attr,LineCh(X2,Y));
 END; {SmartHLine}

 PROCEDURE SmartVLine(X,Y1,Y2,Attr:Byte; LType:LineStyle);
 VAR
    I: Integer;
    Ch,
    TestCh: Char;
    LineStr: STRING[19];
    StringOffset: Byte;

    FUNCTION AdjacentChar(X,Y:Byte): Char;
    BEGIN
       IF (X < 1) OR (X > MaxX)
         THEN AdjacentChar := ' '
         ELSE AdjacentChar := GetScreenChar(X,Y);
    END;

    FUNCTION LineCh(X,Y:byte): Char;
    CONST LeftSingle: STRING[13] = '¿Ŵҷ׶н';
          LeftDouble: STRING[13] = '˻ιʼѸصϾ';
          RightSingle:STRING[13] = '';
          RightDouble:STRING[13] = '';
    VAR LStyle: Char;
    BEGIN
       LStyle := AdjacentChar(Pred(X),Y);
       IF Pos(LStyle,RightSingle) > 0
         THEN LStyle := ''
         ELSE IF Pos(LStyle,RightDouble) > 0
               THEN LStyle := ''
               ELSE LStyle := ' ';
       CASE LStyle OF
       '': IF Pos(AdjacentChar(Succ(X),Y),LeftSingle) > 0
              THEN Ch := LineStr[2+StringOffset]
              ELSE Ch := LineStr[3+StringOffset];
       '': IF Pos(AdjacentChar(succ(X),Y),LeftDouble) > 0
              THEN Ch := LineStr[4+StringOffset]
              ELSE Ch := LineStr[5+StringOffset];
       ELSE TestCh := AdjacentChar(succ(X),Y);
            IF Pos(TestCh,LeftSingle) > 0
              THEN Ch := LineStr[6+StringOffset]
              ELSE IF Pos(TestCh,LeftDouble) > 0
                     THEN Ch := LineStr[7+StringOffset]
                     ELSE Ch := LineStr[1];
       END;
       LineCh := Ch;
    END;

 BEGIN
   IF LType IN [DoubleLine,cyrDoubleLine]
     THEN LineStr := 'ҷ˻׶ιнʼ'
     ELSE LineStr := '¿ѸŴصϾ';
   StringOffSet := 0;
   FastWrite(X,Y1,Attr,LineCh(X,Y1));
   StringOffSet := 6;
   FOR I := Succ(Y1) TO Pred(Y2) DO FastWrite(X,I,Attr,LineCh(X,I));
   StringOffSet := 12;
   FastWrite(X,Y2,Attr,LineCh(X,Y2));
 END; {SmartVLine}


{----------------------------------------------------------------------------}
{                                                                            }
{                               BOX DRAWING                                  }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE Box(X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);
 VAR I: Integer;
 BEGIN
   IF X2 > MaxX THEN X2 := MaxX;
   IF Y2 > MaxY THEN Y2 := MaxY;
   FastWrite(X1,Y1,Attr,BoxChars[BoxType,1]);
   FastWrite(X1+1,Y1,Attr,Replicate(X2-X1-1,BoxChars[BoxType,5]));
   FastWrite(X2,Y1,Attr,BoxChars[BoxType,2]);
   FOR I := Y1+1 TO Y2-1 DO
   BEGIN
     FastWrite(X1,I,Attr,BoxChars[BoxType,7]);
     FastWrite(X2,I,Attr,BoxChars[BoxType,7]);
   END;
   FastWrite(X1,Y2,Attr,BoxChars[BoxType,3]);
   FastWrite(X1+1,Y2,Attr,Replicate(X2-X1-1,BoxChars[BoxType,6]));
   FastWrite(X2,Y2,Attr,BoxChars[BoxType,4]);
 END;

 PROCEDURE FBox(X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);
 BEGIN
   IF X2 > MaxX THEN X2 := MaxX;
   IF Y2 > MaxY THEN Y2 := MaxY;
   Box(X1,Y1,X2,Y2,Attr,BoxType);
   ClearText(Succ(X1),Succ(Y1),Pred(X2),Pred(Y2),Attr);
 END;

 PROCEDURE GrowFBox(X1,Y1,X2,Y2,Attr:Byte; BoxType:FrameStyle);
 VAR I,TX1,TY1,TX2,TY2,Ratio: Integer;
 BEGIN
   IF X2 > MaxX THEN X2 := MaxX;
   IF Y2 > MaxY THEN Y2 := MaxY;
   If 2*(Y2 -Y1 +1) > X2 - X1 + 1
     THEN Ratio := 2
     ELSE Ratio := 1;
   TX2 := (X2 - X1) DIV 2 + X1 + 2;
   TX1 := TX2 - 3;                 {needs a box 3 by 3 minimum}
   TY2 := (Y2 - Y1) DIV 2 + Y1 + 2;
   TY1 := TY2 - 3;
   IF (X2-X1) < 3
     THEN BEGIN
            TX2 := X2;
            TX1 := X1;
          END;
   IF (Y2-Y1) < 3
     THEN BEGIN
            TY2 := Y2;
            TY1 := Y1;
          END;
   REPEAT
     FBox(TX1,TY1,TX2,TY2,Attr,BoxType);
     IF TX1 >= X1 + (1*Ratio) THEN TX1 := TX1 - (1*Ratio) ELSE TX1 := X1;
     IF TY1 > Y1  THEN TY1 := TY1 - 1;
     IF TX2 + (1*Ratio) <= X2 THEN TX2 := TX2 + (1*Ratio) ELSE TX2 := X2;
     IF TY2 + 1 <= Y2 THEN TY2 := TY2 + 1;
     Delay(DelayRatio);
   UNTIL (TX1 = X1) AND (TY1 = Y1) AND (TX2 = X2) AND (TY2 = Y2);
   FBox(TX1,TY1,TX2,TY2,Attr,BoxType);
 END;



{----------------------------------------------------------------------------}
{                                                                            }
{                            DIRECT MEMORY READ&WRITE                        }
{                                                                            }
{----------------------------------------------------------------------------}
 FUNCTION CompMem(VAR Source,Dest; Count:Word):Boolean; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        MOV     CX, Count
        LES     DI, Dest
        LDS     SI, Source
        REPE    CMPSB
        MOV     AL, True
        JE      @End
        MOV     AL, False
 @End:
        POP     DS
 END;

 FUNCTION ScanMem(VAR Dest; Count:Word; Num:Byte):Word; ASSEMBLER;
 ASM
        CLD
        MOV     AL, Num
        MOV     CX, Count
        LES     DI, Dest
        XOR     BX, BX
 @@1:
        REPNE   SCASB
        JNE     @End
        INC     BX
        JMP     @@1
 @End:
        MOV     AX, BX
 END;

 PROCEDURE MoveMem(VAR Source,Dest; Count:Word); ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        MOV     CX, Count
        LES     DI, Dest
        LDS     SI, Source
        SHR     CX, 1
        REP     MOVSW
        JNC     @End
        MOVSB
 @End:
        POP     DS
 END;

 PROCEDURE FillMem(VAR Dest; Count:Word; Num:Byte); ASSEMBLER;
 ASM
        CLD
        MOV     AL, Num
        MOV     AH, AL
        MOV     CX, Count
        LES     DI, Dest
        SHR     CX, 1
        REP     STOSW
        JNC     @End
        STOSB
 @End:
 END;


 PROCEDURE MoveFromScreen(VAR Source,Dest; Count:Word); ASSEMBLER;
 ASM
        PUSH    DS              { SaveDS }
        MOV     AL, CheckSnow   { Grab before changing DS }
        LES     DI, Dest        { ES:DI points to Dest }
        LDS     SI, Source      { DS:SI points to Source }
        MOV     CX, Count       { CX=Length }
        CLD                     { Set direction to forward }
        RCR     AL, 1           { Check Wait For Retrace }
        JNC     @MFNoWait       { False? UseMFNoWait routine }
        MOV     DX, 03DAh       { Point DX to CGA status port }
 @MFNext:
        CLI                     { No interrupts now }
 @MFWaitNoH:
        IN      AL, DX          { Get 6845 status }
        TEST    AL, 8           { Check for vertical retrace }
        JNZ     @MFGo           { Inprogress? go }
        RCR     AL, 1           { Wait for END of horizontal }
        JC      @MFWaitNoH      { retrace }
 @MFWaitH:
        IN      AL, DX          { Get 6845 status again }
        RCR     AL, 1           { Wait for horizontal }
        JNC     @MFWaitH        { retrace }
 @MFGo:
        LODSW                   { Load next video word into AX }
        STI                     { Allow interrupts }
        STOSW                   { Store video word in Dest }
        LOOP    @MFNext         { Get next videoword }
        JMP     @MFExit         { All Done }
 @MFNoWait:
        REP     MOVSW           { That's it! }
 @MFExit:
        POP     DS              { Restore DS }
 END;

 PROCEDURE MoveToScreen(VAR Source,Dest; Count:Word); ASSEMBLER;
 ASM
        PUSH    DS              { SaveDS}
        MOV     AL, CheckSnow   { Grab before changingDS }
        LES     DI, Dest        { ES:DI points to Dest }
        LDS     SI, Source      { DS:SI points to Source }
        MOV     CX, Count       { CX=Length }
        CLD                     { Set direction to forward }
        RCR     AL, 1           { Check Wait For Retrace }
        JNC     @MTNoWait       { False? Use MTNoWait routine }
        MOV     DX,03DAh        { Point DX to CGA status port }
 @MTGetNext:
        LODSW                   { Load next video word into AX }
        MOV     BX, AX          { Store video word in BX }
        CLI                     { No interrupts now }
 @MTWaitNoH:
        IN      AL, DX          { Get 6845 status }
        TEST    AL, 8           { Check for vertical retrace }
        JNZ     @MTGo           { Inprogress? Go }
        RCR     AL, 1           { WaitforENDofhorizontal }
        JC      @MTWaitNoH      { retrace }
 @MTWaitH:
        IN      AL, DX          { Get 6845 status again }
        RCR     AL, 1           { Wait for horizontal }
        JNC     @MTWaitH        { retrace}
 @MTGo:
        MOV     AX, BX          { Move word back to AX... }
        STOSW                   { and then to screen }
        STI                     { Allow interrupts }
        LOOP    @MTGetNext      { Get next video word }
        JMP     @MTExit         { All done }
 @MTNoWait:
        REP     MOVSW           { That's all! }
 @MTExit:
        POP     DS              { RestoreDS }
 END;

 PROCEDURE PartSave(X1,Y1,X2,Y2:Byte; VAR Dest);
 VAR I,Width: Byte; ScreenAdr: Integer;
 BEGIN
   Width := Succ(X2-X1);
   FOR I :=  Y1 TO Y2 DO
   BEGIN
     ScreenAdr := Pred(I) * (MaxX*2) + Pred(X1) * 2;
     MoveFromScreen(Mem[Vseg:ScreenAdr],
                    Mem[Seg(Dest):Ofs(Dest)+(I-Y1)*Width*2],
                    Width);
   END;
 END;

 PROCEDURE PartRestore(X1,Y1,X2,Y2:Byte; VAR Source);
 VAR I,Width: Byte; ScreenAdr: Integer;
 BEGIN
   Width := Succ(X2- X1);
   FOR I :=  Y1 TO Y2 DO
   BEGIN
     ScreenAdr := Pred(I)*(MaxX*2) + Pred(X1)*2;
     MoveToScreen(Mem[Seg(Source):Ofs(Source)+(I-Y1)*Width*2],
                  Mem[Vseg:ScreenAdr],
                  Width);
   END;
 END;

 PROCEDURE CopyScreenBlock(X1,Y1,X2,Y2,X,Y:Byte);
 VAR S: Word; SPtr: Pointer;
 BEGIN
   S := Succ(Y2-Y1)*Succ(X2-X1)*2;
   GetMem(SPtr,S);
   PartSave(X1,Y1,X2,Y2,SPtr^);
   PartRestore(X,Y,X+X2-X1,Y+Y2-Y1,SPtr^);
   FreeMem(Sptr,S);
 END;

 PROCEDURE MoveScreenBlock(X1,Y1,X2,Y2,X,Y:Byte; ReplaceChar:Char);
 VAR S:Word; I:Integer; SPtr:Pointer; ST:STRING;
 BEGIN
   S := Succ(Y2-Y1)*Succ(X2-X1)*2;
   GetMem(SPtr,S);
   PartSave(X1,Y1,X2,Y2,SPtr^);
   St := Replicate(Succ(X2-X1),ReplaceChar);
   FOR I := Y1 TO Y2 DO PlainWrite(X1,I,St);
   PartRestore(X,Y,X+X2-X1,Y+Y2-Y1,SPtr^);
   FreeMem(Sptr,S);
 END;

 PROCEDURE GetScreenWord(X,Y:Byte; VAR Attr:Byte; VAR Ch:Char);
 TYPE ScreenWordRec = RECORD
                        Ch  : Char;
                        Attr: Byte;
                      END;
 VAR ScreenAdr:Integer; SW:ScreenWordRec;
 BEGIN
   ScreenAdr := Pred(Y) * MaxX*2 + Pred(X)*2;
   MoveFromScreen(Mem[Vseg:ScreenAdr],mem[Seg(SW):Ofs(SW)],1);
   Ch   := SW.Ch;
   Attr := SW.Attr;
 END;

 FUNCTION GetScreenChar(X,Y:Byte): Char;
 VAR A: Byte; C: Char;
 BEGIN
   GetScreenWord(X,Y,A,C);
   GetScreenChar := C;
 END;

 FUNCTION GetScreenAttr(X,Y:Byte): Byte;
 VAR A: Byte; C: Char;
 BEGIN
   GetScreenWord(X,Y,A,C);
   GetScreenAttr := A;
 END;

 FUNCTION GetScreenStr(X1,X2,Y:Byte): STRING;
 VAR I: Integer; St: STRING;
 BEGIN
   St := '';
   FOR I := X1 TO X2 DO St := St + GetScreenChar(I,Y);
   GetScreenStr := St;
 END;


{----------------------------------------------------------------------------}
{                                                                            }
{                                  CURSOR ROUTINES                           }
{                                                                            }
{----------------------------------------------------------------------------}
CONST
  MaxSavedCursors = $0F;


TYPE
  TCursorREC = RECORD
        OldX : Byte;
        OldY : Byte;
      OldTop : Byte;
   OldBottom : Byte;
  END;


CONST
  SavedCursorPOS: Byte = 0;

VAR
  OldCursors: ARRAY[0..MaxSavedCursors] OF TCursorREC;


 PROCEDURE SaveCursor;
 VAR OldCursor:TCursorREC;
 BEGIN
   IF SavedCursorPOS = MaxSavedCursors THEN Exit ELSE Inc(SavedCursorPOS);
   ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        MOV     OldCursor.OldX, DL
        MOV     OldCursor.OldY, DH
        MOV     OldCursor.OldTop, CH
        MOV     OldCursor.OldBottom, CL
   END;
   OldCursors[SavedCursorPOS] := OldCursor;
 END;

 PROCEDURE RestoreCursor;
 VAR OldCursor:TCursorREC;
 BEGIN
   OldCursor := OldCursors[SavedCursorPOS];
   IF SavedCursorPOS = 0 THEN Exit ELSE Dec(SavedCursorPOS);
   ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $02
        MOV     DL, OldCursor.OldX
        MOV     DH, OldCursor.OldY
        INT     10h
        MOV     AH, $01
        MOV     CH, OldCursor.OldTop
        MOV     CL, OldCursor.OldBottom
        INT     10h
   END;
 END;

 FUNCTION GetCursorTop: Byte; ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        MOV     AL, CH
        INC     AL
 END;

 FUNCTION GetCursorBottom: Byte; ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        MOV     AL, CL
        INC     AL
 END;

 PROCEDURE GetCursorSize(VAR Top,Bottom: Byte); ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        INC     CL
        INC     CH
        LES     DI, Top
        MOV     ES:BYTE PTR [DI+0], CH
        MOV     ES:BYTE PTR [DI+1], CL
 END;

 PROCEDURE SetCursorSize(Top,Bottom: Byte); ASSEMBLER;
 ASM
        MOV     AH, $01
        MOV     CH, Top
        MOV     CL, Bottom
        INT     10h
 END;


 FUNCTION WhereX: Byte; ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        MOV     AL, DL
        INC     AL
 END;

 FUNCTION WhereY: Byte; ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        MOV     AL, DH
        INC     AL
 END;

 PROCEDURE GetCursorPos(VAR X,Y:Byte); ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $03
        INT     10h
        INC     DL
        INC     DH
        LES     DI, X
        MOV     ES:BYTE PTR [DI+0], DL
        MOV     ES:BYTE PTR [DI+1], DH
 END;

 PROCEDURE PosCursor(X,Y:Byte); ASSEMBLER;
 ASM
        MOV     AH, $0F
        INT     10h
        MOV     AH, $02
        DEC     X
        DEC     Y
        MOV     DL, X
        MOV     DH, Y
        INT     10h
 END;


 PROCEDURE Cursor(CursorType:TCursorType);
 BEGIN
   IF BaseOfScreen = $B800
     THEN BEGIN {Color Video Card}
            CASE CursorType OF
              On  : SetCursorSize(6,7);
              Off : SetCursorSize(14,0);
              Half: SetCursorSize(4,7);
              Full: SetCursorSize(0,7);
            END;
          END
     ELSE BEGIN {Mono Video Card}
            CASE CursorType OF
              On  : SetCursorSize(12,13);
              Off : SetCursorSize(14,0);
              Half: SetCursorSize(8,13);
              Full: SetCursorSize(0,13);
            END;
          END;
 END;


{----------------------------------------------------------------------------}
{                                                                            }
{                                FONT ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE Load8x8; ASSEMBLER;
 ASM
        MOV     AX, 1112h
        MOV     BL, 00
        INT     10h
        MOV     AX, 1112h
        MOV     BL, 01
        INT     10h
 END;

 PROCEDURE Load8x14; ASSEMBLER;
 ASM
        MOV     AX, 1111h
        MOV     BL, 00
        INT     10h
        MOV     AX, 1111h
        MOV     BL, 01
        INT     10h
 END;

 PROCEDURE Load8x16; ASSEMBLER;
 ASM
        MOV     AX, 1114h
        MOV     BL, 00
        INT     10h
        MOV     AX, 1114h
        MOV     BL, 01
        INT     10h
 END;


 PROCEDURE GetFontAccess; ASSEMBLER;
 ASM
        XOR     CX, CX
        MOV     CL, WaitVRetrace
        JCXZ    @Action
        {---VRetrace---}
        MOV     DX, $03DA
        MOV     AH, 8
 @W1:   IN      AL, DX
        TEST    AL, AH
        JNZ     @W1
 @W2:   IN      AL, DX
        TEST    AL, AH
        JZ      @W2
        {-------------}
 @Action:
        MOV     DX, $03C4; { Sequenser }
        MOV     AX, $0402;      OUT     DX, AX
        MOV     AX, $0704;      OUT     DX, AX

        MOV     DX, $03CE;
        MOV     AX, $0204;      OUT     DX, AX
        MOV     AX, $0005;      OUT     DX, AX
        MOV     AX, $0406;      OUT     DX, AX
 END;

 PROCEDURE ReleaseFontAccess; ASSEMBLER;
 ASM
        MOV     DX, $03C4; { Sequenser }
        MOV     AX, $0302;      OUT     DX, AX
        MOV     AX, $0304;      OUT     DX, AX

        MOV     DX, $03CE; { Graphic }
        MOV     AX, $0004;      OUT     DX, AX
        MOV     AX, $1005;      OUT     DX, AX

        MOV     AX, $0E06
        CMP     BaseOfScreen, $B800 { Color screen? }
        JE      @Yes                { Yes - Video memory start form $B800 }
        MOV     AX, $0A06           { No  - Video memory start from $B000 }
 @Yes:
        OUT     DX, AX
 END;

 PROCEDURE OneFontOnScreen; ASSEMBLER;
 ASM
        MOV     AX, $1103
        MOV     BL, $00
        INT     10h
 END;

 PROCEDURE TwoFontsOnScreen; ASSEMBLER;
 ASM
        MOV     AX, $1103
        MOV     BL, $04
        INT     10h
 END;


 PROCEDURE SetFont8x16(Table:Byte; VAR Font:Font8x16); ASSEMBLER;
 ASM
        CALL    GetFontAccess
        PUSH    DS
        LDS     SI, Font

        MOV     AX, $A000
        MOV     ES, AX
        XOR     AL, AL
        MOV     AL, Table
        MOV     CX, $4000
        MUL     CX
        MOV     DI, AX
        MOV     CX, $FF

 @LoadFONT:
        PUSH    CX
        PUSH    DI
        MOV     CX, 8
        REP     MOVSW
        POP     DI
        POP     CX
        ADD     DI, 32
        LOOP    @LoadFONT
        CALL    ReleaseFontAccess
        POP     DS
 END;


 PROCEDURE GetFont8x16(Table:Byte; VAR Font:Font8x16); ASSEMBLER;
 ASM
        CALL    GetFontAccess
        LES     DI, Font
        PUSH    DS

        MOV     AX, $A000
        MOV     DS, AX
        XOR     AL, AL
        MOV     AL, Table
        MOV     CX, $4000
        MUL     CX
        MOV     SI, AX
        MOV     CX, $FF

 @LoadFONT:
        PUSH    CX
        PUSH    SI
        MOV     CX, 8
        REP     MOVSW
        POP     SI
        POP     CX
        ADD     SI, 32
        LOOP    @LoadFONT
        CALL    ReleaseFontAccess
        POP     DS
 END;

 PROCEDURE ResetFont8x16(Table:Byte); ASSEMBLER;
 ASM
        MOV     AX, $1104
        MOV     BL, Table
        INT     10h
 END;


 PROCEDURE SetChar8x16(Table,CharNum:Byte; VAR BitMap:Char8x16); ASSEMBLER;
 ASM
        CALL    GetFontAccess
        PUSH    DS
        LDS     SI, BitMap

        MOV     AX, $A000
        MOV     ES, AX
        XOR     AL, AL
        MOV     AL, Table
        MOV     CX, $4000
        MUL     CX
        MOV     DI, AX

        MOV     AL, CharNum
        MOV     CL, 32
        MUL     CL
        ADD     DI, AX

        MOV     CX, 8
        REP     MOVSW
        CALL    ReleaseFontAccess
        POP     DS
 END;


 PROCEDURE GetChar8x16(Table,CharNum:Byte; VAR BitMap:Char8x16); ASSEMBLER;
 ASM
        CALL    GetFontAccess
        LES     DI, BitMap
        PUSH    DS

        MOV     AX, $A000
        MOV     DS, AX
        XOR     AL, AL
        MOV     AL, Table
        MOV     CX, $4000
        MUL     CX
        MOV     SI, AX
        MOV     CX, $FF

        MOV     AL, CharNum
        MOV     CL, 32
        MUL     CL
        ADD     SI, AX

        MOV     CX, 8
        REP     MOVSW
        CALL    ReleaseFontAccess
        POP     DS
 END;


 PROCEDURE BIOSLoadFont(CONST Font:Font8x16); ASSEMBLER;
 ASM
        PUSH    BP
        MOV     AX, $1110
        MOV     BX, $1000
        MOV     CX, $FF
        XOR     DX, DX
        LES     BP, Font
        INT     10h
        POP     BP
 END;



 PROCEDURE Set25Lines;
 VAR Mode:Byte;
 BEGIN
   IF StartMode = Mono THEN Mode := Mono ELSE Mode := 3;
   SetVideoMode(Mode);
 END;

 PROCEDURE SetNormalLines;
 BEGIN
   ClrScr(7);
   SetVideoMode(StartMode);
 END;

 PROCEDURE SetCondensedLines;
 BEGIN
   ClrScr(7);
   Load8x8;
   ClrScr(7);
 END;


{----------------------------------------------------------------------------}
{                                                                            }
{                             WINDOWS ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
TYPE
  PWindowImage = ^TWindowImage;
  TWindowImage = RECORD
    Next       : PWindowImage;
    Buffer     : Pointer;
    BuffSize   : Word;
    Coords     : ARRAY[1..4] OF Byte;
    Shadow     : Boolean;
  END;

CONST
  TopWindow    : PWindowImage = NIL;


 PROCEDURE CreateWin(X1,Y1,X2,Y2:Byte; AShadow:Boolean);
 VAR NewWindow: PWindowImage;
 BEGIN
   New(NewWindow);
   Inc(WindowCount);
   WITH NewWindow^ DO
   BEGIN
     Shadow := AShadow;
     IF (Shadow) AND (X2 <= (MaxX-2) ) AND (Y2 < MaxY) THEN
     BEGIN
       Inc(Y2);
       Inc(X2,2);
     END;
     Coords[1]:= X1;  Coords[2] := Y1;
     Coords[3]:= X2;  Coords[4] := Y2;
     Next     := TopWindow;
     BuffSize := Succ(Y2-Y1) * Succ(X2-X1) * 2;
     GetMem(Buffer, BuffSize);
     PartSave(X1,Y1,X2,Y2,Buffer^);
   END;
   TopWindow := NewWindow;
 END;

 PROCEDURE MkWin(AXPos,AYPos   : Byte;
                 AWidth,AHeigth: Byte;
                 AFrameAttr    : Byte;
                 ABoxType      : FrameStyle;
                 ATitle        : STRING);
 VAR I, X2, Y2: Byte;
 BEGIN
   X2 := AXPos + AWidth;
   Y2 := AYPos + AHeigth;
   CreateWin(AXPos,AYPos,X2,Y2,WinShadow);
   IF GrowWindow
     THEN GrowFBox(AXPos,AYPos,X2,Y2,AFrameAttr,ABoxType)
     ELSE FBox(AXPos,AYPos,X2,Y2,AFrameAttr,ABoxType);
   IF (WinShadow) AND (X2 <= (MaxX-2)) AND (Y2 < MaxY) THEN
   BEGIN
     FOR I := AYPos+1 TO Y2+1 DO Attribute(X2+1,I,ShadColor,2);
     Attribute(AXPos+2,I,ShadColor,X2-AXPos+1);
   END;
   WriteBetween(AXPos,X2,AYPos,AFrameAttr,ATitle);
 END;

 PROCEDURE OpenWin(AXPos,AYPos         : Byte;
                   AWidth,AHeigth      : Byte;
                   ANormAttr,ATitleAttr: Byte;
                   ABoxType            : FrameStyle;
                   ATitle              : STRING);
 VAR TMPTitle:STRING; X:Byte;
 BEGIN
   MkWin(AXPos,AYPos,AWidth,AHeigth,ANormAttr,ABoxType,'');
   IF ATitle <> ''
     THEN BEGIN
            TMPTitle := '[ ~'+ATitle+'~ ]';
            X := AXPos+ ((AWidth+1-Length(TMPTitle)) DIV 2)+1;
            WriteHi(X,AYPos,ANormAttr,ATitleAttr,TMPTitle);
          END;
 END;

 PROCEDURE RmWin;
 VAR OldWindow:PWindowImage;
 BEGIN
   OldWindow := TopWindow;
   IF OldWindow <> NIL THEN
   BEGIN
     WITH OldWindow^ DO
     BEGIN
       PartRestore(Coords[1],Coords[2],Coords[3],Coords[4], Buffer^);
       FreeMem(Buffer,BuffSize);
       TopWindow := OldWindow^.Next;
     END;
     Dispose(OldWindow);
     Dec(WindowCount);
   END;
 END;

{----------------------------------------------------------------------------}
{                                                                            }
{                             KEYBOARD ROUTINES                              }
{                                                                            }
{----------------------------------------------------------------------------}

 PROCEDURE GetStatus; NEAR; ASSEMBLER;
 ASM
  MOV ES, Seg0040
  MOV BL, BYTE PTR ES:[$17]
  MOV AX, True
 END;

 FUNCTION AltPressed:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, 8
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION CtrlPressed:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, 4
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION ShiftPressed:Boolean; ASSEMBLER;
 ASM
        MOV     SI, $40
        MOV     ES, SI
        MOV     AL, BYTE PTR ES:$17
        MOV     BL, True
        TEST    AL, 2
        JNZ     @OK
        TEST    AL, 1
        JNZ     @OK
        MOV     BL, False
 @OK:   MOV     AL, BL
 END;

 FUNCTION RightShiftPressed:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, 1
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION LeftShiftPressed:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, 2
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION ScrollOn:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, $10
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION NumOn:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, $20
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;

 FUNCTION CapsOn:Boolean; ASSEMBLER;
 ASM
        CALL    GetStatus
        TEST    BL, $40
        JNZ     @OK
        MOV     AL, False
 @OK:
 END;


 PROCEDURE SetCaps(On:Boolean); ASSEMBLER;
 ASM
        MOV     ES, Seg0040
        CMP     On, True
        JE      @SetC
        AND     BYTE PTR ES:$17, $BF
        JMP     @End
 @SetC:
        OR      BYTE PTR ES:$17, $40
 @End:
 END;

 PROCEDURE SetNum(On:Boolean); ASSEMBLER;
 ASM
        MOV     ES, Seg0040
        CMP     On, True
        JE      @SetC
        AND     BYTE PTR ES:$17, $DF
        JMP     @End
 @SetC:
        OR      BYTE PTR ES:$17, $20
 @End:
 END;

 PROCEDURE SetScroll(On:Boolean); ASSEMBLER;
 ASM
        MOV     ES, Seg0040
        CMP     On, True
        JE      @SetC
        AND     BYTE PTR ES:$17, $EF
        JMP     @End
 @SetC:
        OR      BYTE PTR ES:$17, $10
 @End:
 END;


 PROCEDURE CallIdleHook; INLINE($FF/$1E/IdleHook);
 PROCEDURE CallPressedHook(VAR Key: Word); INLINE($FF/$1E/PressedHook);


 FUNCTION ReadKey: Word; ASSEMBLER;
 ASM
        XOR     AH, AH
        INT     16H
        CMP     AL, 0
        JE      @End
        XOR     AH, AH
 @End:
 END;

 FUNCTION KeyPressed: Boolean; ASSEMBLER;
 ASM
        MOV     AH,1
        INT     16H
        MOV     AL, True
        JNZ     @End
        MOV     AL, False
 @End:
 END;

 PROCEDURE PressKey(Key:Word); ASSEMBLER;
 ASM
        MOV     AH, 5
        MOV     CX, Key
        INT     16h
 END;

 FUNCTION GetKey:Word;
 VAR Key:Word; Action,Finished:Boolean;
 BEGIN
   Finished := False;
   Action   := False;
   REPEAT
     GiveUpTimeSlice;
     IF IdleHook <> NIL THEN CallIdleHook;
     IF KeyPressed THEN Action := True;
   UNTIL Action;
   Key := ReadKey;
   IF (Key = 9)       AND NOT (CtrlPressed) THEN Key := kbTab;
   IF (Key = 8)       AND NOT (CtrlPressed) THEN Key := kbBSpace;
   IF (Key = 127)     AND     (CtrlPressed) THEN Key := kbCtrlBSpace;
   IF (Key = kbEnter) AND     (CtrlPressed) THEN Key := kbCtrlM;
   IF (Key = kbSpace) AND     (AltPressed)  THEN Key := kbAltSpace;
   IF PressedHook <> NIL THEN CallPressedHook(Key);
   GetKey := Key;
 END;

 FUNCTION Translate(CONST Source,Dest:KBChars; Symbol:Char): Char;
 VAR Index: Byte;
 BEGIN
   FOR Index := 1 TO 60 DO
    IF Symbol = Source[Index]
     THEN
     BEGIN
       Translate := Dest[Index];
       Break;
    END ELSE Translate := Symbol;
 END;

 PROCEDURE TranslateStr(CONST Source,Dest:KBChars; VAR S:STRING);
 VAR I,B:Byte;C:Char;
 BEGIN
   FOR I := 1 TO Length(S) DO
   BEGIN
     C := S[i];
     B := Pos(C,Source);
     IF B > 0 THEN S[i] := Dest[B];
   END;
 END;

 FUNCTION NormalChar(AltKey:Word): Char;
 VAR A: Char;
 BEGIN
   A := #0;
   CASE AltKey OF
     kbAltA:A:='A'; kbAltB:A:='B'; kbAltC:A:='C'; kbAltD:A:='D';
     kbAltE:A:='E'; kbAltF:A:='F'; kbAltG:A:='G'; kbAltH:A:='H';
     kbAltI:A:='I'; kbAltJ:A:='J'; kbAltK:A:='K'; kbAltL:A:='L';
     kbAltM:A:='M'; kbAltN:A:='N'; kbAltO:A:='O'; kbAltP:A:='P';
     kbAltQ:A:='Q'; kbAltR:A:='R'; kbAltS:A:='S'; kbAltT:A:='T';
     kbAltU:A:='U'; kbAltV:A:='V'; kbAltW:A:='W'; kbAltX:A:='X';
     kbAltY:A:='Y'; kbAltZ:A:='Z'; kbAlt1:A:='1'; kbAlt2:A:='2';
     kbAlt3:A:='3'; kbAlt4:A:='4'; kbAlt5:A:='5'; kbAlt6:A:='6';
     kbAlt7:A:='7'; kbAlt8:A:='8'; kbAlt9:A:='9'; kbAlt0:A:='0';
   END;
   NormalChar := A;
 END;

 PROCEDURE Pause;
 VAR Key:Word;
 BEGIN
   ClearKBuffer;
   Key := GetKey;
   ClearKBuffer;
 END;

 PROCEDURE DelayKey(Time:Byte);
 VAR I:Byte; Key:Word;
 BEGIN
   FOR I := 1 TO Time DO
   BEGIN
     IF KeyPressed THEN Exit;
     Wait(1);
   END;
 END;

 PROCEDURE ClearKBuffer;
 BEGIN
(*  ASM
    CLI
    MOV  AX, 040h
    MOV  ES, AX
    MOV  AX, WORD PTR ES:[$1C]
    MOV  WORD PTR ES:[$1A], AX { Clear KBD buffer }
    STI
  END;*)
   INLINE($FA);
   MemW[Seg0040:$1A] := MemW[Seg0040:$1C];
   INLINE($FB);
 END;

 {$F+}
 FUNCTION SetKeyboardSpeed(Rate:Byte): Boolean;
 BEGIN
  INLINE($32/$D2/$B4/$F3/$FA/$E8/$13/$00/$75/$0A/$8A/$66/$06/$E8/
         $0B/$00/$75/$02/$FE/$C2/$FB/$88/$56/$FF/$EB/$27/$90/$51/
         $53/$B3/$03/$33/$C9/$E4/$64/$A8/$02/$E0/$FA/$8A/$C4/$E6/
         $60/$E4/$64/$A8/$01/$E1/$FA/$E4/$60/$3C/$FA/$74/$07/$FE/
         $CB/$75/$E6/$80/$CB/$01/$5B/$59/$C3);
 END;
 {$F-}

 PROCEDURE MaxKeyboardSpeed;
 BEGIN
   SetKeyboardSpeed(0);
 END;

{----------------------------------------------------------------------------}
{                                                                            }
{                               MOUSE ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}

 {$F+}
 PROCEDURE DefaultMouseHandler; ASSEMBLER;
 ASM
        PUSH    DS
        MOV     AX, SEG @Data
        MOV     DS, AX
        MOV     MouseStatus.MouseX, CX
        MOV     MouseStatus.MouseY, DX
        MOV     MouseStatus.LeftButton, Released
        MOV     MouseStatus.RightButton, Released
        MOV     MouseStatus.MiddleButton, Released
 @TestLeft:
        PUSH    BX
        AND     BX, $01
        JZ      @TestRight
        MOV     MouseStatus.LeftButton, Pressed
 @TestRight:
        POP     BX
        PUSH    BX
        AND     BX, $02
        JZ      @TestMiddle
        MOV     MouseStatus.RightButton, Pressed
 @TestMiddle:
        POP     BX
        AND     BX, $04
        JZ      @EndTest
        MOV     MouseStatus.MiddleButton, Pressed
 @EndTest:
        POP     DS
 END;
 {$F-}



 PROCEDURE InitMouse;
 BEGIN
  ASM
        MOV     MouseInstalled, True
        MOV     AX, $0021
        INT     33H
        CMP     AX, $FFFF
        JE      @OK
        MOV     MouseInstalled, False
  @OK:
  END;
  IF MouseInstalled THEN
  BEGIN
    SetEventHandler($FFFF, @DefaultMouseHandler);
    GetMouseStatus(MouseStatus);
  END;
 END;


 FUNCTION MouseVersion: Word; ASSEMBLER;
 ASM
        MOV     AX, $0024
        INT     33H
        MOV     AX, BX
 END;

 FUNCTION GetMouseX: Integer; ASSEMBLER;
 ASM
        MOV     AX, $0003
        INT     33h
        MOV     AX, CX
 END;

 FUNCTION GetMouseY: Integer; ASSEMBLER;
 ASM
        MOV     AX, $0003
        INT     33h
        MOV     AX, DX
 END;

 PROCEDURE GetMouseXY(VAR X,Y:Integer); ASSEMBLER;
 ASM
        MOV     AX, $0003
        INT     33h
        MOV     WORD PTR X, CX
        MOV     WORD PTR Y, DX
 END;

 PROCEDURE SetMouseXY(X,Y:Integer); ASSEMBLER;
 ASM
        MOV     AX, $0004
        MOV     CX, X
        MOV     DX, Y
        INT     33h
 END;

 FUNCTION MouseButtonPressed: Boolean; ASSEMBLER;
 ASM
        MOV     AX, $0003
        INT     33h
        MOV     AX, True
        AND     BX, 7
        CMP     BX, 0
        JNE     @End
        MOV     AX, False
 @End:
 END;

 FUNCTION GetMouseButton(Button:TMouseButtons): TButtonState;
 VAR Btns:Integer; Flag:Byte;
 BEGIN
   ASM
        MOV     AX, $0003
        INT     33h
        MOV     Btns, BX
   END;
     IF Button = btnLeft   THEN Flag := $01 ELSE
     IF Button = btnRight  THEN Flag := $02 ELSE
     IF Button = btnMiddle THEN Flag := $04;
   IF (Btns AND Flag) <> 0
     THEN GetMouseButton := Pressed
     ELSE GetMouseButton := Released;
 END;

 PROCEDURE GetMouseStatus(VAR InVAR:TMouseStatus);
 VAR Btns: Integer;
 BEGIN
   ASM
        MOV     AX, $0003
        INT     33h
        MOV     Btns, BX
   END;
   WITH InVAR DO
   BEGIN
     GetMouseXY(MouseX,MouseY);
     LeftButton   := Released;
     RightButton  := Released;
     MiddleButton := Released;
     IF (Btns AND $01) <> 0 THEN LeftButton   := Pressed;
     IF (Btns AND $02) <> 0 THEN RightButton  := Pressed;
     IF (Btns AND $04) <> 0 THEN MiddleButton := Pressed;
   END;
 END;

 FUNCTION LastXPress(Button: TMouseButtons): Word; ASSEMBLER;
 ASM
        MOV     AX, $0005
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, CX
 END;

 FUNCTION LastXRelease(Button: TMouseButtons): Word; ASSEMBLER;
 ASM
        MOV     AX, $0006
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, CX
 END;

 FUNCTION LastYPress(Button: TMouseButtons): Word; ASSEMBLER;
 ASM
        MOV     AX, $0005
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, DX
 END;

 FUNCTION LastYRelease(Button: TMouseButtons): Word; ASSEMBLER;
 ASM
        MOV     AX, $0006
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, DX
 END;

 FUNCTION MouseButtonPresses(Button: TMouseButtons): Word; ASSEMBLER;
 { Since last check }
 ASM
        MOV     AX, $0005
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, BX
 END;

 FUNCTION MouseButtonReleases(Button: TMouseButtons): Word; ASSEMBLER;
 { Since last check }
 ASM
        MOV     AX, $0006
        XOR     BX, BX
        MOV     BL, Button
        INT     33h
        MOV     AX, BX
 END;

 FUNCTION LastXMovement: TMouseDirection; ASSEMBLER;
 ASM
        MOV     AX, $000B
        INT     33h
        CMP     CX, 0
        JNE     @Left
        MOV     AX, NoMove
        JMP     @EndTest
 @Left:
        CMP     CX, $7FFF
        JBE     @Right
        MOV     AX, MoveLEFT
        JMP     @EndTest
 @Right:
        MOV     AX, MoveRIGHT
 @EndTest:
 END;

 FUNCTION LastYMovement: TMouseDirection; ASSEMBLER;
 ASM
        MOV     AX, $000B
        INT     33h
        CMP     DX, 0
        JNE     @Up
        MOV     AX, NoMove
        JMP     @EndTest
 @Up:
        CMP     DX, $7FFF
        JBE     @Down
        MOV     AX, MoveUP
        JMP     @EndTest
 @Down:
        MOV     AX, MoveDOWN
 @EndTest:
 END;

 PROCEDURE SetMinMaxX(Min,Max: Integer); ASSEMBLER;
 ASM
        MOV     AX, $0007
        MOV     CX, Min
        MOV     DX, Max
        INT     33h
 END;

 PROCEDURE SetMinMaxY(Min,Max: Integer); ASSEMBLER;
 ASM
        MOV     AX, $0008
        MOV     CX, Min
        MOV     DX, Max
        INT     33h
 END;

 PROCEDURE SetMouseBox(X1,Y1,X2,Y2: Integer); ASSEMBLER;
 ASM
        MOV     AX, $0007
        MOV     CX, X1
        MOV     DX, X2
        INT     33h
        MOV     AX, $0008
        MOV     CX, Y1
        MOV     DX, Y2
        INT     33h
 END;

 PROCEDURE HardwareMouseCursor(FromLine,ToLine: Word); ASSEMBLER;
 { Color scan lines 0..7, Monochrome - 0..13 }
 ASM
        MOV     AX, $000A
        MOV     BX, 1
        MOV     CX, FromLine
        MOV     DX, ToLine
        INT     33h
 END;

 PROCEDURE SoftwareMouseCursor(ScreenMasc,CursorMasc: Word); ASSEMBLER;
 ASM
        MOV     AX, $000A
        XOR     BX, BX          { BX := 0 }
        MOV     CX, ScreenMasc
        MOV     DX, CursorMasc
        INT     33h
 END;

 PROCEDURE SetMouseSensetivity(X,Y: Word); ASSEMBLER;
 ASM
        MOV     AX, $000F
        MOV     CX, X
        MOV     DX, Y
        INT     33h
 END;

 PROCEDURE SetEventHandler(Masc: Word; NewHandler: Pointer); ASSEMBLER;
 ASM
        MOV     AX, $000C
        MOV     CX, Masc
        LES     DX, NewHandler
        INT     33h
 END;

 PROCEDURE SetGraphicMouseCursor(HotSpotX,HotSpotY: Integer;
                                 VAR CursorBitMAP: MouseCursorARRAY); ASSEMBLER;
 ASM
        PUSH    ES
        MOV     AX, $0009
        MOV     BX, HotSpotX
        MOV     CX, HotSpotY
        LES     DX, CursorBitMAP
        INT     33h
        POP     ES
 END;

 PROCEDURE SetWatchMouseCursor;
 CONST WatchCursor:MouseCursorARRAY =
   ( $E007,$C003,$8001,$0000,$0000,$0000,$0000,$0000,
     $0000,$0000,$0000,$0000,$0000,$8001,$C003,$E007,
     $0000,$1FF8,$318C,$6186,$4012,$4022,$4042,$718C,
     $718C,$4062,$4032,$4002,$6186,$318C,$1FF8,$0000);
 BEGIN
   SetGraphicMouseCursor(0,0,WatchCursor);
 END;

 PROCEDURE SetHourglassMouseCursor;
 CONST HourglassCursor:MouseCursorARRAY =
  ( $0000,$0000,$0000,$0000,$8001,$C003,$E007,$F00F,
    $E007,$C003,$8001,$0000,$0000,$0000,$0000,$FFFF,
    $0000,$7FFE,$6006,$300C,$1818,$0C30,$0660,$03C0,
    $0660,$0C30,$1998,$33CC,$67E6,$7FFE,$0000,$0000 );
 BEGIN
   SetGraphicMouseCursor(7,7,HourglassCursor);
 END;

 PROCEDURE SetUpArrowCursor;
 CONST UpArrowCursor:MouseCursorARRAY =
   ( $F9FF,$F0FF,$E07F,$E07F,$C03F,$C03F,$801F,$801F,
     $000F,$000F,$F0FF,$F0FF,$F0FF,$F0FF,$F0FF,$F0FF,
     $0000,$0600,$0F00,$0F00,$1F80,$1F80,$3FC0,$3FC0,
     $7FE0,$0600,$0600,$0600,$0600,$0600,$0600,$0600 );
 BEGIN
   SetGraphicMouseCursor(5,0,UpArrowCursor);
 END;

 PROCEDURE SetCheckMarkCursor;
 CONST CheckMarkCursor:MouseCursorARRAY =
   ( $FFF0,$FFE0,$FFC0,$FF81,$FF03,$0607,$000F,$001F,
     $C03F,$F07F,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,
     $0000,$0006,$000C,$0018,$0030,$0060,$70C0,$1D80,
     $0700,$0000,$0000,$0000,$0000,$0000,$0000,$0000 );
 BEGIN
   SetGraphicMouseCursor(6,7,CheckMarkCursor);
 END;

 PROCEDURE SetDiagonalCrossCursor;
 CONST DiagonalCrossCursor:MouseCursorARRAY =
   ( $07E0,$0180,$0000,$C003,$F00F,$C003,$0000,$0180,
     $07E0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,
     $0000,$700E,$1C38,$0660,$03C0,$0660,$1C38,$700E,
     $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000 );
 BEGIN
   SetGraphicMouseCursor(7,4,DiagonalCrossCursor);
 END;

 PROCEDURE SetRectangularCrossCursor;
 CONST RectangularCrossCursor:MouseCursorARRAY =
   ( $FC3F,$FC3F,$FC3F,$0000,$0000,$0000,$FC3F,$FC3F,
     $FC3F,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,
     $0000,$0180,$0180,$0180,$7FFE,$0180,$0180,$0180,
     $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000);
 BEGIN
   SetGraphicMouseCursor(7,4,RectangularCrossCursor);
 END;

 PROCEDURE SetPointingHandCursor;
 CONST PointingHandCursor:MouseCursorARRAY =
  ( $E1FF,$E1FF,$E1FF,$E1FF,$E1FF,$E000,$E000,$E000,
    $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,
    $1E00,$1200,$1200,$1200,$1200,$13FF,$1249,$1249,
    $F249,$9001,$9001,$9001,$8001,$8001,$8001,$FFFF );
 BEGIN
   SetGraphicMouseCursor(5,0,PointingHandCursor);
 END;


{----------------------------------------------------------------------------}
{                                                                            }
{                              STRING ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
CONST
  Floating     = 255;
  HexChars     : ARRAY[0..$F] OF Char = '0123456789ABCDEF';


 FUNCTION Replicate(Number:Byte; Character:Char):STRING; ASSEMBLER;
 ASM
        LES     DI, @Result
        CLD
        XOR     CH, CH
        MOV     CL, Number
        MOV     AX, CX
        STOSB
        MOV     AL, Character
        REP     STOSB
 END;

 FUNCTION Frequency(Match:STRING; Source:STRING): Byte;
 VAR Len,Loc,Counter: Byte;
 BEGIN
   Counter := 0;
   Len     := Length(Match);
   IF (Len <> 0) AND (length(Source) > 0)
     THEN
       REPEAT
         Loc := Pos(Match,Source);
         IF Loc <> 0 THEN
         BEGIN
           Inc(Counter);
           Delete(Source,Loc,Length(Match));
         END;
       UNTIL Loc = 0;
   Frequency := Counter;
 END;


{Compare SearchStr with NameStr, and allow wildcards in SearchStr.
 The following wildcards are allowed:
 *ABC*        matches everything which contains ABC
 [A-C]*       matches everything that starts with either A,B or C
 [ADEF-JW-Z]  matches A,D,E,F,G,H,I,J,W,V,X,Y or Z
 ABC?         matches ABC, ABC1, ABC2, ABCA, ABCB etc.
 ABC[?]       matches ABC1, ABC2, ABCA, ABCB etc. (but not ABC)
 ABC*         matches everything starting with ABC
 (for using with DOS filenames like DOS (and 4DOS), you must split the
  filename in the extention and the filename, and compare them seperately)}
 FUNCTION CompareStr(NameStr,SearchStr:STRING): Boolean; ASSEMBLER;
 VAR LastW:Word;
 ASM
        CLD
        PUSH    DS
        LDS     SI, SearchStr
        LES     DI, NameStr
        XOR     AH, AH
        LODSB
        MOV     CX, AX
        MOV     AL, ES:[DI]
        INC     DI
        MOV     BX, AX
        OR      CX, CX
        JNZ     @ChkChr
        OR      BX, BX
        JZ      @ChrAOk
        JMP     @ChrNOk
        XOR     DH, DH
 @ChkChr:
        LODSB
        CMP     AL, '*'
        JNE     @ChkQues
        DEC     CX
        JZ      @ChrAOk
        MOV     DH, 1
        MOV     LastW, CX
        JMP     @ChkChr
 @ChkQues:
        CMP     AL, '?'
        JNZ     @NormChr
        INC     DI
        OR      BX, BX
        JE      @ChrOk
        DEC     BX
        JMP     @ChrOk
 @NormChr:
        OR      BX, BX
        JE      @ChrNOk
 {From here to @No4DosChr is used for [0-9]/[?]/[!0-9] 4DOS wildcards...}
        CMP     AL, '['
        JNE     @No4DosChr
        CMP     WORD PTR [SI], ']?'
        JE      @SkipRange
        MOV     AH, BYTE PTR ES:[DI]
        XOR     DL, DL
        CMP     BYTE PTR [si], '!'
        JNZ     @ChkRange
        INC     SI
        DEC     CX
        JZ      @ChrNOk
        INC     DX
 @ChkRange:
        LODSB
        DEC     CX
        JZ      @ChrNOk
        CMP     AL, ']'
        JE      @NChrNOk
        CMP     AH, AL
        JE      @NChrOk
        CMP     BYTE PTR [SI], '-'
        JNE     @ChkRange
        INC     SI
        DEC     CX
        JZ      @ChrNOk
        CMP     AH, AL
        JAE     @ChkR2
        INC     SI              {Throw a-Z < away}
        DEC     CX
        JZ      @ChrNOk
        JMP     @ChkRange
 @ChkR2:
        LODSB
        DEC     CX
        JZ      @ChrNOk
        CMP     AH, AL
        JA      @ChkRange        {= jbe @NChrOk; jmp @ChkRange}
 @NChrOk:
        OR      DL, DL
        JNZ     @ChrNOk
        INC     DX
 @NChrNOk:
        OR      DL, DL
        JZ      @ChrNOk
 @NNChrOk:
        CMP     AL, ']'
        JE      @NNNChrOk
 @SkipRange:
        LODSB
        CMP     AL, ']'
        LOOPNE  @SkipRange
        JNE     @ChrNOk
 @NNNChrOk:
        DEC     BX
        INC     DI
        JMP     @ChrOk
 @No4DosChr:
        CMP     ES:[DI], AL
        JNE     @ChrNOk
        INC     DI
        DEC     BX
 @ChrOk:
        XOR     DH, DH
        DEC     CX
        JNZ     @ChkChr        { Can't use loop, distance >128 bytes }
        OR      BX, BX
        JNZ     @ChrNOk
 @ChrAOk:
        MOV     AL, 1
        JMP     @EndR
 @ChrNOk:
        OR      DH, DH
        JZ      @IChrNOk
        JCXZ    @IChrNOk
        OR      BX, BX
        JZ      @IChrNOk
        INC     DI
        DEC     BX
        JZ      @IChrNOk
        MOV     AX, [LastW]
        SUB     AX, CX
        ADD     CX, AX
        SUB     SI, AX
        DEC     SI
        JMP     @ChkChr
 @IChrNOK:
        MOV     AL, 0
 @EndR:
        POP     DS
 END;

 FUNCTION EmptyStr(Str:STRING): Boolean; ASSEMBLER;
 ASM
        CLD
        XOR     CH, CH
        LES     DI, Str
        MOV     CL, BYTE PTR ES:[DI]
        JCXZ    @OK
        INC     DI
        MOV     AL, ' '
        REPE    SCASB
        JZ      @OK
        MOV     AL, False
        JMP     @End
 @OK:
        MOV     AL, True
 @End:
 END;

 FUNCTION CurrentTime: STRING;
 VAR H,M,S,T:Word; Hour,Min,Sec:STRING[2];
 BEGIN
   GetTime(H,M,S,T);
   Str(H,Hour);
   Str(M,Min);
   Str(S,Sec);
   IF S < 10 THEN Sec := '0'+Sec;
   IF M < 10 THEN Min := '0'+Min;
   IF Length(Hour) = 1 THEN Hour := ' '+Hour;
   CurrentTime := Hour+':'+Min+':'+Sec;
 END;

 FUNCTION CurrentDate: STRING;
 VAR Y,M,D,Dow: Word; Day,Month,Year: STRING[4];
 BEGIN
   GetDate(Y,M,D,Dow);
   Str(D,Day);
   Str(M,Month);
   Str(Y,Year);
   IF D < 10 THEN Day := '0'+Day;
   IF M < 10 THEN Month := '0'+Month;
   CurrentDate :=  Day+'-'+Month+'-'+Year;
 END;


 FUNCTION EncodeStr(StrIn: eString): STRING;
 VAR
   CurrChr: Byte;
   Counter: Byte;
   Len,Key: Byte;
   DIVPart: Byte;
   MODPart: Byte;
   StrOut : STRING;
 BEGIN
   Key       := 3;
   Len       := Length(StrIn);
   StrOut    := '';
   FOR Counter := 1 TO Len DO
   BEGIN
     CurrChr := Ord(StrIn[Counter]);
     DIVPart := CurrChr DIV Key;
     MODPart := CurrChr MOD Key;
     StrOut  := StrOut + Chr(DIVPart) + Chr(MODPart);
   END;
   FOR Counter := 1 TO Length(StrOut) DO
     StrOut[Counter] := Chr(Ord(StrOut[Counter]) XOR (Ord(StrOut[0])+127));
   EncodeStr := StrOut;
 END;

 FUNCTION DecodeStr(StrIn: STRING): eString;
 VAR
   Counter: Byte;
   Len,Key: Byte;
   DIVPart: Byte;
   MODPart: Byte;
   StrOut : STRING;
 BEGIN
   FOR Counter := 1 TO Length(StrIn) DO
     StrIn[Counter] := Chr(Ord(StrIn[Counter]) XOR (Ord(StrIn[0])+127));
   Key     := 3;
   Len     := Length(StrIn);
   StrOut  := '';
   Counter := 1;
   REPEAT
     DIVPart := Ord(StrIn[Counter]);
     MODPart := Ord(StrIn[Counter+1]);
     StrOut  := StrOut + Chr(DIVPart * Key + MODPart);
     Inc(Counter,2);
   UNTIL Counter >= Len;
   DecodeStr := StrOut;
 END;


 FUNCTION IsLower(C:Char): Boolean; ASSEMBLER;
 ASM
        MOV     CL, C
        MOV     AL, False
        CMP     CL, 'a'
        JB      @End
        CMP     CL, 'z'
        JA      @End
        MOV     AL, True
 @End:
 END;

 FUNCTION IsUpper(C:Char): Boolean; ASSEMBLER;
 ASM
        MOV     CL, C
        MOV     AL, False
        CMP     CL, 'A'
        JB      @End
        CMP     CL, 'Z'
        JA      @End
        MOV     AL, True
 @End:
 END;

 FUNCTION IsDigit(C:Char): Boolean; ASSEMBLER;
 ASM
        MOV     CL, C
        MOV     AL, False
        CMP     CL, '0'
        JB      @End
        CMP     CL, '9'
        JA      @End
        MOV     AL, True
 @End:
 END;

 FUNCTION IsAlpha(C:Char): Boolean; ASSEMBLER;
 ASM
        MOV     CL, C
        MOV     AL, False
        CMP     CL, 'A'
        JB      @End
        CMP     CL, 'Z'
        JBE     @Ok
        CMP     CL, 'a'
        JB      @End
        CMP     CL, 'z'
        JA      @End
 @Ok:   MOV     AL, True
 @End:
 END;

 FUNCTION IsAlNum(C:Char): Boolean; ASSEMBLER;
 ASM
        MOV     CL, C
        MOV     AL, False
        CMP     CL, '0'
        JB      @End
        CMP     CL, '9'
        JBE     @Ok
        CMP     CL, 'A'
        JB      @End
        CMP     CL, 'Z'
        JBE     @Ok
        CMP     CL, 'a'
        JB      @End
        CMP     CL, 'z'
        JA      @End
 @Ok:   MOV     AL, True
 @End:
 END;

 FUNCTION FirstUpperPos(Str:STRING): Byte; ASSEMBLER;
 ASM
        XOR     AL, AL
        XOR     DL, DL
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        JCXZ    @ExitProc
        MOV     DL,CL
        INC     DL
 @CheckForUpper:
        INC     DI
        INC     AL
        CMP     ES:BYTE PTR[DI],'A'
        JB      @Next
        CMP     ES:BYTE PTR[DI],'Z'
        JA      @Next
        JMP     @End
 @Next:
        LOOP    @CheckForUpper
 @End:
        CMP     AL, DL
        JNA     @ExitProc
        XOR     AL, AL
 @ExitProc:
 END;

 FUNCTION FirstUpperChar(Str:STRING): Char; ASSEMBLER;
 ASM
        XOR     AL, AL
        XOR     DL, DL
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        JCXZ    @ExitProc
        MOV     DL,CL
        INC     DL
 @CheckForUpper:
        INC     DI
        INC     AL
        CMP     ES:BYTE PTR[DI],'A'
        JB      @Next
        CMP     ES:BYTE PTR[DI],'Z'
        JA      @Next
        JMP     @End
 @Next:
        LOOP    @CheckForUpper
 @End:
        CMP     AL, DL
        JNA     @RetChar
        XOR     AL, AL
 @RetChar:
        LES     DI, Str
        ADD     DI, AX
        MOV     AL, ES:[DI]
 @ExitProc:
 END;

 FUNCTION FirstLowerPos(Str:STRING): Byte; ASSEMBLER;
 ASM
        XOR     AL, AL
        XOR     DL, DL
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        JCXZ    @ExitProc
        MOV     DL,CL
        INC     DL
 @CheckForLower:
        INC     DI
        INC     AL
        CMP     ES:BYTE PTR[DI],'a'
        JB      @Next
        CMP     ES:BYTE PTR[DI],'z'
        JA      @Next
        JMP     @End
 @Next:
        LOOP    @CheckForLower
 @End:
        CMP     AL, DL
        JNA     @ExitProc
        XOR     AL, AL
 @ExitProc:
 END;

 FUNCTION FirstLowerChar(Str:STRING): Char; ASSEMBLER;
 ASM
        XOR     AL, AL
        XOR     DL, DL
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        JCXZ    @ExitProc
        MOV     DL,CL
        INC     DL
 @CheckForLower:
        INC     DI
        INC     AL
        CMP     ES:BYTE PTR[DI],'a'
        JB      @Next
        CMP     ES:BYTE PTR[DI],'z'
        JA      @Next
        JMP     @End
 @Next:
        LOOP    @CheckForLower
 @End:
        CMP     AL, DL
        JNA     @RetChar
        XOR     AL, AL
 @RetChar:
        LES     DI, Str
        ADD     DI, AX
        MOV     AL, ES:[DI]
 @ExitProc:
 END;

 FUNCTION LastPos(AChar:Char; Str:STRING): Byte; ASSEMBLER;
 ASM
        PUSH    DS
        XOR     AX, AX
        XOR     BX, BX
        XOR     CX, CX
        XOR     DX, DX
        MOV     BL, AChar
        LDS     SI, Str
        MOV     CL, DS:[SI]
        JCXZ    @ExitProc
        MOV     BH, CL
        INC     BH
        ADD     SI, CX
        STD
 @SearchChar:
        INC     DL
        LODSB
        CMP     AL, BL
        JNE     @Next
        MOV     BL, True
        JMP     @End
 @Next:
        LOOP    @SearchChar
 @End:
        CMP     BL, True
        JE      @SetValue
        XOR     DX, DX
        JMP     @ExitProc
 @SetValue:
        SUB     BH, DL
        MOV     DL, BH
 @ExitProc:
        MOV     AX, DX
        POP     DS
 END;


 FUNCTION PadLeft(Str:STRING; Size:Byte; Pad:Char): STRING; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        LDS     SI, Str
        XOR     AX, AX
        LODSB
        MOV     CX, AX
        LES     DI, @Result
        INC     DI
        REP     MOVSB
        MOV     CL, Size
        SUB     CL, AL
        CMP     CX, 0
        JNB     @@1
        XOR     CX, CX
 @@1:
        MOV     AL, Pad
        REP     STOSB
        MOV     DI, WORD PTR @Result
        MOV     AL, Size
        MOV     BYTE PTR ES:[DI], AL
        POP     DS
 END;

 FUNCTION PadRight(Str:STRING; Size:Byte; Pad:Char): STRING; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        LES     DI, @Result
        INC     DI
        LDS     SI, Str
        XOR     AX, AX
        LODSB
        MOV     BX, AX
        XOR     CX, CX
        MOV     CL, Size
        CMP     AL, CL
        JA      @@2
        SUB     CL, AL
        CMP     CX, 0
        JNB     @@1
        XOR     CX, CX
 @@1:
        MOV     AL, Pad
        REP     STOSB
 @@2:
        MOV     CX, BX
        REP     MOVSB
        MOV     DI, WORD PTR @Result
        MOV     AL, Size
        MOV     BYTE PTR ES:[DI], AL
        POP     DS
 END;

 FUNCTION PadCenter(Str:STRING; Size:Byte; Pad:Char): STRING;
 VAR L:Integer; Temp:STRING;
 BEGIN
   FillChar(Temp[1],Size,Pad);
   Temp[0] := Chr(Size);
   L := Length(Str);
   IF L <= Size
    THEN Move(Str[1],Temp[((Size - L) DIV 2) + 1],L)
    ELSE Move(Str[((L - Size) DIV 2) + 1],Temp[1],Size);
   PadCenter := Temp;
 END;


 FUNCTION First(N:Byte;Str:STRING): STRING;
 VAR Temp:STRING;
 BEGIN
   IF N > Length(Str)
    THEN Temp := Str
    ELSE Temp := Copy(Str,1,N);
   First := Temp;
 END;

 FUNCTION Last(N:Byte; Str:STRING): STRING;
 VAR Temp:STRING;
 BEGIN
   IF N > Length(Str)
    THEN Temp := Str
    ELSE Temp := Copy(Str,Succ(Length(Str) - N),N);
   Last := Temp;
 END;



 {$IFDEF DPMI}
 FUNCTION AdjCase(AdjTo:TCase; Str:STRING): STRING;
 VAR I:Byte;

   PROCEDURE DoLower;
   VAR I:Byte;
   BEGIN
     FOR I := 1 TO Length(Str) DO IF (Str[I] IN ['A'..'Z']) THEN Str[I] := Chr(Ord(Str[i])+32);
   END;

   PROCEDURE DoProper;
   VAR I:Byte;
   BEGIN
     IF (Str[1] IN ['a'..'z']) THEN Str[1] := Chr(Ord(Str[1])-32);
     FOR I := 2 TO Length(Str) DO
       IF (Str[I-1] IN [' ','0'..'9']) THEN
         IF (Str[I] IN ['a'..'z']) THEN Str[I] := Chr(Ord(Str[i])-32);
   END;

 BEGIN
   AdjCase := '';
   IF Length(Str) = 0 THEN Exit;
   CASE AdjTo OF
       Upper: FOR I := 1 TO Length(Str) DO IF (Str[I] IN ['a'..'z']) THEN Str[I] := Chr(Ord(Str[i])-32);
       Lower: DoLower;
  ProperFull: BEGIN
                DoLower;
                DoProper;
              END;
  ProperNorm: DoProper;
        Flip: FOR I := 1 TO Length(Str) DO
                IF (Str[I] IN ['a'..'z']) THEN Str[I] := Chr(Ord(Str[i])-32)
                  ELSE IF (Str[I] IN ['A'..'Z']) THEN Str[I] := Chr(Ord(Str[i])+32);
   END;
   AdjCase := Str;
 END;



 {$ELSE}
  {-- Procedures used by ADJCASE --}
  PROCEDURE DoUpper; NEAR; ASSEMBLER;
  ASM
  @DoUpper:
        INC     DI
        MOV     AL, BYTE PTR ES:[DI]
        CMP     AL, 'a'
        JB      @Repeat
        CMP     AL, 'z'
        JA      @Repeat
        SUB     AL, 32
  @Repeat:
        MOV     ES:[DI], AL
        LOOP    @DoUpper
  END;

  PROCEDURE DoLower; NEAR; ASSEMBLER;
  ASM
  @DoLower:
        INC     DI
        CMP     ES:BYTE PTR[DI],'A'
        JB      @Repeat
        CMP     ES:BYTE PTR[DI],'Z'
        JA      @Repeat
        ADD     ES:BYTE PTR[DI],32
  @Repeat:
        LOOP    @DoLower
  END;

  PROCEDURE UpCaseAL; NEAR; ASSEMBLER; {Used by DoProper}
  ASM
        CMP     AL, 'a'
        JB      @End
        CMP     AL, 'z'
        JA      @End
        SUB     AL, 32
  @End:
        MOV     ES:[DI], AL
  END;

  PROCEDURE DoProper; NEAR; ASSEMBLER;
  ASM
        XOR     AL,AL
        INC     DI
        MOV     AL, ES:[DI]
        CALL    UpCaseAL
        DEC CX
        JCXZ    @End
  @DoProper:
        INC     DI
        MOV     AL, ES:[DI-1]
        CMP     AL, ' '
        JE      @DoIt
        CMP     AL, '0'
        JB      @Repeat
        CMP     AL, '9'
        JA      @Repeat
  @DoIt:
        MOV     AL, ES:[DI]
        CALL    UpCaseAL
  @Repeat:
        LOOP    @DoProper
  @End:
  END;
  {-- End of Procedures used by ADJCASE --}

  PROCEDURE DoFlip; NEAR; ASSEMBLER;
  ASM
  @DoFlip:
        INC     DI
        CMP     ES:BYTE PTR[DI],'a'
        JB      @TestUP
        CMP     ES:BYTE PTR[DI],'z'
        JA      @TestUP
        SUB     ES:BYTE PTR[DI],32
        JMP     @Repeat
  @TestUP:
        CMP     ES:BYTE PTR[DI],'A'
        JB      @Repeat
        CMP     ES:BYTE PTR[DI],'Z'
        JA      @Repeat
        ADD     ES:BYTE PTR[DI],32
  @Repeat:
        LOOP    @DoFlip
  END;


 FUNCTION AdjCase(AdjTo:TCase; Str:STRING): STRING; ASSEMBLER;
 ASM
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        JCXZ    @End
 @IsUpper:
        CMP     AdjTo, Upper
        JNE     @IsLower
        CALL    DoUpper
        JMP     @End
 @IsLower:
        CMP     AdjTo, Lower
        JNE     @IsProperNorm
        CALL    DoLower
        JMP     @End
 @IsProperNorm:
        CMP     AdjTo, ProperNorm
        JNE     @IsProperFull
        CALL    DoProper
        JMP     @End
 @IsProperFull:
        CMP     AdjTo, ProperFull
        JNE     @IsFlip
        CALL    DoLower
        LES     DI, Str
        XOR     CX, CX
        MOV     CL, ES:[DI]
        CALL    DoProper
        JMP     @End
 @IsFlip:
        CMP     AdjTo, Flip
        JNE     @End
        CALL    DoFlip
 @End:
        PUSH    DS
        LES     DI, @Result
        LDS     SI, Str
        LODSB
        STOSB
        XCHG    AX, CX
        XOR     CH, CH
        REP     MOVSB
        POP     DS
 END;
 {$ENDIF}


 FUNCTION AdjCaseCyr(AdjTo:TCase; Str:STRING): STRING;
 VAR I:Byte;

   PROCEDURE DoLower;
   VAR I:Byte;
   BEGIN
     FOR I := 1 TO Length(Str) DO IF (Str[I] IN [''..'']) THEN Str[I] := Chr(Ord(Str[i])+32);
   END;

   PROCEDURE DoProper;
   VAR I:Byte;
   BEGIN
     IF (Str[1] IN [''..'']) THEN Str[1] := Chr(Ord(Str[1])-32);
     FOR I := 2 TO Length(Str) DO
       IF (Str[I-1] IN [' ','0'..'9']) THEN
         IF (Str[I] IN [''..'']) THEN Str[I] := Chr(Ord(Str[i])-32);
   END;

 BEGIN
   AdjCaseCyr := '';
   IF Length(Str) = 0 THEN Exit;
   CASE AdjTo OF
       Upper: FOR I := 1 TO Length(Str) DO IF (Str[I] IN [''..'']) THEN Str[I] := Chr(Ord(Str[i])-32);
       Lower: DoLower;
  ProperFull: BEGIN
                DoLower;
                DoProper;
              END;
  ProperNorm: DoProper;
        Flip: FOR I := 1 TO Length(Str) DO
                IF (Str[I] IN [''..'']) THEN Str[I] := Chr(Ord(Str[i])-32)
                  ELSE IF (Str[I] IN [''..'']) THEN Str[I] := Chr(Ord(Str[i])+32);
   END;
   AdjCaseCyr := Str;
 END;


 FUNCTION LocWord(StartAT,WordNo:Byte; Str:STRING): Byte;
 VAR W,L:Integer; SpaceBefore:Boolean;
 BEGIN
   IF (Str = '') OR (WordNo < 1) OR (StartAT > Length(Str)) THEN
    BEGIN
      LocWord := 0;
      Exit;
    END;
   W := 0;
   L := Length(Str);
   StartAT := Pred(StartAT);
   SpaceBefore := True;
   WHILE (W < Wordno) AND (StartAT <= Length(Str)) DO
   BEGIN
     StartAT := Succ(StartAT);
     IF SpaceBefore AND (Str[StartAT] <> ' ')
     THEN
      BEGIN
        W := succ(W);
        SpaceBefore := False;
      END
     ELSE
      IF (SpaceBefore = False) and (Str[StartAT] = ' ')
       THEN SpaceBefore := True;
   END;
   IF W = Wordno
    THEN LocWord := StartAT
    ELSE LocWord := 0;
 END;

 FUNCTION PosWord(WordNo:Byte; Str:STRING): Byte;
 BEGIN
   PosWord := LocWord(1,WordNo,Str);
 END;

 FUNCTION WordCnt(Str:STRING): Byte;
 VAR W,I:Integer; SpaceBefore:Boolean;
 BEGIN
   IF Str = '' THEN
    BEGIN
      WordCnt := 0;
      Exit;
    END;
   W := 0;
   SpaceBefore := True;
   FOR I := 1 TO Length(Str) DO
   BEGIN
     IF SpaceBefore AND (Str[I] <> ' ')
      THEN
       BEGIN
         W := succ(W);
         SpaceBefore := false;
       END
      ELSE
       IF (SpaceBefore = False) AND (Str[I] = ' ')
        THEN SpaceBefore := True;
   END;
   WordCnt := W;
 END;

 FUNCTION ExtractWords(StartWord,NoWords:Byte; Str:STRING): STRING;
 VAR Start,Finish:Integer;
 BEGIN
   IF Str = '' THEN
    BEGIN
      ExtractWords := '';
      Exit;
    END;
   Start := LocWord(1,StartWord,Str);
   IF Start <> 0
    THEN Finish := LocWord(Start,Succ(NoWords),Str)
    ELSE
     BEGIN
       ExtractWords := '';
       Exit;
     END;
    IF Finish <> 0
     THEN
      REPEAT
        Finish := Pred(Finish);
      UNTIL Str[Finish] <> ' '
     ELSE Finish := Length(Str);
   ExtractWords := Copy(Str,Start,Succ(Finish-Start));
 END;

 PROCEDURE OverWrite(OverPos:Byte; VAR Source:STRING; OverStr:STRING);
 VAR Temp:Byte;
 BEGIN
   Temp := OverPos+Length(OverStr);
   IF Temp > Length(Source) THEN Source[0] := Chr(Temp);
   Move(OverStr[1],Source[OverPos],Length(OverStr));
 END;


 {--------------------------------------------------------------------------}
 FUNCTION StripLeft(Str:STRING; C:Char): STRING;
 VAR Index:Byte;
 BEGIN
   WHILE (Str[1] = C) AND (Length(Str) > 0) DO Delete(Str,1,1);
   StripLeft := Str;
 END;

 FUNCTION StripRight(Str:STRING; C:Char): STRING;
 VAR Index:Byte;
 BEGIN
   WHILE (Str[Length(Str)] = C) AND (Length(Str) > 0) DO Delete(Str,Length(Str),1);
   StripRight := Str;
 END;

 FUNCTION StripBoth(Str:STRING; C:Char):STRING;
 BEGIN
   WHILE (Str[1] = C) AND (Length(Str) > 0) DO Delete(Str,1,1);
   WHILE (Str[Length(Str)] = C) AND (Length(Str) > 0) DO Delete(Str,Length(Str),1);
   StripBoth := Str;
 END;

 FUNCTION StripAll(Str:STRING; C:Char):STRING;
 VAR Index:Byte;
 BEGIN
   Index := 1;
   REPEAT
     IF (Str[Index] = C) AND (Length(Str) > 0)
       THEN Delete(Str,Index,1)
       ELSE Index := Succ(Index);
   UNTIL (Index > Length(Str)) OR (Str = '');
   StripAll := Str;
 END;
 {--------------------------------------------------------------------------}


{ FUNCTION StripLeft(Str:STRING; C:Char): STRING; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        LES     DI, @Result
        LDS     SI, Str

        XOR     CX, CX
        LODSB
        MOV     CL, AL
        MOV     BL, AL
        XOR     DL, DL
 @Loop:
        LODSB
        CMP     AL, C
        JNE     @Quit
        INC     DL
        LOOP    @Loop
 @Quit:
        MOV     AL, BL
        SUB     AL, DL
        STOSB
        DEC     SI
 @Exit:
        REP     MOVSB
        POP     DS
 END;

 FUNCTION StripRight(Str:STRING; C:Char): STRING; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        LES     DI, @Result
        LDS     SI, Str
        MOV     BX, DI
        LODSB
        STOSB
        XCHG    AX, CX
        XOR     CH, CH
        REP     MOVSB
        MOV     AL, C
 @Loop:
        CMP     BYTE PTR ES:[DI-1], AL
        JNE     @Quit
        DEC     DI
        MOV     CX, DI
        DEC     BYTE PTR ES:[BX]
        JCXZ    @Quit
        JMP     @Loop
 @Quit:
        POP     DS
 END;

 FUNCTION StripBoth(Str:STRING; C:Char):STRING; ASSEMBLER;
 ASM
        PUSH    DS
        LES     DI, Str
        LDS     SI, Str
        XOR     CX, CX
        MOV     CL, [DI]
        JCXZ    @Exit
        MOV     BX, DI
        XOR     DX, DX
        MOV     AL, C
        STD
        ADD     DI, CX
        REPE    SCASB
        JZ      @Done
        INC     CX
        CLD
        INC     SI
        MOV     DI, SI
        REPE    SCASB
        JZ      @Done
        INC     CX
        DEC     DI
        MOV     DX, CX
        XCHG    DI, SI
        REP     MOVSB
 @Done:
        MOV     [BX], DL
 @Exit:
        LES     DI, @Result
        LDS     SI, Str
        LODSB
        STOSB
        XCHG    AX, CX
        XOR     CH, CH
        REP     MOVSB
        POP     DS
 END;

 FUNCTION StripAll(Str:STRING; C:Char): STRING; ASSEMBLER;
 ASM
        PUSH    DS
        CLD
        LDS     SI, Str
        XOR     AX, AX
        LODSB
        XCHG    AX, CX
        LES     DI, @Result
        INC     DI
        JCXZ    @End
        MOV     BL, C
 @Loop:
        LODSB
        CMP     AL, BL
        JE      @Next
        STOSB
 @Next:
        LOOP    @Loop
 @End:
        XCHG    AX, DI
        MOV     DI, WORD PTR @Result
        SUB     AX, DI
        DEC     AX
        STOSB
        POP     DS
 END;}


 FUNCTION ReplaceChar(Str:STRING; Old,New:Char): STRING; ASSEMBLER;
 ASM
        MOV     BL, New

        PUSH    DS
        LES     DI, @Result
        LDS     SI, Str

        XOR     CX, CX
        LODSB
        STOSB
        MOV     CL, AL
        JCXZ    @End
 @Loop:
        LODSB
        CMP     AL, Old
        JNE     @Next
        MOV     AL, New
 @Next:
        STOSB
        LOOP @Loop
 @End:
        POP     DS
 END;


 { -------------- }
 { FILE FUNCTIONS }
 { -------------- }
 FUNCTION AddSlash(Str:STRING): STRING;
 BEGIN
   IF Str[Length(Str)] <> '\' THEN Str := Str + '\';
   AddSlash := Str;
 END;

 FUNCTION StripSlash(Str:STRING): STRING;
 BEGIN
   IF Str[Length(Str)] = '\' THEN Dec(Byte(Str[0]));
   StripSlash := Str;
 END;

 FUNCTION PathOnly(FileName:STRING): STRING;
 VAR Dir:DirStr; Name:NameStr; Ext:ExtStr;
 BEGIN
   FSplit(FileName,Dir,Name,Ext);
   PathOnly := Dir;
 END;

 FUNCTION NameOnly(FileName:STRING): STRING;
 VAR Dir:DirStr; Name:NameStr; Ext:ExtStr;
 BEGIN
   FSplit(FileName,Dir,Name,Ext);
   NameOnly := Name + Ext;
 END;

 FUNCTION BaseNameOnly(FileName:STRING): STRING;
 VAR Dir:DirStr; Name:NameStr; Ext:ExtStr;
 BEGIN
   FSplit(FileName,Dir,Name,Ext);
   BaseNameOnly := Name;
 END;

 FUNCTION ExtOnly(FileName:STRING): STRING;
 VAR Dir:DirStr; Name:NameStr; Ext:ExtStr;
 BEGIN
   FSplit(FileName,Dir,Name,Ext);
   IF Pos('.', Ext) <> 0 THEN Delete(Ext,1,1);
   ExtOnly := Ext;
 END;


 { ---------- }
 { CONVERTORS }
 { ---------- }
 FUNCTION AddComas(This:LongInt): STRING;
 LABEL ConvertEnd;
 VAR S:STRING[14]; I,R,F:Byte;
 BEGIN
   Str(This,S);
   IF (This > -1000) AND (This < 1000) THEN GOTO ConvertEnd;
   R := 1;
   F := 2;
   IF This < 0 THEN F := 3;
   FOR I := Length(S) DOWNTO F DO
   BEGIN
     Inc(R);
     IF R = 4 THEN BEGIN
                     R := 1;
                     Insert(',',S,I);
                   END;
   END;
 ConvertEnd:
   AddComas := S;
 END;

 FUNCTION HexToDec(HexString:STRING): LongInt;
 VAR Index,Dummy:Byte; HexOfs,Result:LongInt;
 BEGIN
   HexOfs := 1;
   Result := 0;
   FOR Index := Length(HexString) DOWNTO 1 DO
   BEGIN
     FOR Dummy := 0 TO $0F DO
       IF UpCase(HexString[Index]) = HexChars[Dummy] THEN Break;
     Inc(Result,Dummy*HexOfs);
     HexOfs := HexOfs*16;
   END;
   HexToDec := Result;
 END;

 FUNCTION DecToHex(Number:Longint): STRING;
 VAR I:Integer; Ch:Char; Str:STRING; BitsToShift:Byte;
 BEGIN
   Str := '';
   IF Number <= 15 THEN BEGIN DecToHex := '0'+HEXChars[Number]; Exit END;
   FOR I := 7 DOWNTO 0 DO
   BEGIN
      BitsToShift := I*4;
      Ch  := HEXChars[(Number SHR BitsToShift) AND $0F];
      Str := Str + Ch;
   END;
   WHILE Str[1] = '0' DO Delete(Str,1,1);
   IF Odd(Length(Str)) THEN Str := '0'+Str;
   DecToHex := Str;
 END;

 FUNCTION PtrToHex(P:Pointer):STRING;
 VAR S,O:Word;
 BEGIN
   ASM
      MOV AX, Word(P)
      MOV DX, Word(P+2)
      MOV S, DX
      MOV O, AX
   END;
   PtrToHex := PadRight(DecToHex(S),4,'0')+':'+
               PadRight(DecToHex(O),4,'0');
 END;

 FUNCTION IntToStr(Number:Longint): STRING;
 VAR Temp:STRING;
 BEGIN
   Str(Number,Temp);
   IntToStr := Temp;
 END;

 FUNCTION StrToReal(Str:STRING): Real;
 VAR Code:Integer; Temp:Real;
 BEGIN
   IF Length(Str) = 0
    THEN StrToReal := 0
    ELSE
     BEGIN
       IF Copy(Str,1,1)='.' THEN Str:='0'+Str;
       IF (Copy(Str,1,1)='-') AND (Copy(Str,2,1)='.') THEN Insert('0',Str,2);
       IF Str[Length(Str)] = '.' THEN Delete(Str,Length(Str),1);
       Val(Str,Temp,Code);
       IF Code = 0
        THEN StrToReal := Temp
        ELSE StrToReal := 0;
     END;
 END;

 FUNCTION RealToStr(Number:Real; Decimals:Byte): STRING;
 VAR Temp:STRING;
 BEGIN
   Str(Number:20:Decimals,Temp);
   REPEAT
     IF Copy(Temp,1,1) = ' ' THEN Delete(Temp,1,1);
   UNTIL Copy(Temp,1,1) <> ' ';
   IF Decimals = Floating THEN
    BEGIN
      Temp := StripRight(Temp,'0');
      IF Temp[Length(Temp)] = '.' THEN Delete(Temp,Length(Temp),1);
    END;
   RealToStr := Temp;
 END;

 FUNCTION StrToInt(Str:STRING): Longint;
 VAR Code:Integer; Temp:Longint;
 BEGIN
   IF Length(Str) = 0
    THEN StrToInt := 0
    ELSE
     BEGIN
       Val(Str,Temp,Code);
       IF Code = 0
        THEN StrToInt := Temp
        ELSE StrToInt := 0;
     END;
 END;

 FUNCTION RealtoSciStr(Number:Real; D:Byte): STRING;
 CONST DamnNearUnity = 9.99999999E-01;
 VAR Temp:Real; Power:Integer; Value:STRING; Sign:Char;
 BEGIN
   IF Number = 1.0
    THEN RealToSciStr := '1.000'
    ELSE
     BEGIN
       Temp  := Number;
       Power := 0;
       IF Number > 1.0
        THEN
         BEGIN
           WHILE Temp >= 10.0 DO
           BEGIN
             Inc(Power);
             Temp := Temp/10.0;
           END;
           Sign := '+';
         END
        ELSE
         BEGIN
           WHILE Temp < DamnNearUnity DO
           BEGIN
             Inc(Power);
             Temp := Temp * 10.0;
           END;
           Sign := '-';
         END;
       Value := RealToStr(Temp,D);
       RealtoSciStr := Value+' E'+Sign+Padright(IntToStr(Power),2,'0');
     END;
 END;

{----------------------------------------------------------------------------}
{                                                                            }
{                              PRINTER ROUTINES                              }
{                                                                            }
{----------------------------------------------------------------------------}
 FUNCTION PrinterStatus: PrnStatus;
 VAR Regs: Registers;
 BEGIN
   WITH Regs DO
   BEGIN
     AH := 2;
     DX := 0;
     Intr($17,Regs);
     IF (AH AND $B8) = $90        THEN PrinterStatus := prnOK
       ELSE IF (AH AND $20) = $20 THEN PrinterStatus := prnNoPaper
       ELSE IF (AH AND $10) = $00 THEN PrinterStatus := prnOffLine
       ELSE IF (AH AND $80) = $00 THEN PrinterStatus := prnBusy
       ELSE IF (AH AND $08) = $08 THEN PrinterStatus := prnUnknown;
   END;
 END;

 FUNCTION PrinterReady: Boolean;
 BEGIN
   PrinterReady := (PrinterStatus = prnOK);
 END;

 PROCEDURE ResetPrinter(TimeToWait:Word);
 BEGIN
   ASM
     MOV  AH,1
     MOV  DX,0
     INT  17h
   END;
   Wait(TimeToWait);
 END;

{----------------------------------------------------------------------------}
{                                                                            }
{                                FILE ROUTINES                               }
{                                                                            }
{----------------------------------------------------------------------------}
CONST
  MaxFModes = 10;
  FModePTR  : Byte = 0;

VAR
  FileModes : ARRAY[1..MaxFModes] OF Byte;


 PROCEDURE SaveFilemode; ASSEMBLER;
 ASM
   CMP  FModePTR, MaxFModes
   JE   @Exit
   XOR  BX, BX
   MOV  BL, FModePTR
   MOV  DI, OFFSET FileModes
   MOV  AL, FileMode
   MOV  DS:[DI + BX], AL
   INC  FModePTR
  @Exit:
 END;

 PROCEDURE RestoreFilemode; ASSEMBLER;
 ASM
   CMP  FModePTR, 0
   JE   @Exit
   DEC  FModePTR
   XOR  BX, BX
   MOV  BL, FModePTR
   MOV  DI, OFFSET FileModes
   MOV  AL, DS:[DI + BX]
   MOV  FileMode, AL
  @Exit:
 END;

 PROCEDURE SetFileMode(ShareMethod:TShareMethod; AccessMethod:TAccessMethod);

  PROCEDURE SetMethod(A,B,C:Byte);
  BEGIN
    CASE AccessMethod OF
      AccessRead: FileMode := A;
     AccessWrite: FileMode := B;
 AccessReadWrite: FileMode := C;
    END;
  END;

 BEGIN
  IF ShareInstalled
    THEN BEGIN
           CASE ShareMethod OF
            Compatible: SetMethod(0,1,2);
              DenyBoth: SetMethod(16,17,18);
             DenyWrite: SetMethod(32,33,34);
              DenyRead: SetMethod(48,49,50);
              DenyNone: SetMethod(64,65,66);
           END;
         END
    ELSE SetMethod(0,1,2);
 END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

(*
 FUNCTION DosSeek(Handle:Word; Posn:LongInt; Func:byte): LongInt; ASSEMBLER;
 ASM
        MOV     AH, $42
        MOV     AL, Func
        MOV     BX, Handle
        MOV     DX, WORD PTR Posn
        MOV     CX, WORD PTR Posn+2
        INT     $21
        JNC     @End
        MOV     InOutRes, AX
        XOR     AX, AX
        XOR     DX, DX
 @End:
 END;*)

 PROCEDURE GetFileMode; ASSEMBLER;
 ASM
        CLC
        CMP    ES:[DI].TextRec.Mode, fmInput
        JE     @1
        MOV    [InOutRes], 104         { 'File not opened for reading' }
        XOR    AX, AX                  { Zero out function result }
        XOR    DX, DX
        STC
 @1:
 END;  { GetFileMode }


 FUNCTION TextFilePos(VAR F:Text): LongInt; ASSEMBLER;
 ASM
        LES    DI, f
        CALL   GetFileMode
        JC     @1

        XOR    CX, CX                  { Get position of file pointer }
        XOR    DX, DX
        MOV    BX, ES:[DI].TextRec.handle
        MOV    AX, 4201h
        INT    21h                     { offset := offset-BufEnd+BufPos }
        XOR    BX, BX
        SUB    AX, ES:[DI].TextRec.BufEnd
        SBB    DX, BX
        ADD    AX, ES:[DI].TextRec.BufPos
        ADC    DX, BX
 @1:
 END;  { TextFilePos }


 FUNCTION TextFileSize(VAR F:Text): LongInt; ASSEMBLER;
 ASM
        LES    DI, f
        CALL   GetFileMode
        JC     @1

        XOR    CX, CX                  { Get position of file pointer }
        XOR    DX, DX
        MOV    BX, ES:[DI].TextRec.handle
        MOV    AX, 4201h
        INT    21h
        PUSH   DX                      { Save current offset on the stack }
        PUSH   AX
        XOR    DX, DX                  { Move file pointer to EOF }
        MOV    AX, 4202h
        INT    21h
        POP    SI
        POP    CX
        PUSH   DX                      { Save EOF position }
        PUSH   AX
        MOV    DX, SI                  { Restore old offset }
        MOV    AX, 4200h
        INT    21h
        POP    AX                      { Return result}
        POP    DX
 @1:
 END;  { TextFileSize }


 PROCEDURE TextSeek(VAR F:Text; Pos:LongInt); ASSEMBLER;
 ASM
        LES    DI, f
        CALL   GetFileMode
        JC     @2

        MOV    CX, Word Ptr Pos+2        { Move file pointer }
        MOV    DX, Word Ptr Pos
        MOV    BX, ES:[DI].TextRec.Handle
        MOV    AX, 4200h
        INT    21h
        JNC    @1                      { Carry flag = reading past EOF }
        MOV    [InOutRes], AX
        JMP    @2

        { Force read next time }
 @1:    MOV    AX, ES:[DI].TextRec.BufEnd
        MOV    ES:[DI].TextRec.BufPos, AX
 @2:
 END;  { TextSeek }



 FUNCTION Exist(FileName:STRING): Boolean;
 VAR AFile: SearchRec;
 BEGIN
   FindFirst(FileName,AnyFile,AFile);
   Exist := (DOSError = 0);
 END;

 FUNCTION DirExist(Dir:STRING): Boolean;
 VAR fHandle:FILE; wAttr:Word;
 BEGIN
   WHILE Dir[Length(Dir)] = '\' DO Dec( Dir[0] );
   Dir := Dir + '\.';
   Assign( fHandle, Dir );
   GetFAttr( fHandle, wAttr );
   DirExist := ( (wAttr AND Directory) = Directory );
 END;


 FUNCTION MakeDir(Dir:STRING; ChangeDir:Boolean):Boolean;
 VAR Error:Boolean; OldDir:PathStr;

   PROCEDURE mDir(St:PathStr);
   VAR NS:PathStr; IOR:Word;
   BEGIN
       Error := False;
       {$I-}
         ChDir(St);
       {$I+}
       IF IOResult = 0 THEN Exit;
       {$I-}
         MkDir(St);
       {$I+}
       IOR := IOResult;
       IF IOR = 3 THEN
       BEGIN
         NS := ST;
         WHILE NS[Length(NS)] <> '\' DO Delete(NS,Length(NS),1);
         Delete(NS,Length(NS),1);
         mDir(NS);
         mDir(ST);
       END;
       IF ((IOR<>0) AND (IOR<>3)) THEN
       BEGIN
         Error := True;
         Exit;
       END;
   END;

 BEGIN
   Dir := FExpand(Dir);
   GetDir(0,OldDir);
   mDir(Dir);
   {$I-}
   IF NOT ChangeDir THEN ChDir(OldDir);
   {$I+}
   IF IOResult <> 0 THEN ;
   MakeDir := Error;
 END; {MakeDir}


 FUNCTION FindFile(VAR FileName:STRING):Boolean;
 BEGIN
   IF NOT Exist(FileName)
     THEN IF Exist(PathOnly(ParamStr(0))+FileName)
            THEN FileName := PathOnly(ParamStr(0))+FileName
            ELSE BEGIN
                   FileName := FSearch(FileName, GetEnv('PATH'));
                   IF FileName = '' THEN FileName := '+++';
                 END;
   FindFile := Exist(FileName);
 END;

 FUNCTION CopyFile(SourceFile,TargetFile:STRING): ShortInt;
 {Return codes:  0 successful
                 1 source and target the same
                 2 cannot open source
                 3 unable to create target
                 4 error during copy
                 5 not enough memory}
 TYPE
   HugeArray = ARRAY[0..65534] OF Char;

 VAR
   Source,Target: FILE;
   BRead, BWrite: Word;
   FileBuf      : ^HugeArray;

 BEGIN
   IF (MemAvail < 65536) THEN BEGIN CopyFile := 5; Exit; END;
   New(FileBuf);
   SaveFileMode;
   IF SourceFile = TargetFile
     THEN CopyFile := 1
     ELSE
     BEGIN
       SetFileMode(DenyWrite,AccessRead);
       Assign(Source,SourceFile);
       {$I-}
         Reset(Source,1);
       {$I+}
       IF IOResult <> 0
         THEN CopyFile := 2
         ELSE
         BEGIN
           SetFileMode(DenyRead,AccessWrite);
           Assign(Target,TargetFile);
           {$I-}
             Rewrite(Target,1);
           {$I+}
           IF IOResult <> 0
             THEN CopyFile := 3
             ELSE
             BEGIN
               {$I+}
               REPEAT
                 BlockRead(Source,FileBuf^,SizeOf(FileBuf^),BRead);
                 BlockWrite(Target,FileBuf^,BRead,BWrite);
               UNTIL (BRead = 0) or (BRead <> BWrite);
               Close(Source);
               Close(Target);
               {$I-}
               IF IOResult <> 0
                 THEN CopyFile := 4
                 ELSE IF BRead <> BWrite
                        THEN CopyFile := 4
                        ELSE CopyFile := 0;
             END;
         END;
     END;
   Dispose(FileBuf);
   RestoreFileMode;
 END;

 FUNCTION RenameFile(OldName,NewName:STRING): ShortInt;
 {Return codes: 0 file renamed
                1 file not found
                2 rename failed}
 VAR F: FILE;
 BEGIN
   IF NOT Exist(OldName)
     THEN RenameFile := 1
     ELSE
     BEGIN
       Assign(F,OldName);
       {$I-}
        Rename(F,NewName);
       {$I+}
       IF IOResult = 0
         THEN RenameFile := 0
         ELSE RenameFile := 2;
     END;
 END;

 FUNCTION DeleteFile(FileName:STRING): ShortInt;
 {Return codes: -1 File not found
                 0 File deleted
                 1 Error - file not deleted}
 VAR F: FILE;
 BEGIN
   IF NOT Exist(FileName)
     THEN DeleteFile := -1
     ELSE
     BEGIN
       Assign(F,FileName);
       {$I-}
         Erase(F);
       {$I+}
       IF IOResult = 0
         THEN DeleteFile := 0
         ELSE DeleteFile := 1;
     END;
 END;

 FUNCTION FSize(FileName:STRING): LongInt;
 { Returns -1 if file not found }
 VAR F: FILE OF Byte;
 BEGIN
   SaveFileMode;
   SetFileMode(DenyNone,AccessRead);
   Assign(F,FileName);
   {$I-}
     Reset(F);
   {$I+}
   IF IOResult <> 0 THEN
   BEGIN
     FSize := -1;
     Exit;
   END;
   FSize := FileSize(F);
   Close(F);
   RestoreFileMode;
 END;



{----------------------------------------------------------------------------}
{                                                                            }
{                               TIMING FUNCTIONS                             }
{                                                                            }
{----------------------------------------------------------------------------}
VAR
   StartW : Word;
   StartM : LongInt;
   StopW  : Word;
   StopM  : LongInt;

PROCEDURE StartTimer; ASSEMBLER;
ASM
        IN      AL, 40h
        MOV     AH, AL
        IN      AL, 40h
        XCHG    AH, AL
        MOV     Word PTR StartW , AX
        MOV     BX, 40h
        MOV     ES, BX
        MOV     BX, 6Ch
        MOV     AX, ES:[BX]
        MOV     Word PTR StartM, AX
        MOV     AX, ES:[BX+2]
        MOV     Word PTR StartM+2, AX
END;

FUNCTION StopTimer: Real;
BEGIN
  ASM
        IN      AL, 40h
        MOV     AH, AL
        IN      AL, 40h
        XCHG    AH, AL
        MOV     Word PTR StopW, AX
        MOV     BX, 40h
        MOV     ES, BX
        MOV     BX, 6Ch
        MOV     AX, ES:[BX]
        MOV     Word PTR StopM, AX
        MOV     AX, ES:[BX+2]
        MOV     Word PTR StopM+2, AX
  END;
  IF StartM <= StopM
    THEN StopM:=StopM-StartM
    ELSE StopM:=1572480-StartM+StopM;
  IF StartW <= StopW
    THEN StopW:=StopW-StartW
    ELSE StopW:=65535-StartW+StopW;
  StopTimer := (Stopm*65535+StopW) / 1193181.667;
END;


FUNCTION GetTimerStr(TimerCount:Real):STRING;
BEGIN
  GetTimerStr := RealToStr(TimerCount,2);
END;




{----------------------------------------------------------------------------}
{                                                                            }
{                              STARTING ROUTINES                             }
{                                                                            }
{----------------------------------------------------------------------------}
 PROCEDURE ShrinkHeap;
 VAR Reg:Registers;
 BEGIN
 {$IFNDEF DPMI}
   Reg.BX := MemW[Seg(HeapPtr):Ofs(HeapPtr)+2]-PrefixSeg;
   Reg.ES := PrefixSeg;
   Reg.AH := $4A;
   Intr($21, Reg);
 {$ENDIF}
 END;

 PROCEDURE ExpandHeap;
 VAR Reg:Registers;
 BEGIN
 {$IFNDEF DPMI}
   Reg.BX := MemW[Seg(HeapEnd):Ofs(HeapEnd)+2]-PrefixSeg;
   Reg.ES := PrefixSeg;
   Reg.AH := $4A;
   Intr($21, Reg);
 {$ENDIF}
 END;

 FUNCTION RunEXECOM(ProgName,Params:STRING): Integer;
 BEGIN
   ShrinkHeap;
   SwapVectors;
   Exec(Progname,Params);
   SwapVectors;
   ExpandHeap;
   RunEXECOM := DOSError;
 END;

 FUNCTION RunAnything(Command:STRING): Integer;
 BEGIN
   ShrinkHeap;
   SwapVectors;
   Exec(GetEnv('COMSPEC'),'/C '+Command);
   SwapVectors;
   ExpandHeap;
   RunAnything := DOSError;
 END;

 FUNCTION ShellToDOS: Integer;
 BEGIN
   ShrinkHeap;
   SwapVectors;
   Exec(GetEnv('COMSPEC'),'');
   SwapVectors;
   ExpandHeap;
   ShellToDOS := DOSError;
 END;




{---------------------------------------------------------------------------}
{                                                                           }
{                             INIT MULTITASKING                             }
{                                                                           }
{---------------------------------------------------------------------------}
 PROCEDURE InitMultiTasking; ASSEMBLER;
 ASM
   MOV   AH, 30h
   MOV   AL, 01h
   INT   21h
   CMP   Al, 20
   JE    @_OS2

   MOV   AX, 160Ah
   INT   2Fh
   CMP   AX, 0
   JE    @_Windows

   MOV   AX, 2B01h
   MOV   CX, 4445h
   MOV   DX, 5351h
   INT   21h
   CMP   AL, $FF
   JNE   @_DESQview

   MOV   AX, 1022h
   MOV   BX, 0000h
   INT   15h
   CMP   BX, 0
   JNE   @_TOPview

   MOV  AX, 0E400h
   INT  21h
   CMP  AL, 0
   JNE  @_DoubleDOS

   JMP   @End
 @_Windows:
   MOV   Tasker.OS, Windows
   MOV   Tasker.Version, BX
   JMP   @End
 @_OS2:
   MOV   Tasker.OS, OS2
   MOV   BH, AH
   XOR   AH, AH
   MOV   CL, 10
   DIV   CL
   MOV   AH, BH
   XCHG  AH, AL
   MOV   Tasker.Version, AX
   JMP   @End
 @_DESQview:
   MOV   Tasker.Version, BX
   MOV   Tasker.OS, DesQView
   JMP   @End
 @_TopView:
   MOV   AX, 1022h
   XOR   BX, BX
   INT   15h
   MOV   Tasker.Version, BX
   MOV   Tasker.OS, TopView
   JMP   @End
 @_DoubleDOS:
   MOV   AX, 1022h
   XOR   BX, BX
   INT   15h
   MOV   Tasker.Version, BX
   MOV   Tasker.OS, DoubleDOS
 @End:
 END;


 PROCEDURE GiveUpTimeSlice; ASSEMBLER;
 ASM
   CMP  Tasker.OS, NoTasker
   JE   @MSDos
   CMP  Tasker.OS, Windows
   JE   @Win_OS2
   CMP  Tasker.OS, OS2
   JE   @Win_OS2
   CMP  Tasker.OS, DoubleDOS
   JE   @DblDOS
 @DV_TV:
   MOV  AX, 1000h
   INT  15h
   JMP  @End
 @Win_OS2:
   MOV  AX, 1680h
   INT  2Fh
   JMP  @End
 @DblDOS:
   MOV  AX, 0EE01h
   INT  21h
 @MSDos:
   INT  28h
 @End:
 END;




{============================================================================}
{                                                                            }
{                              INITIALIZING UNIT                             }
{                                                                            }
{============================================================================}
BEGIN
  ASM
        MOV     ES, Seg0040
        MOV     AL, BYTE PTR ES:[$49] { CurrentMode }
        MOV     StartMode, AL
        MOV     CheckSnow, False
        MOV     BX, SegB800
        MOV     BaseOfScreen, BX
        CMP     AL, Mono
        JE      @MonoSystem
 @ColorSystem:
        MOV     AX, $1200
        MOV     BL, $10
        MOV     CX, $FFFF
        INT     $10
        CMP     CX, $FFFF       { EGA Test }
        JNE     @EndInit
        MOV     CheckSnow, True
        JMP     @EndInit
 @MonoSystem:
        MOV     BX, SegB000
        MOV     BaseOfScreen, BX
 @EndInit:
        MOV     AX, BaseOfScreen
        MOV     VSeg, AX
        MOV     VOfs, 0
 END;
END.
