{$A+,B-,E-,F+,I-,L-,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ Copyright (C) 1995-96 By The GodFather }

UNIT GFDialog;


INTERFACE


USES Dos,
     GUtils, GMemory, GList_o, GButtons;

VAR
  FileDialogName: STRING;

FUNCTION FileDialog(aWildCard,aName: STRING): Boolean;

IMPLEMENTATION

VAR UpY: Byte;

{---------------------------------------------------------------------------}
{-- FILE DIALOG BOX --------------------------------------------------------}
{---------------------------------------------------------------------------}
TYPE
  String12   = STRING[12];
  PFRec       = ^TFRec;
  TFRec       = OBJECT(TObject)
    Name      : String12;
    Size      : LongInt;
    Time      : LongInt;
    Dir       : Boolean;
    CONSTRUCTOR Init(aName:String12; aSize:LongInt;
                     aTime:LongInt;  aDir :Boolean);
  END;

VAR
  OrigDir,
  CurrDir,
  WildCard: STRING;
  FileList: PList;
  Files   : PCollection;
  aFile   : PFRec;
  NormExit: Boolean;

PROCEDURE __Watch(Position:Integer);
BEGIN
  FastWrite(21,UpY+14,$57,CurrDir+Replicate(38-Length(CurrDir),' '));
END;

FUNCTION FormatFName(FName: String12): String12;
VAR PPos,FL: Byte; TempS: String12; Ch: Char;
BEGIN
  Ch   := ' ';
  FL   := Length(FName);
  PPos := Pos('.',FName);
  IF (FName[1] = '.') OR
     (PPos     = 0  )
     THEN BEGIN
            FormatFName := PadLeft(FName,12,' ');
            Exit
          END;
  FormatFName := PadLeft(BaseNameOnly(FName),8,' ')+' '+
                 PadLeft(ExtOnly(FName),3,' ');
END;

FUNCTION __GetFile(Position:Integer):STRING;
VAR Entry:PFRec; Dt:DateTime; S: STRING;

  FUNCTION Az(This:Word): STRING;
  VAR S: STRING[30];
  BEGIN
    S := AddComas{Convert}(This);
    IF Length(S) = 1 THEN S := '0' + S;
    Az := S;
  END;

BEGIN
  Entry := Files^.At(Position-1);
  WITH Entry^ DO
    IF Dir
      THEN  S := ' '+FormatFName(Name)
      ELSE BEGIN
             S := ' '+FormatFName(Name)+PadRight(AddComas{Convert}(Size),11,' ');
             UnpackTime(Time, DT);
             WITH DT DO S := S + '  '+Az(Day)+'-'+Az(Month)+'-'+Az(Year-1900)+
                                 '  '+Az(Hour)+':'+Az(Min);
           END;
  __GetFile := S;
END;

CONSTRUCTOR TFRec.Init(aName:String12; aSize:LongInt; aTime:LongInt; aDir:Boolean);
BEGIN
  Name := aName;
  Size := aSize;
  Time := aTime;
  Dir  := aDir;
END;

PROCEDURE ReadFiles;
VAR Dir: SearchRec; Where: STRING;
BEGIN
  IF Length(CurrDir) = 3
    THEN Where := CurrDir
    ELSE Where := CurrDir + '\';
  New(Files,Init(1,1));
  FindFirst(Where+WildCard,AnyFile AND NOT (VolumeID OR
                                            Hidden   OR
                                            SysFile  OR
                                            ReadOnly OR
                                            Directory), Dir);
  WHILE DosError = 0 DO
  BEGIN
    WITH Dir DO Files^.Insert(New(PFRec,Init(Name,Size,Time,False)));
    FindNext(Dir);
  END;
  FindFirst(Where+'*.*',Directory, Dir);
  WHILE DosError = 0 DO
  BEGIN
    WITH Dir DO
      IF (Name <> '.') AND
         (Name <> '..') AND
         (Attr = Directory)
         THEN Files^.Insert(New(PFRec,Init(Name,Size,Time,True)));
    FindNext(Dir);
  END;
  IF Length(Where) > 3 THEN Files^.Insert(New(PFRec,Init('..',0,0,True)));
  IF Files^.Count  = 0 THEN Files^.Insert(New(PFRec,Init('No files',0,0,True)));
END;

PROCEDURE NewDir;
BEGIN
  Dispose(Files,Done);
  ReadFiles;
  FileList^.Position := 1;
  FileList^.MaxTopics   := Files^.Count;
  FileList^.Lines       := 9;
  FileList^.MaxLines    := 9;
  ReDrawList(FileList);
END;

PROCEDURE ChDrive;
LABEL Quit;
VAR OK: Boolean; Key: Word; Tmp: STRING;
BEGIN
  Cursor(On);
  MkWin(20,UpY+6,42,4,$4C,Special2,'');
  FastWrite(29,UpY+8,$4E,'Enter new drive letter: [ ]');
  FastWrite(54,UpY+8,$4F,CurrDir[1]);
  PosCursor(54,UpY+8);
  Tmp     := '!';
  ClearKBuffer;
  Key     := Ord( UpCase(Chr(GetKey)) );
  IF (Chr(Key) = CurrDir[1]) THEN GOTO Quit;
  IF (Chr(Key) >= 'A') AND (Chr(Key) <= 'Z') THEN Tmp := Chr(Key)+':\';
  FastWrite(54,UpY+8,$4F,Tmp[1]);
  {$I-} ChDir(Tmp); {$I+}
  IF IOResult = 0 THEN
  BEGIN
    RmWin;
    Cursor(Off);
    PosCursor(80,MaxY);
    CurrDir := Tmp;
    NewDir; Exit;
  END;
Quit:
  RmWin;
  Cursor(Off);
  PosCursor(80,MaxY);
END;

PROCEDURE ExitDir;
VAR TMP: STRING; I: Byte; CH: Char;
BEGIN
  TMP := CurrDir;
  IF Length(TMP) > 3 THEN
  BEGIN
    WHILE TRUE DO
    BEGIN
      Ch := TMP[Length(TMP)];
      Delete(TMP,Length(TMP),1);
      IF Ch = '\' THEN Break;
    END;
    IF Length(TMP) = 2 THEN TMP := TMP + '\';
    ChDir(TMP);
    CurrDir := TMP;
    NewDir;
  END;
END;

PROCEDURE EnterDir;
VAR TMP: STRING;
BEGIN
   TMP := aFile^.Name;
   IF (TMP = '..') THEN ExitDir;
   IF Length(CurrDir) = 3
     THEN CurrDir := CurrDir +      TMP
     ELSE CurrDir := CurrDir + '\'+ TMP;
   ChDir(CurrDir);
   NewDir;
END;

PROCEDURE DoIT;
BEGIN
  WITH aFile^ DO
  BEGIN
    IF Name = 'No files' THEN Exit;
    IF Name = '..'
      THEN ExitDir
      ELSE IF Dir THEN EnterDir
                  ELSE BEGIN
                         IF Length(CurrDir) = 3
                           THEN FileDialogName := CurrDir +      Name
                           ELSE FileDialogName := CurrDir + '\'+ Name;
                         FileList^.EndOfList := True;
                         NormExit            := True;
                       END;
  END;
END;

PROCEDURE __ProcessKey(Position:Integer; VAR Key:Word);
VAR T: STRING;
BEGIN
  aFile := Files^.At(Position-1);
  CASE Key OF
    kbEnter,
    43{PLUS} : DoIT;
    45{MINUS}: ExitDir;
    kbF9     : BEGIN
                 {$I-} ChDir(OrigDir); {$I+}
                 IF IOResult = 0 THEN
                 BEGIN
                   CurrDir := OrigDir;
                   NewDir;
                 END;
               END;
    kbF10    : ChDrive;
    kbEsc    : BEGIN NormExit := False; FileList^.EndOfList := True; END;
  END;
END;

FUNCTION FileDialog(aWildCard,aName: STRING): Boolean;
BEGIN
  GetDir(0,OrigDir);
  CurrDir  := FExpand(OrigDir);
  WildCard := AdjCase(Upper,aWildCard);
  NormExit := True;
  ReadFiles;
  InitList(FileList);
  UpY := MaxY DIV 2 - 7;
  MkWin(17,UpY,49,18,$5D,Single1,'');
  WriteBetween(1,80,UpY,$5F,aName);
  FastWrite(22,UpY+16,$5F,'F9');  FastWrite(25,UpY+16,$5E,'Return to begining');
  FastWrite(46,UpY+16,$5F,'F10'); FastWrite(50,UpY+16,$5E,'Change drive');
  FastWrite(21,UpY+2,$07,'[ '+WildCard+Replicate(38-Length(WildCard),' ')+' ]');
  WITH FileList^ DO
  BEGIN
    XPos      := 21;
    YPos      := UpY + 4;
    Lines     := 9;
    BarSize   := 42;
    MaxTopics := Files^.Count;
    GetString := __GetFile;
    CheckKey  := __ProcessKey;
    MiscProc  := __Watch;
  END;
  ShowList(FileList);
  DoneList(FileList);
  Dispose(Files, Done);
  RmWin;
  FileDialog := NormExit;
  {$I-} ChDir(OrigDir); {$I+}
END;

END.